<%
/***************************************************************************************************
*               PAGE DESCRIPTION
****************************************************************************************************
*
*               NAME:           acceptProposition.jsp
*               LANGUAGE:       JSP
*               DATE:           10.4.2002
*               AUTHOR:         Minna Hillebrand, University of Jyvskyl (JYU)
*               PURPOSE:        Page show's details of a proposed subject and offers
*                               posibility to accept the proposition to a subject. 
*                               The user can send email to the proposer to ask more 
*                               details about the proposition.    
*
****************************************************************************************************
*               COPYRIGHT (C) KOPPELO PROJECT GROUP
*               Limited rights granted. Please refer to GNU General Public License
*               http://www.gnu.org/licenses/gpl.html
****************************************************************************************************

****************************************************************************************************
*               UPDATES
****************************************************************************************************
*               24.4.2002 
*                  Variables canAccept and canUpdate tell if the user can
*                  maintain the details. If both are false, the user is 
*                  redirected to error page (has no access to this page)
*
*               25.4.2002 M. Ylitalo
*                  Lines and Types are selected and keywords appear properly 
****************************************************************************************************/
%>

<%
  if (request.getParameter("origid") == null) {
    response.sendRedirect("errorProposeAccept.jsp?origid=bad");
    return;
  }   
  int origID = Integer.parseInt(request.getParameter("origid"));   
  int proposedBy = -1;
%>

<%@ include file="/shared/beans.inc" %>
<%@ include file="/shared/constants.inc" %>
<%@ include file="/shared/dbconnect.inc" %>


<%-- Access right --%>

<% police.setDB(db);

   boolean canAccept = false; 
   boolean canUpdate = false;

   if ( police.hasPersonRightOriginal(allowPropAccept, personID, origID) ||
        police.hasGroupRight(allowPropAccept, userAccessLevel) ) {
     canAccept = true;
     canUpdate = true;
   }
%>


<sql:statement id="stmt3" conn="conn2">
  <sql:query>
    select assignmentoriginal.proposedby as proposedby
    from  assignmentoriginal 
    where assignmentoriginal.deleted = false
    and   assignmentoriginal.originalid = <%=origID%>;
  </sql:query>
  <sql:resultSet id="rset3">
    <sql:getColumn colName="proposedby" to="proposedby" scope="page"/>
    <%
    {  proposedBy = Integer.parseInt((String)pageContext.getAttribute("proposedby"));
       if (proposedBy == personID)  canUpdate = true; 
    }
    %>
  </sql:resultSet>
</sql:statement>

<%
   if ( !canAccept && !canUpdate ) {              // if both are false then redirect
    response.sendRedirect("assignmentOriginalInfo.jsp?origid="+origID); 
    return;
   }

%>


<%@ include file="/shared/header.inc" %>
<%@ include file="/shared/menus.inc" %>


<% time timeformater = new time(); %>

<h3><t:Tr>Aihe-ehdotuksen <% if (canAccept) { %> hyvksyminen ja <% } %> tietojen muuttaminen</t:Tr></h3>

<%--
<p><t:Tr>
Seuraavissa kentiss on aiheen ehdottajan syttmt arvot. Voit muuttaa annettuja 
arvoja, joilloin pivitetyt tiedot tallennetaan kantaan.
</t:Tr></p>
--%>

<%
  if (request.getParameter("info") != null) {
%>
  <h4><t:Tr>Tiedot tallennettu</t:Tr></h4>
<% } %>


<form action="acceptPropositionInsert.jsp" method="post">
<input type="hidden" name="origid" value="<%=origID%>" />

<table>

<%-- TITLE --%>
<sql:statement id="stmt6" conn="conn2">
  <sql:query>
   select assdetailtranslation.name as name,
          descriptiontypetranslation.name as type,
          assignmentdetail.detailid as id
   from   assdetailtranslation, descriptiontypetranslation 
   where  assoriginalreldetail.originalid = <%=origID%>
   and    assoriginalreldetail.detailid = assignmentdetail.detailid
   and    assignmentdetail.typeid = <%=titleID%> 
   and    assdetailtranslation.detailid = assignmentdetail.detailid
   and    assdetailtranslation.languageid = <%=languageID%>
   and    descriptiontypetranslation.descriptiontypeid = <%=titleID%>
   and    descriptiontypetranslation.languageid = <%=languageID%>;
  </sql:query>
  <sql:resultSet id="rset6">
    <tr>
        <td><strong><sql:getColumn colName="type" /></strong></td>
        <td><input type="text" name="title" size="49"
             value="<sql:getColumn colName="name" />" /></td>        
    </tr> 
  </sql:resultSet>
</sql:statement>

<%-- We can't use any loop because we need to know exactly witch type of result 
     we get e.g. title, description, url... to insert inputbox or textarea  --%>

<%-- DESCRIPTION --%> 
<sql:statement id="stmt3" conn="conn2">

  <sql:query>
   select assdetailtranslation.name as name,
          descriptiontypetranslation.name as type,
          assignmentdetail.detailid as id
   from  assoriginalreldetail, assignmentdetail, assdetailtranslation, descriptiontypetranslation 
   where assoriginalreldetail.originalid = <%=origID%>
   and   assoriginalreldetail.detailid = assignmentdetail.detailid
   and   assignmentdetail.typeid = <%=descriptionID%> 
   and   assdetailtranslation.detailid = assignmentdetail.detailid
   and   assdetailtranslation.languageid = 2
   and   descriptiontypetranslation.descriptiontypeid = <%=descriptionID%>
   and   descriptiontypetranslation.languageid = 2;
  </sql:query>
  <sql:resultSet id="rset7">
    <tr>
        <td valign="top"><strong><sql:getColumn colName="type" /></strong></td>
        <td><textarea name="description" rows="8" 
             cols="50"><sql:getColumn colName="name" /></textarea></td>
    </tr> 
  </sql:resultSet>

</sql:statement>

 


<%-- Markon jutut  --%>

<% Vector vKeywords= new Vector(); %>

<sql:statement id="stmt8" conn="conn2">
  <sql:query>
select asskeywordtranslation.name as name 
from   assoriginalrelkeyword , asskeywordtranslation , assignmentkeyword  
where  assoriginalrelkeyword.deleted = false
and    assoriginalrelkeyword.originalid = <%=origID%>
and    assoriginalrelkeyword.keywordid = assignmentkeyword.keywordid
and    assignmentkeyword.deleted = false
and    assignmentkeyword.keywordid = asskeywordtranslation.keywordid
and    asskeywordtranslation.languageid = <%=languageID%> ;
  </sql:query>


  <sql:resultSet id="rset8">
    <sql:getColumn colName="name" to="keyword" scope="page"/>
    <%  vKeywords.addElement(pageContext.getAttribute("keyword")); %>
  </sql:resultSet>


</sql:statement>

</td>
</tr>


<%

int i=0;
String apu="";

if (!vKeywords.isEmpty()) {      //check is there keywords....
  apu = (String)vKeywords.get(0);

  for (i=1;i < vKeywords.size() ; i++)
    apu = apu + ", " + vKeywords.get(i);
}
%>      
    <tr>
      <td><label for="keywords"><strong><t:Tr>Avainsanat </t:Tr></strong></label></td>
      <td><input id="keywords" type="text" name="keywords" value="<%=apu%>" size="49" /></td>
    </tr>


<sql:statement id="stmt9" conn="conn2">
  <sql:query>
     select assignmentoriginal.proposeddate as pdate,
            person.lastname || ' ' || person.firstnames as proposer
     where  assignmentoriginal.originalid = <%=origID%>
     and    assignmentoriginal.deleted = false
     and    assignmentoriginal.proposedby = person.personid
  </sql:query>
  <sql:resultSet id="rset9">
  <tr>
    <td><strong><t:Tr>Ehdotettu </t:Tr></strong></td>
    <td><sql:getDate colName="pdate" to="pdate" /><%=timeformater.monthToOutFormat((String)pageContext.getAttribute("pdate"))%></td> 
  </tr>
  <tr>
    <td><strong><t:Tr>Ehdottaja </t:Tr></strong></td>
    <td><sql:getColumn colName="proposer" /></td> 
  </tr>
  </sql:resultSet>
</sql:statement>





<%-- Markon jutut  --%>

      <sql:statement id="stmt2" conn="conn2">
        <sql:query>
          select assignmentoriginal.validuntil as validuntil
          from assignmentoriginal
          where assignmentoriginal.originalid = <%=origID%>
          and assignmentoriginal.deleted = false;
        </sql:query>
        <sql:resultSet id="rset2">
          <sql:getColumn colName="validuntil" to="validuntil" scope="page" />
        </sql:resultSet>
      </sql:statement>
<% String validUntil = (String)pageContext.getAttribute("validuntil"); %>
    <tr>
      <td><label for="validuntil"><strong><t:Tr>Aihe voimassa </t:Tr></strong></label></td>
      <td><input type="text" name="validuntil" id="validuntil" size="12" value="<%=timeformater.monthToOutFormat(validUntil)%>" /> saakka</td>
    </tr>

</table>

<%-- <input type="hidden" name="oldkeywords" value="<%=apu%>" /> --%>


<table>
   <tr>
      <td><strong><t:Tr>Opinnytteen tyyppi</t:Tr><strong></td>
      <td><strong><t:Tr>&nbsp;&nbsp;&nbsp;</t:Tr><strong></td>
      <td><strong><t:Tr>Opinnytteen linja</t:Tr><strong></td>
   </tr>

    <tr>
       
<%
    // Select first only selected types    

    Vector vTypes = new Vector(); 
%>

      <%-- all study types and ids --%>
      <td><select multiple name="type" id="studytype" size="6">
      <sql:statement id="stmt5" conn="conn2">
        <sql:query>
          select assignmenttype.typeid as type,
                 asstypetranslation.name as name   
          from   assignmenttype, asstypetranslation
          where  assignmenttype.deleted = false


<%--          and    assignment.assignmentid = assoriginalpostype.typeid --%>
          and    assoriginalpostype.originalid = <%=origID%>
          and    assoriginalpostype.typeid = assignmenttype.typeid  
          and    assoriginalpostype.deleted = false

          and    assignmenttype.typeid = asstypetranslation.typeid
          and    asstypetranslation.deleted = false  
          and    asstypetranslation.languageid = <%=languageID%>; 
          
        </sql:query>
        <sql:resultSet id="rset5" loop="true">
          <sql:getColumn colName="type" to="type" />
          <option selected="selected" value="<sql:getColumn colName="type" />">
                                  <sql:getColumn colName="name" />
          </option>
<%        vTypes.add((String)pageContext.getAttribute("type"));     // store all selected typeIDs
%>
        </sql:resultSet>
      </sql:statement>



      <sql:statement id="stmt11" conn="conn2">
        <sql:query>
          select assignmenttype.typeid as type,
                 asstypetranslation.name as name
          from   assignmenttype, asstypetranslation
          where  assignmenttype.deleted = false
          and    assignmenttype.typeid = asstypetranslation.typeid
          and    asstypetranslation.deleted = false
          and    asstypetranslation.languageid = <%=languageID%>;
      
        </sql:query>
        <sql:resultSet id="rset11" loop="true">
        <sql:getColumn colName="type" to="type" />

<%      int f = 0;                                                 // add only nonselected types
        try {
             String nakki = (String)pageContext.getAttribute("type");
             if ( nakki != null ) {
               if ( vTypes.indexOf(nakki) > -1  )
                 f++;
             }
           
        } catch (Exception e) { System.out.println( e.getClass().getName() + ":" + e.getMessage() ); 
}

         if ( f==0 ) {
%>
            <option value="<sql:getColumn colName="type" />">
                           <sql:getColumn colName="name" />
            </option>

<%        }
%>
        </sql:resultSet>
      </sql:statement>

      </select></td>


    <td></td>

<% 
  // Select first only selected lines

  Vector vLines= new Vector(); 
  boolean firstResult=true;
%>

      <td><select multiple name="line" id="studyline" size="6">
      <%-- all study lines and ids --%>
      <sql:statement id="stmt4" conn="conn2">
        <sql:query>

          select studyline.lineid as line,
                 studylinetranslation.name as name 
          from   studyline, studylinetranslation   
          where  studyline.deleted = false
          and    studyline.lineid = studylinetranslation.lineid
          
          and    studyline.lineid = assoriginalposline.lineid 
          and    assoriginalposline.originalid = <%=origID%> 
          and    assoriginalposline.deleted = false
          
          and    studylinetranslation.deleted = false
          and    studylinetranslation.languageid = <%=languageID%>;
                    

        </sql:query>
        <sql:resultSet id="rset4" loop="true">
          <sql:getColumn colName="line" to="line" />
          <% if ( pageContext.getAttribute("line") != null && firstResult == true ) { %> 
          <option value="null">ei linjaa</option>  
          <%   firstResult = false; } %>
          <option selected="selected" value="<sql:getColumn colName="line" />">
                         <sql:getColumn colName="name" />
          </option>
<%
        vLines.addElement((String)pageContext.getAttribute("line"));   // store all selected lineIDs
%>
        </sql:resultSet>
      </sql:statement>

<% if (firstResult)  { %>
          <option selected="selected" value="null">ei linjaa</option>  
<% } %>       

      <sql:statement id="stmt10" conn="conn2">

        <sql:query>
          select distinct studyline.lineid as line,
                 studylinetranslation.name as name
          from   studyline, studylinetranslation
          where  studyline.deleted = false
          and    studyline.lineid = studylinetranslation.lineid
          and    studylinetranslation.deleted = false
          and    studylinetranslation.languageid = <%=languageID%>;

          
        </sql:query>
        <sql:resultSet id="rset10" loop="true">
        <sql:getColumn colName="line" to="line" />


<%       int f = 0;                                               // add only nonselected lines
         try { 
           String nakki = (String)pageContext.getAttribute("line");
           if ( nakki != null ) {
             if ( vLines.indexOf(nakki) > -1  ) 
               f++;
           }
         }  catch (Exception e) { System.out.println(e.getClass().getName() + ":" + e.getMessage() );}


         if ( f==0 ) { 
%>
           <option value="<sql:getColumn colName="line" />">
                          <sql:getColumn colName="name" />
          </option>
<%       }      
%>
        </sql:resultSet>
      </sql:statement>

      </select></td>


    </tr>


<% /* Box to send email. */ %>

<% if (canAccept) { %>
    <tr>
      <td colspan="3"><t:Tr>Kirjoita shkpostiviesti aiheen ehdottajalle</t:Tr></td>
    </tr>
    <tr>
      <td colspan="3"><textarea name="message" cols="50" rows="6"></textarea></td>
    </tr>

<sql:statement id="stmt8" conn="conn2">
  <sql:query>
    select distinct personparametervalue as address
    from   personparameter
    where  personparameter.personparametertypeid = 3
    and    personparameter.personid = <%=personID%>
  </sql:query>
  <sql:resultSet id="rset8">
    <input type="hidden" name="sender"   value="<sql:getColumn colName="address"/>" />
  </sql:resultSet>
</sql:statement>          


<sql:statement id="stmt9" conn="conn2">
  <sql:query>
    select distinct personparametervalue as to
    from   personparameter
    where  personparameter.personparametertypeid = 3
    and    personparameter.personid = <%=proposedBy%>
  </sql:query>
  <sql:resultSet id="rset9">
    <input type="hidden" name="to"   value="<sql:getColumn colName="to"/>" />
  </sql:resultSet>
</sql:statement>

      
<% } %>
</table>



<%-- <input type="hidden" name="oldkeywords" value="<%=apu%>" /> --%>



<input type="submit" name="update" value="<t:Tr>Tallenna muutokset</t:Tr>" />

<% if (canAccept) { %>
&nbsp;&nbsp;<input type="submit" name="email" value="<t:Tr>Pyyd listietoja</t:Tr>" />
&nbsp;&nbsp;<input type="submit" name="fail" value="<t:Tr>Hylk aihe-ehdotus</t:Tr>" />
&nbsp;&nbsp;<input type="submit" name="accept" value="<t:Tr>Hyvksy aiheeksi</t:Tr>" />
<% } %>

</form>



<%@ include file="/shared/pageEnd.inc" %>



