<% 
/***************************************************************************************************
*               PAGE DESCRIPTION
****************************************************************************************************
*
*               NAME:           acceptPropositionInsert.jsp
*               LANGUAGE:       JSP
*               DATE:           11.4.2002
*               AUTHOR:         Minna Hillebrand, University of Jyvskyl (JYU)
*               PURPOSE:        Update values or insert some fields
*
****************************************************************************************************
*               COPYRIGHT (C) KOPPELO PROJECT GROUP
*               Limited rights granted. Please refer to GNU General Public License
*               http://www.gnu.org/licenses/gpl.html
****************************************************************************************************

****************************************************************************************************
*               UPDATES
****************************************************************************************************
*                
*      17.5.2002 M.Ylitalo
*            - Added sendmail to proposer                
*
****************************************************************************************************/
%>


<%@ include file="/shared/beans.inc" %>
<%@ include file="/shared/constants.inc" %>
<%@ include file="/shared/dbconnect.inc" %>


<%
  /* Check the parameters */

  if (request.getParameter("origid") == null) {
    response.sendRedirect("errorAcceptPropInsert.jsp?orig=bad");
    return;
  }   
  int origID = Integer.parseInt(request.getParameter("origid")); 

  time timeformater = new time(); 
%>

<%--   Check the user --%>

<%

 police.setDB(db);

   boolean canAccept = false; 
   boolean canUpdate = false;

   if ( police.hasPersonRightOriginal(allowPropAccept, personID, origID) ||
        police.hasGroupRight(allowPropAccept, userAccessLevel) ) {
     canAccept = true;
     canUpdate = true;
   }

%>


<sql:statement id="stmt7" conn="conn2">
  <sql:query>
    select assignmentoriginal.proposedby as proposedby
    from  assignmentoriginal 
    where assignmentoriginal.deleted = false
    and   assignmentoriginal.originalid = <%=origID%>;
  </sql:query>
  <sql:resultSet id="rset7">
    <sql:getColumn colName="proposedby" to="proposedby" scope="page"/>
    <%
    {  int proposedBy = Integer.parseInt((String)pageContext.getAttribute("proposedby"));
       if (proposedBy == personID)  canUpdate = true; 
    }
    %>
  </sql:resultSet>
</sql:statement>

<%
   if ( !canAccept && !canUpdate ) {            // if both are false then redirect
    response.sendRedirect("errorNoAccess.jsp"); 
    return;
   }

%>


<%-- ---end of user check---------------------------------------- --%>

<%-- parameter check -------------------------------------------- --%>

<%
  String title;
  if (request.getParameter("title") == null) title="";
  else title = (String)request.getParameter("title");

  String description;
  if (request.getParameter("description") == null) description="";
  else description = (String)request.getParameter("description");

  if (request.getParameter("validuntil") == null || ((String)request.getParameter("validuntil")).equals("") ) {
    response.sendRedirect("error.jsp?page=acceptPropositionInsert&message=1"); 
    return;
   }
   String validuntil = timeformater.monthToDBFormat((String)request.getParameter("validuntil"));

  if (request.getParameter("line") == null || request.getParameter("type") == null ) {
    response.sendRedirect("error.jsp?page=acceptPropositionInsert&message=1"); 
    return;
   }


  if ( request.getParameter("update") == null &&
       request.getParameter("accept") == null &&
       request.getParameter("email") == null  &&
       request.getParameter("fail") == null )   {
        
        response.sendRedirect("error.jsp?page=acceptPropositionInsert&message=1");
        return;
  }
    
  


  /* For now on we go on one phase at a time */
  /* ======================================= */


if (request.getParameter("fail") != null) {
// pagecontext.forward



    if ( request.getParameter("message") != null )
      session.setAttribute("message", request.getParameter("message"));
    else session.setAttribute("message", "\n");

    response.sendRedirect("proposeConfirmRemove.jsp?origid="+origID);
    return;
}



/* *************** EMail ************************************************************* */


if (request.getParameter("email") != null) {

    String mailmessage = "";


%>



<sql:statement id="stmt7" conn="conn2">
  <sql:query>
    select person.callname as firstname,
           person.lastname as lastname
    from   person
    where  person.personid = <%=personID%>
  </sql:query>
  <sql:resultSet id="rset7">
    <sql:getColumn colName="firstname" to="firstname" scope="page"/>
    <sql:getColumn colName="lastname" to="lastname" scope="page"/>
  </sql:resultSet>
</sql:statement>





<%
    
     try {
       if ( mail.sendMail( "koppelo@mit.jyu.fi" ,(String)request.getParameter("to"),
                      "Viesti KOPPELO-jrjestelmst", "TM ON AUTOMAATTINEN VIESTI KOPPELO-JRJESTELMST \n\n"+
                      "Lhettj: "+(String)pageContext.getAttribute("firstname")+" "+(String)pageContext.getAttribute("lastname")+
                      ", "+ (String)request.getParameter("sender") + "\n\n" +
                       (String)request.getParameter("message")+
                      "\n\nOtsikko: "+(String)request.getParameter("title")+"\n\nKuvaus: "+
                       (String)request.getParameter("description")) )   {

          response.sendRedirect("sendMail.jsp?success=1");  return;
       }
     } catch (Exception e) {}

          response.sendRedirect("sendMail.jsp?success=2");  return;
}



/* **************************** ACCEPT ************************************* */


if (request.getParameter("accept") != null) {
      if (!canAccept) { response.sendRedirect("errorNoAccess.jsp"); return; }


%>

    
<sql:statement id="stmt2" conn="conn2">
  <sql:query>    
    update assignmentoriginal
    set acceptedby = <%=personID%>,
        accepteddate = (select current_date),
        available = 1
    where assignmentoriginal.originalid = <%=origID%>;
  </sql:query>
  <sql:execute />
</sql:statement>

<%
                 //      Tss lhtee postia...

String name="";

%>


<sql:statement id="stmt7" conn="conn2">
  <sql:query>
   select  person.callname as firstname,
           person.lastname as lastname,
           personparameter.personparametervalue as email
    from   personparameter, person
    where  personparameter.personparametertypeid = 3
    and    personparameter.personid = person.personid
    and    person.personid = <%=personID%>
  </sql:query>
  <sql:resultSet id="rset7">
    <sql:getColumn colName="firstname" to="firstname" scope="page"/>
    <sql:getColumn colName="lastname" to="lastname" scope="page"/>
    <sql:getColumn colName="email" to="email" scope="page"/>
      <% if ( pageContext.getAttribute("firstname") != null)
           name=(String)pageContext.getAttribute("firstname")+" "+ (String)pageContext.getAttribute("lastname");
      %>
  </sql:resultSet>
</sql:statement>
      





<sql:statement id="stmt8" conn="conn2">
  <sql:query>
    select distinct personparametervalue as address,
           current_date as day
    from   personparameter
    where  personparameter.personparametertypeid = 3
    and    personparameter.personid = <%=pageContext.getAttribute("proposedby")%>
  </sql:query>
  <sql:resultSet id="rset8">
    <sql:getColumn colName="day" to="day" scope="page"/>
    <sql:getColumn colName="address" to="address" scope="page"/>
          <% mail.sendMail( "koppelo@it.jyu.fi",(String)pageContext.getAttribute("address"), title, 
                            "Aihe-ehdotuksesi "+title+" on hyvksytty aiheeksi\n\n"+
                             request.getParameter("message")+"\n\n"+                             
                            "Ksittelij: "+ name +", "+timeformater.monthToOutFormat((String)pageContext.getAttribute("day"))+
                            "\n"+(String)pageContext.getAttribute("email") ); %>
  </sql:resultSet>
</sql:statement>
    
    
  
<%
    response.sendRedirect("assignmentAttach.jsp?origid="+(String)request.getParameter("origid") );
    return;
}   


/* ******************************** UPDATE ********************************* */


if (request.getParameter("update") != null) {

    if (!canUpdate) { response.sendRedirect("errorNoAccess.jsp"); return; } 

%>

<%-- title --%>

<sql:statement id="stmt2" conn="conn2">
  <sql:query>  
    update assdetailtranslation
    set name = '<%=title%>'
    where languageid = <%=languageID%> and
    detailid = ( 
      select assignmentdetail.detailid 
      from   assignmentdetail 
      where  assoriginalreldetail.originalid = <%=origID%>
      and    assoriginalreldetail.detailid = assignmentdetail.detailid
      and    assignmentdetail.typeid = <%=titleID%>
      and    assignmentdetail.detailid = assdetailtranslation.detailid
    );
  </sql:query>
  <sql:execute />
</sql:statement>

<%-- description --%>
<sql:statement id="stmt2" conn="conn2">
  <sql:query>  
    update assdetailtranslation
    set name = '<%=description%>'
    where languageid = <%=languageID%> and
    detailid = ( 
      select assignmentdetail.detailid 
      from   assignmentdetail 
      where  assoriginalreldetail.originalid = <%=origID%>
      and   assoriginalreldetail.detailid = assignmentdetail.detailid
      and   assignmentdetail.typeid = <%=descriptionID%>
      and   assignmentdetail.detailid = assdetailtranslation.detailid
);
  </sql:query>
  <sql:execute />
</sql:statement>

<%-- validuntil --%>
<sql:statement id="stmt2" conn="conn2">
  <sql:query>  
    update assignmentoriginal
    set validuntil = '<%=validuntil%>'
    where originalid = <%=origID%>
  </sql:query>
  <sql:execute />
</sql:statement>

<%-- keywords --%>

<sql:statement id="stmt2" conn="conn2">
  <sql:query>  
    update assoriginalrelkeyword
    set deleted = true
    where originalid = <%=origID%>    
  </sql:query>
  <sql:execute />
</sql:statement>

<%
  boolean success = false;

  if ( request.getParameter("keywords") != null) {
      int i=0; 
      int lkm=0;

      int beg = 0; 
      int end = 0;
      String [] keys = new String [100];
      String key = request.getParameter("keywords");

      while ( end < key.length() ) {

        end = key.indexOf(",", beg);
        if ( end < 0 ) end = key.length();
        if (beg >= end ) break;
        keys[i] = (key.substring(beg, end)).trim();
        beg = end+1;
        i++;
      }
    lkm = i;
    for (i=0; i < lkm; i++) { 
      int keyid = 1;
      success=false; 
%>
      <sql:statement id="stmt2" conn="conn2">
       <sql:query>
           select assignmentkeyword.keywordid as id
           from   asskeywordtranslation
           where asskeywordtranslation.deleted = false
           and   asskeywordtranslation.languageid = <%=languageID%>
           and   lower(asskeywordtranslation.name) like lower('<%=keys[i]%>')
           and   asskeywordtranslation.keywordid = assignmentkeyword.keywordid
           and   assignmentkeyword.deleted = false;
        </sql:query>
        <sql:resultSet id="rset2">
        <sql:getColumn colName="id" to="keyid" scope="page" />
          <% String apu = (String)pageContext.getAttribute("keyid");
             if ( apu != null )  success = true; %>
        </sql:resultSet> 
      </sql:statement> 
<%
      if (success) { keyid = Integer.parseInt((String)pageContext.getAttribute("keyid")); }
      else { 

%>   
      <sql:statement id="stmt2" conn="conn2">
        <sql:query>
           select max(keywordid)+1 as max from assignmentkeyword;
        </sql:query>
        <sql:resultSet id="rset2">
        <sql:getColumn colName="max" to="keyid" scope="page" />
          <% String apu = (String)pageContext.getAttribute("keyid");
             if ( apu != null )  success = true; %>
        </sql:resultSet>
      </sql:statement>
      <% if (success) keyid = Integer.parseInt((String)pageContext.getAttribute("keyid")); %>
      <sql:statement id="stmt2" conn="conn2">
        <sql:query>
           insert into assignmentkeyword 
           (deleted, keywordid) values
           ('false', <%=keyid%>);
        </sql:query>
        <sql:execute />
      </sql:statement>
      <sql:statement id="stmt2" conn="conn2">
        <sql:query>
           insert into asskeywordtranslation 
           (deleted, keywordid, languageid, name) values
           ('false', <%=keyid%>, <%=languageID%>, '<%=keys[i]%>');
        </sql:query>
        <sql:execute />
      </sql:statement>
<%    }
    // Finally update to relation table 
      try {
%>
      <sql:statement id="stmt2" conn="conn2">
        <sql:query>
           insert into assoriginalrelkeyword 
           (deleted, originalid, keywordid) values
           ('false', <%=origID%>, <%=keyid%>);
        </sql:query>
        <sql:execute />
      </sql:statement>
<%    } catch (Exception kex) {
%>
      <sql:statement id="stmt3" conn="conn2">
        <sql:query>
           update assoriginalrelkeyword 
           set deleted = false
           where originalid = <%=origID%>
           and   keywordid =  <%=keyid%>;
        </sql:query>
        <sql:execute />
      </sql:statement>
<%    }
    }  
  }

%>




<%-- lines --%>

<sql:statement id="stmt2" conn="conn2">
  <sql:query>  
    update assoriginalposline
    set deleted = true
    where originalid = <%=origID%>    
  </sql:query>
  <sql:execute />
</sql:statement>

<%
  String[] lines = new String[100];
  lines =  request.getParameterValues("line");
  if ( lines != null ) {
    int i=0;
    for (i=0; i < lines.length; i++) {
      try {
%>

    <sql:statement id="stmt2" conn="conn2">
      <sql:query>  
        insert into assoriginalposline (deleted, originalid, lineid)
        values (false, <%=origID%>, <%=lines[i]%>);
      </sql:query>
      <sql:execute />
    </sql:statement>     
<%
      } catch (Exception ep) {
%>
    <sql:statement id="stmt2" conn="conn2">
      <sql:query>  
        update assoriginalposline
        set deleted = false
        where originalid = <%=origID%>
        and   lineid = <%=lines[i]%>    
      </sql:query>
      <sql:execute />
    </sql:statement>
<%
      }       
    }
  }
 
%>
 
<%-- types --%>

<sql:statement id="stmt2" conn="conn2">
  <sql:query>  
    update assoriginalpostype
    set deleted = true
    where originalid = <%=origID%>    
  </sql:query>
  <sql:execute />
</sql:statement>

<%
  String[] types = new String[100];
  types =  request.getParameterValues("type");
  if ( types != null ) {
    int i=0;
    for (i=0; i < types.length; i++) {
      try {
%>

    <sql:statement id="stmt2" conn="conn2">
      <sql:query>  
        insert into assoriginalpostype (deleted, originalid, typeid)
        values (false, <%=origID%>, <%=types[i]%>);
      </sql:query>
      <sql:execute />
    </sql:statement>     
<%
      } catch (Exception ep) {
%>
    <sql:statement id="stmt2" conn="conn2">
      <sql:query>  
        update assoriginalpostype
        set deleted = false
        where originalid = <%=origID%>
        and   typeid = <%=types[i]%>    
      </sql:query>
      <sql:execute />
    </sql:statement>
<%
      }       
    }
  }


  response.sendRedirect("acceptProposition.jsp?info=ok&origid="+origID );

}
   
%>

