<%
/***************************************************************************************************
*               PAGE DESCRIPTION
****************************************************************************************************
*
*               NAME:           adminAssRightPerson.jsp
*               LANGUAGE:       JSP
*               DATE:           6.5.2002
*               AUTHOR:         Minna Hillebrand, University of Jyvskyl (JYU)
*
****************************************************************************************************
*               COPYRIGHT (C) KOPPELO PROJECT GROUP
*               Limited rights granted. Please refer to GNU General Public License
*               http://www.gnu.org/licenses/gpl.html
****************************************************************************************************

****************************************************************************************************
*               UPDATES
****************************************************************************************************
*          
*          
*          
*          
*
****************************************************************************************************/
%>

<%@ include file="/shared/beans.inc" %>
<%@ include file="/shared/constants.inc" %>

<% /* No relation to database is needed */
   if ( userAccessLevel < 6 )  { response.sendRedirect("errorNoAccess.jsp"); return; }
%>

<%@ include file="/shared/header.inc" %>
<%@ include file="/shared/menus.inc" %>
<%@ include file="/shared/dbconnect.inc" %>

<%  String orderBy= "order by person.lastname";
    String order="";
    if (request.getParameter("orderby") != null) order = request.getParameter("orderby");
    if ( order.equals("name") ) orderBy = "order by person.lastname";
    if ( order.equals("rightname") ) orderBy = "order by assignmentright.name, person.lastname";
    if ( order.equals("linename") ) orderBy = "order by studylinetranslation.name, person.lastname";
    if ( order.equals("typename") ) orderBy = "order by asstypetranslation.name, person.lastname";
%>


<h3><t:Tr>Opinnytteiden henkilkohtaiset oikeudet</t:Tr></h3>

<div class="in">

<p><a href="adminAssRightPersonAdd.jsp">Lis henkilille oikeuksia...</a></p>


<div class="in">

<h4><t:Tr>Kannassa olevat oikeudet</t:Tr></h4>

<form action="adminAssRightPerson.jsp" method="post">

  <p>Lisehto sukunimelle <input type="text" name="namecondition" size="30" />
  <input type="submit" name="search" value="Hae" />
  </p>
</form>
</div>



<% if ( request.getParameter("namecondition") != null ) { %>

<p><hr width="75%" /></p>

<form action="adminAssRightPersonRemove.jsp">
<input type="hidden" name="namecondition" value="<%=request.getParameter("namecondition")%>" />

<table>
  <tr>
     <td><strong><t:Tr>Poista</t:Tr></strong></td>
     <td><strong><a href="adminAssRightPerson.jsp?orderby=name&namecondition=<%=request.getParameter("namecondition")%>"><t:Tr>Henkil</t:Tr></a></strong></td>
     <td><strong><a href="adminAssRightPerson.jsp?orderby=rightname&namecondition=<%=request.getParameter("namecondition")%>"><t:Tr>Oikeus</t:Tr></a></strong></td>
     <td><strong><a href="adminAssRightPerson.jsp?orderby=linename&namecondition=<%=request.getParameter("namecondition")%>"><t:Tr>Linja</t:Tr></a></strong></td>
     <td><strong><a href="adminAssRightPerson.jsp?orderby=typename&namecondition=<%=request.getParameter("namecondition")%>"><t:Tr>Opinnytteen tyyppi</t:Tr></a></strong></td>
  </tr>

  <sql:statement id="stmt2" conn="conn2">
    <sql:query>
      select person.firstnames || ' ' || person.lastname || ' (' || person.account || ')' as name,
             person.personid,
             assignmentright.name as rightname,
             studylinetranslation.name as linename,
             asstypetranslation.name as typename,
             asspersonrelright.lineid as lineid,
             asspersonrelright.asstypeid as typeid,
             asspersonrelright.rightid as rightid 
      from   asspersonrelright 
      where  asspersonrelright.deleted = false 
      and    asspersonrelright.personid = person.personid 
      and    asspersonrelright.rightid = assignmentright.rightid
      and    asspersonrelright.lineid = studyline.lineid
      and    studyline.lineid = studylinetranslation.lineid 
      and    studylinetranslation.languageid = <%=languageID%>
      and    asspersonrelright.asstypeid = assignmenttype.typeid
      and    assignmenttype.typeid = asstypetranslation.typeid
      and    asstypetranslation.languageid = <%=languageID%>
      and    lower(person.lastname) like lower('<%=request.getParameter("namecondition")%>%')
      <%=orderBy%>
    </sql:query>
    <sql:resultSet id="rset2">
      <tr>
        <td valign="top"><input type="checkbox" name="personid" value="<sql:getColumn colName="personid" />,<sql:getColumn colName="rightid" />,<sql:getColumn colName="lineid" />,<sql:getColumn colName="typeid" />" /></td>
        <td valign="top"><sql:getColumn colName="name" /></td>
        <td valign="top"><sql:getColumn colName="rightname" /></td>
        <td valign="top"><sql:getColumn colName="linename" /></td>
        <td valign="top"><sql:getColumn colName="typename" /></td>     
      </tr>
    </sql:resultSet>
  </sql:statement>

</table>

<p><input type="submit" name="submit" value="Poista valitut oikeudet" /></p>
</form>

<% } %>

<%@ include file="/shared/pageEnd.inc" %>


