<%
/***************************************************************************************************
*               PAGE DESCRIPTION
****************************************************************************************************
*
*               NAME:           adminAssRightPersonAdd.jsp
*               LANGUAGE:       JSP
*               DATE:           6.5.2002
*               AUTHOR:         Minna Hillebrand, University of Jyvskyl (JYU)
*               PURPOSE:        Add rights to selected person
*
****************************************************************************************************
*               COPYRIGHT (C) KOPPELO PROJECT GROUP
*               Limited rights granted. Please refer to GNU General Public License
*               http://www.gnu.org/licenses/gpl.html
****************************************************************************************************

****************************************************************************************************
*               UPDATES
****************************************************************************************************
*          
*          
*          
*          
*
****************************************************************************************************/
%>

<%@ include file="/shared/beans.inc" %>
<%@ include file="/shared/constants.inc" %>

<% /* No relation to database is needed */
   if ( userAccessLevel < 6 )  { response.sendRedirect("errorNoAccess.jsp"); return; }
%>

<%@ include file="/shared/header.inc" %>
<%@ include file="/shared/menus.inc" %>
<%@ include file="/shared/dbconnect.inc" %>


<h3><t:Tr>Lis oikeuksia henkillle</t:Tr></h3>


<div class="in">

<p>Oikeuksien asettaminen KOPPELO-sovelluksessa valitu(i)lle henkil(i)lle. </p>

<form action="adminAssRightPersonAdd.jsp" method="post">

<% String ehto="";
   if ( request.getParameter("condition") != null ) ehto = (String)request.getParameter("condition");
%>
  <p>Lisehto sukunimelle <input type="text" name="condition" size="30" value="<%=ehto%>"/>
  <input type="submit" name="search" value="Hae" />
  </p>
</form>
</div>



<% if ( request.getParameter("condition") != null ) { %>

<p><hr width="75%" /></p>

<h4><t:Tr>Mynn oikeus henkil(i)lle</t:Tr></h4>


<div class="in">

<form action="adminAssRightPersonInsert.jsp" method="post">
<input type="hidden" name="condition" value="<%=ehto%>" />

<table>
  <tr>
     <td><strong><t:Tr>Henkil</t:Tr></strong></td>
     <td><strong><t:Tr>Oikeus</t:Tr></strong></td>
     <td><strong><t:Tr>Linja</t:Tr></strong></td>
     <td><strong><t:Tr>Opinnytteen tyyppi</t:Tr></strong></td>
  </tr>
  <tr>

<%  String condition = ""; 

      int i=0;
      int lkm=0;

      int beg = 0; 
      int end = 0;
      String [] conds = new String[100]; 
      String con = request.getParameter("condition");

      while ( end < con.length() ) {

        end = con.indexOf(",", beg);
        if ( end < 0 ) end = con.length();
        if (beg >= end ) break;
        conds[i] = (con.substring(beg, end)).trim();
        beg = end+1;
        i++;
      }
      lkm = i;

      condition = "and ( lower(person.lastname) like lower(\'" +conds[0] +"%\') ";
      for(i=1;i < lkm;i++) {
        condition += "or lower(person.lastname) like lower(\'" +conds[i] +"%\') ";    
       } 
      condition += ")";  

%>

<td><div>
  <select multiple name="personid" size="20"> 
  <sql:statement id="stmt2" conn="conn2">
    <sql:query>
       select person.lastname || ' ' || person.firstnames as name,
              person.personid as personid, person.account as account
       from   person
       where  person.deleted = false
       <%=condition %>
       order by person.lastname;
    </sql:query>
    <sql:resultSet id="rset2">
      <option value="<sql:getColumn colName="personid" />">
      <sql:getColumn colName="name" /> '<sql:getColumn colName="account" />'
      </option>
    </sql:resultSet>
  </sql:statement>
  </select>
</div>
</td>

<td><div>
  <select multiple name="rightid" size="20"> 
  <sql:statement id="stmt2" conn="conn2">
    <sql:query>
       select assignmentright.name || ' (' ||  assignmentright.rightid || ')' as rightname,
              assignmentright.rightid as rightid 
       from   assignmentright
       where  assignmentright.deleted = false
       order by assignmentright.name
    </sql:query>
    <sql:resultSet id="rset2">
      <option value="<sql:getColumn colName="rightid" />"><sql:getColumn colName="rightname" /></option>
    </sql:resultSet>
  </sql:statement>
  </select>
</div>
</td>

<td><div>
  <select multiple name="lineid" size="20"> 
  <sql:statement id="stmt2" conn="conn2">
    <sql:query>
       select studylinetranslation.name || ' (' || studylinetranslation.lineid || ')' as linename,
              studylinetranslation.lineid
       from   studyline
       where  studyline.deleted = false
       and    studyline.lineid = studylinetranslation.lineid
       and    studylinetranslation.languageid = <%=languageID%>
    </sql:query>
    <sql:resultSet id="rset2">
      <option value="<sql:getColumn colName="lineid" />"><sql:getColumn colName="linename" /></option>
    </sql:resultSet>
  </sql:statement>
  </select>
</div>
</td>

<td><div>
  <select multiple name="typeid" size="20"> 
  <sql:statement id="stmt2" conn="conn2">
    <sql:query>
       select asstypetranslation.name || ' (' || asstypetranslation.typeid || ')' as typename,
              asstypetranslation.typeid as typeid
       from   assignmenttype
       where  assignmenttype.deleted = false
       and    assignmenttype.typeid = asstypetranslation.typeid 
       and    asstypetranslation.languageid = <%=languageID%>
    </sql:query>
    <sql:resultSet id="rset2">
      <option value="<sql:getColumn colName="typeid" />"><sql:getColumn colName="typename" /></option>
    </sql:resultSet>
  </sql:statement>
  </select>
</div>
</td>
</tr>

</table>

<p><input type="submit" name="submit" value="Mynn oikeus" /></p>
<p>Toiminto lis henkilille oikeuslistasta valitut oikeudet poistamatta heille 
   aiemmin mrttyj oikeuksia.</p>
</form>

<% } %>


<%@ include file="/shared/pageEnd.inc" %>


