<%
/***************************************************************************************************
*               PAGE DESCRIPTION
****************************************************************************************************
*
*               NAME:           assignment.jsp
*               LANGUAGE:       JSP
*               DATE:           4.4.2002
*               AUTHOR:         Minna Hillebrand, University of Jyvskyl (JYU)
*
****************************************************************************************************
*               COPYRIGHT (C) KOPPELO PROJECT GROUP
*               Limited rights granted. Please refer to GNU General Public License
*               http://www.gnu.org/licenses/gpl.html
****************************************************************************************************

****************************************************************************************************
*               UPDATES
****************************************************************************************************
*                 27.4.2002  Minna Hillebrand              
*                   Added all assignment related details
*		  15.5.2002  Antti Vanhanen
*                   Modification to vocabulary
****************************************************************************************************/
%>



<%@ include file="/shared/beans.inc" %>
<%@ include file="/shared/constants.inc" %>
<%@ include file="/shared/dbconnect.inc" %>


<%-- Check that all necessary parameters have been posted and the user 
     is related to the assignment --%>

<%
  if (request.getParameter("assid") == null) { 
    if (request.getParameter("origid") == null) { 
      response.sendRedirect("error.jsp?page=assignment&message=1");
      return;
    }
    int origid = Integer.parseInt(request.getParameter("origid"));       
    response.sendRedirect("assignmentInfo.jsp?origid="+origid);
    return;
  }

  int assID = Integer.parseInt(request.getParameter("assid"));   

%>
<%-- we need to figure out if the user can update assignment's detail or just watch the details --%>


<% police.setDB(db);

   boolean canUpdate = false;
   boolean canGrade  = false;
   boolean canFinish = false; 

   if ( ! police.hasPersonRight(allowAssDetail, personID, assID) ) {
      response.sendRedirect("assignmentInfo.jsp?assid="+assID); 
      return;   
   }

   if ( police.hasPersonRight(allowAssUpdate, personID, assID) )   canUpdate  = true;
   if ( police.hasPersonRight(allowGradeID, personID, assID)   )   canGrade  = true;
   if ( police.hasPersonRight(allowAssFinish, personID, assID) )   canFinish = true;

%>



<%@ include file="/shared/header.inc" %>
<%@ include file="/shared/menus.inc" %>

<% time timeformater = new time(); %>

<p>
<t:Tr><a href="addEvent.jsp?assid=<%=assID%>">Lis tapahtuma</a></t:Tr>
<% if ( canUpdate ) { %>
| <t:Tr><a href="assignmentUpdate.jsp?assid=<%=assID %>">Muuta tietoja</a></t:Tr>
| <t:Tr><a href="assignmentUpdatePerson.jsp?assid=<%=assID %>">Lis/poista henkilit</a></t:Tr>
| <t:Tr><a href="assignmentUpdateTask.jsp?assid=<%=assID %>">Pivit tytehtvi</a></t:Tr>

<% } %>
<% if ( canGrade ) { %>
| <t:Tr><a href="assignmentGrade.jsp?assid=<%=assID %>">Arvioi opiskelija</a></t:Tr>
<% } %>
<% if ( canFinish ) { %>
| <t:Tr><a href="assignmentGradeFinish.jsp?assid=<%=assID %>">Opinnytteen hyvksyminen</a></t:Tr>
<% } %>
</p>

<h3><t:Tr>Opinnytteen tiedot ja tapahtumat</t:Tr></h3>

<!--<p>&nbsp;</p>-->

<h4>Opinnytteen yleiset tiedot</h4>

<div class="in">


<table>

  <sql:statement id="stmt2" conn="conn2">
    <sql:query>
       select assdetailtranslation.name as title,
              descriptiontypetranslation.name as name 
       from   assdetailtranslation
       where  assignment.assignmentid = <%=assID%>
       and    assignment.deleted = false
       and    assignmentreldetail.assignmentid = <%=assID%>
       and    assignmentreldetail.detailid = assignmentdetail.detailid
       and    assignmentdetail.typeid = <%=titleID%>
       and    assdetailtranslation.detailid = assignmentdetail.detailid
       and    assdetailtranslation.languageid = <%=languageID%> 
       and    descriptiontypetranslation.descriptiontypeid = <%=titleID%>
       and    descriptiontypetranslation.languageid = <%=languageID%> 
     </sql:query>
    <sql:resultSet id="rset2"> 
    <tr>
      <td valign="top"><strong><sql:getColumn colName="name" /></strong></td>
      <td><sql:getColumn colName="title" /></td>
    </tr>
    </sql:resultSet>
  </sql:statement>

  <sql:statement id="stmt2" conn="conn2">
    <sql:query>
       select assdetailtranslation.name as descr,
              descriptiontypetranslation.name as name 
       from   assdetailtranslation
       where  assignment.assignmentid = <%=assID%>
       and    assignment.deleted = false
       and    assignmentreldetail.assignmentid = <%=assID%>
       and    assignmentreldetail.detailid = assignmentdetail.detailid
       and    assignmentdetail.typeid = <%=descriptionID%>
       and    assdetailtranslation.detailid = assignmentdetail.detailid
       and    assdetailtranslation.languageid = <%=languageID%> 
       and    descriptiontypetranslation.descriptiontypeid = <%=descriptionID%>
       and    descriptiontypetranslation.languageid = <%=languageID%> 
     </sql:query>
    <sql:resultSet id="rset2"> 
    <tr>
      <td valign="top"><strong><sql:getColumn colName="name" /></strong></td>
      <td><sql:getColumn colName="descr" /></td>
    </tr>
    </sql:resultSet>
  </sql:statement>

    <tr>
      <td valign="top"><strong><t:Tr>Avainsanat</t:Tr></strong></td>
      <td>
     <% String akeys="";
        boolean first=true;
     %>

  <sql:statement id="stmt2" conn="conn2">
    <sql:query>
       select asskeywordtranslation.name as keyw
       from   asskeywordtranslation
       where  assignmentrelkeyword.deleted = false
       and    assignmentrelkeyword.assignmentid = <%=assID%>
       and    assignmentrelkeyword.keywordid = assignmentkeyword.keywordid
       and    assignmentkeyword.deleted = false
       and    asskeywordtranslation.deleted = false
       and    assignmentkeyword.keywordid = asskeywordtranslation.keywordid
       and    asskeywordtranslation.languageid = <%=languageID%>
     </sql:query>

    <sql:resultSet id="rset2"> 
      <sql:getColumn colName="keyw" to="keys" />
      <% if (first) { akeys += pageContext.getAttribute("keys"); first = false; }
         else akeys += ", " +pageContext.getAttribute("keys");  %>
    </sql:resultSet>
  </sql:statement>
      <%=akeys%></td>
    </tr>

  <sql:statement id="stmt2" conn="conn2">
    <sql:query>
      select             
             assignment.assignmenttypeid as asstypeid,
             asstypetranslation.name as typename, 
             assignment.lineid as alineid, 
             course.courseid as  asscourseid,
             assignment.phaseid as assphaseid,
             assphasetranslation.name as phasename,  
             assignment.warningtime as wtime,
             assignment.publicgroup as pgroup,
             assignmentoriginal.available as available,
             assignment.begindate,
             assignment.finisheddate

      from   assignment
      where  assignment.deleted = false  
      and    assignment.assignmentid = <%=assID%>
      and    assignment.originalid = assignmentoriginal.originalid

      and    assignment.assignmenttypeid = assignmenttype.typeid
      and    assignmenttype.typeid = asstypetranslation.typeid
      and    asstypetranslation.languageid = <%=languageID%>
<%--
      and    assignment.lineid = studyline.lineid
      and    studyline.lineid = studylinetranslation.lineid 
--%>      
      and    assignment.courseid = course.courseid
      and    course.courseid = coursetranslation.courseid
      and    coursetranslation.languageid = <%=languageID%>

      and    assignment.phaseid = assignmentphase.phaseid
      and    assignmentphase.phaseid = assphasetranslation.phaseid
      and    assphasetranslation.languageid = <%=languageID%> 

    </sql:query>
    <sql:resultSet id="rset2"> 
    <tr>
      <td valign="top"><strong><t:Tr>Tyyppi</t:Tr></strong></td>
      <td><sql:getColumn colName="typename" /></td>  
    </tr>

    <tr>
      <td valign="top"><strong><t:Tr>Linja</t:Tr></strong></td>
      <td>
         <% try { %>

  <sql:statement id="stmt3" conn="conn2">
    <sql:query>
          select studylinetranslation.name as linename,
                 organisationtranslation.name as orgname
          from   studyline
          where  studyline.deleted = false
          and    studyline.lineid = <sql:getColumn colName="alineid" />
          and    studyline.lineid = studylinetranslation.lineid
          and    studylinetranslation.languageid = <%=languageID%>
          and    studyline.organisationid = organisation.organisationid
          and    organisation.deleted = false 
          and    organisation.organisationid = organisationtranslation.organisationid
          and    organisationtranslation.languageid = <%=languageID%>
    </sql:query>
    <sql:resultSet id="rset3">
      <sql:getColumn colName="linename" />, <sql:getColumn colName="orgname" />
    </sql:resultSet>
  </sql:statement>
         <% } catch (Exception e) {} %>  
      </td> 
    </tr>

    <tr>
      <td valign="top"><strong><t:Tr>Tyn vaihe</t:Tr></strong></td>
      <td><sql:getColumn colName="phasename" /> </td>  
    </tr>

<%--
    <tr>
      <td valign="top"><strong><t:Tr>Aihe vapaa </t:Tr></strong></td>
      <td><sql:getColumn colName="available" /> <t:Tr>ryhmlle</t:Tr></td>
    </tr>
 --%>
  <tr>
    <td><strong><t:Tr>Aloituspiv</t:Tr></strong></td>
    <td><sql:getDate colName="begindate" to="bdate" />
        <%=timeformater.monthToOutFormat((String)pageContext.getAttribute("bdate"))%></td>
  </tr>
  <tr>
    <td><strong><t:Tr>Hyvksymispiv</t:Tr></strong></td>
    <td><sql:getDate colName="finisheddate" to="fdate" />
        <% if (pageContext.getAttribute("fdate") != null) { %>
        <%=timeformater.monthToOutFormat((String)pageContext.getAttribute("fdate"))%> <% } %></td>
   </tr>
    </sql:resultSet>
  </sql:statement>

</table>

</div>

<br />
<h4><t:Tr>Opinnytteeseen liittyvt henkilt</t:Tr></h4>

<div class="in">
<table>
  <sql:statement id="stmt2" conn="conn2">
    <sql:query>
       select person.lastname || ' ' || person.firstnames as name,
              assroletranslation.name as rolename, 
              person.personid as pid
       from   assignmentrelatedperson
       where  assignmentrelatedperson.deleted = false
       and    assignmentrelatedperson.assignmentid = <%=assID%>  
       and    assignmentrelatedperson.personid = person.personid
       and    person.deleted = false
       and    assignmentrelatedperson.roleid = assignmentrole.roleid
       and    assignmentrole.deleted = false
       and    assignmentrole.roleid = assroletranslation.roleid
       and    assroletranslation.deleted = false
       and    assroletranslation.languageid = <%=languageID%>                    
       order by roleid, person.lastname;
    </sql:query>
    <sql:resultSet id="rset2"> 
     <tr>
      <td><strong><sql:getColumn colName="rolename" /></strong><td>
      <td><sql:getColumn colName="name" /></td>
      <td>
  <sql:statement id="stmt3" conn="conn2">
    <sql:query>
       select personparameter.personparametervalue as email
       from   personparameter
       where  personparameter.deleted = false 
       and    personparameter.personid = <sql:getColumn colName="pid" /> 
       and    personparameter.personparametertypeid = 3
    </sql:query>
    <sql:resultSet id="rset3"> 
      <td><sql:getColumn colName="email" /> 
    </sql:resultSet>
  </sql:statement>
      </td>
     </tr>
    </sql:resultSet>
  </sql:statement>
</table>
</div>


<br />
<h4><t:Tr>Opinnytteeseen liittyvt tytehtvt</t:Tr></h4>
<% boolean titlerow=true; %>
<div class="in">
<table>
  <sql:statement id="stmt2" conn="conn2">
    <sql:query>
       select asstasktranslation.name as taskname,
              asstaskcategorytranslation.name as catname,
              assphasetranslation.name as taskphase
       from   assignmenttaskrelation
       where  assignmenttaskrelation.deleted = false
       and    assignmenttaskrelation.assignmentid = <%=assID%>  
       and    assignmenttaskrelation.taskid = assignmenttask.taskid
       and    assignmenttask.deleted = false
       and    assignmenttask.taskid = asstasktranslation.taskid
       and    asstasktranslation.languageid = <%=languageID%>
       and    assignmenttask.categoryid = asstaskcategory.categoryid
       and    asstaskcategory.categoryid = asstaskcategorytranslation.categoryid
       and    asstaskcategorytranslation.languageid = <%=languageID%>
       and    assignmenttaskrelation.phaseid = assignmentphase.phaseid
       and    assignmentphase.phaseid = assphasetranslation.phaseid
       and    assphasetranslation.languageid = <%=languageID%> 
       order by catname, taskname 
    </sql:query>
    <sql:resultSet id="rset2"> 
    <tr>
      <% if (titlerow) { %>
      <td><strong><t:Tr>Luokka</t:Tr></strong></td> 
      <td><strong><t:Tr>Tehtvn nimi</t:Tr></strong></td> 
      <td><strong><t:Tr>Tehtvn vaihe</t:Tr></strong></td>
    </tr>
    <tr>
      <% titlerow = false; } %>
      <td><sql:getColumn colName="catname" /></td> 
      <td><sql:getColumn colName="taskname" /></td> 
      <td><sql:getColumn colName="taskphase" /></td> 
    </tr>   
    </sql:resultSet>
  </sql:statement>
</table>
<% if (titlerow) { %>
<p>Opinnytteeseen ei ole liitetty tytehtvi.</p>
<% } %> 

</div>

<%--
<% if (canUpdate) { %>

<h4><t:Tr>Tietojen muuttaminen</t:Tr></h4>
<p>
<a href="assignmentUpdate.jsp?assid=<%=assID %>" ><t:Tr>Muuta tietoja ...</t:Tr></a>
</p>
<% } %>
--%>

<% boolean firstgrade = true; %>

  <sql:statement id="stmt2" conn="conn2">
    <sql:query>
       select
              person.firstnames || ' ' || person.lastname as name,
              assignmentfinished.gradedate,  
              assignmentfinished.gradedbyid,
              gradetranslation.name as grade
       from   assignmentfinished, assignmentrelatedperson as GradedBy, assignmentrelatedperson as Student
       where  assignmentfinished.deleted = false
       and    assignmentfinished.gradedbyid = GradedBy.relationid
       and    GradedBy.assignmentid = <%=assID%>
       and    GradedBy.deleted = false
       and    GradedBy.personid = person.personid
       and    assignmentfinished.persontobegradedid = Student.relationid
       and    Student.deleted = false
       and    Student.personid = <%=personID%>
       and    assignmentfinished.gradeid = gradetranslation.gradeid
       and    gradetranslation.languageid = <%=languageID%>
    </sql:query>
    <sql:resultSet id="rset2"> 

<% if (firstgrade) { %>
<br />
<h4><t:Tr>Arvioinnit</t:Tr></h4>
<div class="in">
<table>
    <tr>
      <td><strong><t:Tr>Arviointipiv</t:Tr></strong></td>
      <td><strong><t:Tr>Arvioija</t:Tr></strong></td>
      <td><strong><t:Tr>Arvolause</t:Tr></strong></td>
    </tr>
<%
    firstgrade = false; 
  } 
%>
    <tr>
      <td><sql:getColumn colName="gradedate" to="gdate" /><a href="assignmentGradeStudent.jsp?assid=<%=assID%>&teacher=<sql:getColumn colName="gradedbyid" />">
          <%=timeformater.monthToOutFormat((String)pageContext.getAttribute("gdate")) %></a></td> 
      <td><sql:getColumn colName="name" /></td> 
      <td>&nbsp;&nbsp;<sql:getColumn colName="grade" /></td>
    </tr>   
    </sql:resultSet>
  </sql:statement>

<% if (!firstgrade) { %>
</table>
</div>
<% } %>


<% if (canGrade) { %>

<br />

<h4><t:Tr>Opiskelijoiden arvioinnit</t:Tr></h4>

<div class="in">
<table>
  <tr>
    <td><strong><t:Tr>Arvostelupiv</t:Tr></strong></td>
    <td><strong><t:Tr>Opiskelija</t:Tr></strong></td>
    <td><strong><t:Tr>Arvioitsija</t:Tr></strong></td>
    <td><strong><t:Tr>Arvolause</t:Tr></strong></td>
    <td><strong><t:Tr>OV</t:Tr></strong></td>
  

  </tr>
  <sql:statement id="stmt2" conn="conn2">
    <sql:query>
       select assignmentfinished.persontobegradedid as studentgrade,
              Stu.firstnames || ' ' || Stu.lastname as stuname,
              assignmentfinished.gradedate,  
              GradedBy.personid as gradeperson,
              GradedBy.relationid as gradedbyid,
              Tea.firstnames || ' ' || Tea.lastname as teaname,
              gradetranslation.name as grade, 
              trunc(assignmentfinished.credits) as credits
       from   assignmentfinished, assignmentrelatedperson as Student, assignmentrelatedperson as GradedBy,
              person as Stu, person as Tea
       where  assignmentfinished.deleted = false
       and    assignmentfinished.gradedbyid = GradedBy.relationid
       and    GradedBy.assignmentid = <%=assID%>
       and    GradedBy.deleted = false
       and    GradedBy.personid = Tea.personid 
       and    assignmentfinished.persontobegradedid = Student.relationid
       and    Student.deleted = false
       and    Student.personid = Stu.personid
       and    Student.assignmentid = <%=assID%>
       and    assignmentfinished.gradeid = grade.gradeid
       and    grade.gradeid = gradetranslation.gradeid
       and    gradetranslation.languageid = <%=languageID%>  
       order by gradedate desc;
    </sql:query>
    <sql:resultSet id="rset2"> 
    <tr><sql:getColumn colName="gradeperson" to="gradeperson" />
      <% if ( Integer.parseInt((String)pageContext.getAttribute("gradeperson")) == personID ) { %> 
      <td><a href="assignmentGrade.jsp?assid=<%=assID%>&studentgrade=<sql:getColumn colName="studentgrade" />">
          <sql:getColumn colName="gradedate" to="gdate" />
          <%=timeformater.monthToOutFormat((String)pageContext.getAttribute("gdate"))%></td> 
       <% } else { %>
      <td><%--<a href="assignmentGradeStudent?assid=<%=assID%>&teacher=<sql:getColumn colName="gradedbyid">--%><sql:getColumn colName="gradedate" /><%--</a>--%></td> 
       <% } %>      <td><sql:getColumn colName="stuname" /></td>
      <td><sql:getColumn colName="teaname" /></td>
      <td>&nbsp;&nbsp;<sql:getColumn colName="grade" /></td>
      <td>&nbsp;<sql:getColumn colName="credits" /></td>
    </tr>   
    </sql:resultSet>
  </sql:statement>
</table>
</div>

<%--
<p>
<a href="assignmentGrade.jsp?assid=<%=assID %>" ><t:Tr>Arvioi opiskelija...</t:Tr></a>
</p>
--%>

<% } %>


<br/>


<h4><a name="events"><t:Tr>Opinnytteen tapahtumat</t:Tr></a></h4>


<div class="in">
<%--<p><a href="addEvent.jsp?assid=<%=assID %>" ><t:Tr>Lis tapahtuma</t:Tr></a></p>
--%>

<% int counter = 0; %> 
<table>
      <tr>
        <td><strong><t:Tr>Pivmr</t:Tr></strong></td>
        <td><strong><t:Tr>Tyyppi</t:Tr></strong></td>
        <td><strong><t:Tr>Otsikko</t:Tr></strong></td>
        <td><strong><t:Tr>Kirjaaja</t:Tr></strong></td>
      </tr>  <sql:statement id="stmt3" conn="conn2">
    <sql:query>
      select assignmentevent.eventid as eventid,
             asseventtypetranslation.name as eventtype,
             assignmentevent.title as title,
             assignmentevent.eventdate as eventdate,
             person.firstnames || ' ' || person.lastname as name
      from   asseventtypetranslation, person
      where  assignmentevent.deleted = 'false'
      and    assignmentevent.assignmentid = <%=assID%>
      and    assignmentevent.eventtypeid = asseventtype.typeid 
      and    asseventtype.typeid =  asseventtypetranslation.typeid
      and    asseventtypetranslation.languageid = <%=languageID%>
      and    assignmentevent.registratorid = assignmentrelatedperson.relationid
      and    assignmentrelatedperson.assignmentid = <%=assID%> 
      and    assignmentrelatedperson.personid = person.personid
      order by assignmentevent.eventdate desc, assignmentevent.begintime desc, assignmentevent.endtime desc;
    </sql:query>

    <sql:resultSet id="rset3" loop="true">
      <% counter++; %>
      <tr>
        <td><sql:getDate colName="eventdate" to="edate"/>
            <a href="assignmentEvent.jsp?eventid=<sql:getColumn colName="eventid" />">
            <%=timeformater.monthToOutFormat((String)pageContext.getAttribute("edate"))%></a></td>
        <td><sql:getColumn colName="eventtype" /></td> 
        <td><sql:getColumn colName="title" /></td> 
        <td><sql:getColumn colName="name" /></td> 
      </tr>
    </sql:resultSet>
  </sql:statement>
</table>
</div>

<%--
<% if (counter > 5) { %>
<p><a href="addEvent.jsp?assid=<%=assID%>" ><t:Tr>Lis tapahtuma</t:Tr></a></p>
<% } %>
--%>


<p>
<t:Tr><a href="addEvent.jsp?assid=<%=assID%>">Lis tapahtuma</a></t:Tr>
<% if ( canUpdate ) { %>
| <t:Tr><a href="assignmentUpdate.jsp?assid=<%=assID %>">Muuta tietoja</a></t:Tr>
| <t:Tr><a href="assignmentUpdatePerson.jsp?assid=<%=assID %>">Lis/poista henkilit</a></t:Tr>
| <t:Tr><a href="assignmentUpdateTask.jsp?assid=<%=assID %>">Pivit tytehtvi</a></t:Tr>

<% } %>
<% if ( canGrade ) { %>
| <t:Tr><a href="assignmentGrade.jsp?assid=<%=assID %>">Arvioi opiskelija</a></t:Tr>
<% } %>
<% if ( canFinish ) { %>
| <t:Tr><a href="assignmentGradeFinish.jsp?assid=<%=assID %>">Opinnytteen hyvksyminen</a></t:Tr>
<% } %>
</p>


<%@ include file="/shared/pageEnd.inc" %>



