<%
/***************************************************************************************************
*               PAGE DESCRIPTION
****************************************************************************************************
*
*               NAME:           assignmentAttach.jsp
*               LANGUAGE:       JSP
*               DATE:           10.4.2002
*               AUTHOR:         Minna Hillebrand, University of Jyvskyl (JYU)
*               PURPOSE:        Promote subject to assignment
*
****************************************************************************************************
*               COPYRIGHT (C) KOPPELO PROJECT GROUP
*               Limited rights granted. Please refer to GNU General Public License
*               http://www.gnu.org/licenses/gpl.html
****************************************************************************************************

****************************************************************************************************
*               UPDATES
****************************************************************************************************
*                10.5.2002 Minna Hillebrand
*                   Functionality to change/adjust assignment's details 
*                      
*
****************************************************************************************************/
%>


<%@ include file="/shared/beans.inc" %>
<%@ include file="/shared/constants.inc" %>
<%@ include file="/shared/dbconnect.inc" %>

<%

 if (request.getParameter("origid") == null) {
   response.sendRedirect("error.jsp?page=assignmentAttach&message=1");
   return;
  }
 String origID = (String)request.getParameter("origid"); 

%>

<%-- Check that user is allowed   --%>

  <sql:statement id="stmt2" conn="conn2">
    <sql:query>
          select 1 as id
          from   asspersonrelright
          where  asspersonrelright.deleted = false
          and    asspersonrelright.personid = <%=personID%>
          and    asspersonrelright.rightid = <%=allowAssAttach%> 
          union  
          select 1 as id
          from   assusergrouprelright
          where  assusergrouprelright.deleted = false
          and    assusergrouprelright.groupid = <%=userAccessLevel%>
          and    assusergrouprelright.rightid = <%=allowAssAttach%> 
    </sql:query>
    <sql:resultSet id="rset2">
      <sql:getColumn colName="id" to="did" scope="page" />
    </sql:resultSet>
  </sql:statement>

<%
  try {
    int id = Integer.parseInt((String)pageContext.getAttribute("did"));
  } catch (Exception e) {
    response.sendRedirect("assignment.jsp&origid="+origID); 
    return;
  }
%>


<%@ include file="/shared/header.inc" %>
<%@ include file="/shared/menus.inc" %>


<p>
<t:Tr><a href="main.jsp?teacher=true">Opinnytteiden hallinta</a></t:Tr> | 
<t:Tr><a href="propositions.jsp">Hyvksymist kaipaavat aihe-ehdotukset</a></t:Tr>
</p>

<h3><t:Tr>Aiheen kiinnittminen</t:Tr></h3>


<form action="assignmentAttachInsert.jsp" method="post">
<input type="hidden" name="origid" value="<%=origID%>" />

<table>
  <tr>
  <td valign="top"><strong><t:Tr>Otsikko</t:Tr></strong></td> 
  <td>
    <sql:statement id="stmt2" conn="conn2">
      <sql:query>
        select assdetailtranslation.name as title
        from   assignmentoriginal
        where  assignmentoriginal.deleted = false 
        and    assignmentoriginal.originalid = <%=origID%>
        and    assignmentoriginal.originalid = assoriginalreldetail.originalid
        and    assoriginalreldetail.detailid = assignmentdetail.detailid
        and    assignmentdetail.typeid = <%=titleID%>
        and    assignmentdetail.detailid = assdetailtranslation.detailid
        and    assdetailtranslation.languageid = <%=languageID%> 
      </sql:query>
      <sql:resultSet id="rset2">
        <sql:getColumn colName="title" />
      </sql:resultSet>
    </sql:statement>
  </td> 
  </tr>
  <tr>
  <td valign="top"><strong><t:Tr>Kuvaus</t:Tr></strong></td> 
  <td>
    <sql:statement id="stmt2" conn="conn2">
      <sql:query>
        select assdetailtranslation.name as description
        from   assignmentoriginal
        where  assignmentoriginal.deleted = false 
        and    assignmentoriginal.originalid = <%=origID%>
        and    assignmentoriginal.originalid = assoriginalreldetail.originalid
        and    assoriginalreldetail.detailid = assignmentdetail.detailid
        and    assignmentdetail.typeid = <%=descriptionID%>
        and    assignmentdetail.detailid = assdetailtranslation.detailid
        and    assdetailtranslation.languageid = <%=languageID%> 
      </sql:query>
      <sql:resultSet id="rset2">
        <sql:getColumn colName="description" />
      </sql:resultSet>
    </sql:statement>
  </td>
  </tr>
  <tr>
  <td><strong><t:Tr>Tyyppi</t:Tr></strong></td> 
  <td>
    <select name="typeid">
    <sql:statement id="stmt2" conn="conn2">
      <sql:query>
        select assoriginalpostype.typeid,
               asstypetranslation.name as typename 
        from   assoriginalpostype
        where  assoriginalpostype.deleted = false
        and    assoriginalpostype.originalid = <%=origID%>
        and    assoriginalpostype.typeid = assignmenttype.typeid
        and    assignmenttype.typeid = asstypetranslation.typeid
        and    asstypetranslation.languageid = <%=languageID%>
      </sql:query>
      <sql:resultSet id="rset2">
        <option value="<sql:getColumn colName="typeid" />"><sql:getColumn colName="typename" /></option>
      </sql:resultSet>
    </sql:statement>
    </select>
  </td>
  </tr>
  <tr> 
  <td><strong><t:Tr>Linja</t:Tr></strong></td> 
  <td>
    <select name="lineid">
       <option value="null">ei linjaa</option>
    <sql:statement id="stmt2" conn="conn2">
      <sql:query>
        select assoriginalposline.lineid,
               studylinetranslation.name as linename 
        from   assoriginalposline
        where  assoriginalposline.deleted = false
        and    assoriginalposline.originalid = <%=origID%>
        and    assoriginalposline.lineid = studyline.lineid
        and    studyline.lineid = studylinetranslation.lineid
        and    studylinetranslation.languageid = <%=languageID%>
      </sql:query>
      <sql:resultSet id="rset2">
        <option value="<sql:getColumn colName="lineid" />"><sql:getColumn colName="linename" /></option>
      </sql:resultSet>
    </sql:statement>
    </select>
  </td>
  </tr>
  <tr> 
  <td><strong><t:Tr>Kurssi</t:Tr></strong></td> 
  <td>
    <select name="courseid">
    <sql:statement id="stmt2" conn="conn2">
      <sql:query>
        select course.courseid,
               course.code,
               coursetranslation.name
        from   course
        where  course.deleted = false
        and    course.courseid = coursetranslation.courseid
        and    coursetranslation.languageid = <%=languageID%>
        and    course.organisationid = <%=user.getOrganisationID()%>
        order by course.code
      </sql:query>
      <sql:resultSet id="rset2">
        <option value="<sql:getColumn colName="courseid" />"><sql:getColumn colName="code" /> 
                                                             <sql:getColumn colName="name" /></option>
      </sql:resultSet>
    </sql:statement>
    </select>
  </td>
  </tr>
<%   
   java.util.Date today = new java.util.Date();
   java.text.SimpleDateFormat parser = new java.text.SimpleDateFormat("dd.MM.yyyy");
%>
  <tr>
  <td><strong><t:Tr>Aloituspiv</t:Tr></strong></td> 
  <td><input type="text" name="begindate" value="<%=parser.format(today)%>" size="12" /></td> 
  </tr>

</table>

<p><input type="submit" name="submit" value="Aloita opinnytteen suoritus"></p>

</form>

<%@ include file="/shared/pageEnd.inc" %>
