<%
/***************************************************************************************************
*               PAGE DESCRIPTION
****************************************************************************************************
*
*               NAME:           assignmentAttachInsert.jsp
*               LANGUAGE:       JSP
*               DATE:           10.5.2002
*               AUTHOR:         Minna Hillebrand, University of Jyvskyl (JYU)
*               PURPOSE:        Insert new assignment
*
****************************************************************************************************
*               COPYRIGHT (C) KOPPELO PROJECT GROUP
*               Limited rights granted. Please refer to GNU General Public License
*               http://www.gnu.org/licenses/gpl.html
****************************************************************************************************

****************************************************************************************************
*               UPDATES
****************************************************************************************************
*             
*             
*                      
*
****************************************************************************************************/
%>


<%@ include file="/shared/beans.inc" %>
<%@ include file="/shared/constants.inc" %>
<%@ include file="/shared/dbconnect.inc" %>

<%-- Check parameters --%>

<%
 
  if (request.getParameter("origid") == null) {
    response.sendRedirect("error.jsp?page=assignmentAttachInsert&message=1");
    return;
   }
  int origID = Integer.parseInt((String)request.getParameter("origid")); 

  if (request.getParameter("lineid") == null) {
    response.sendRedirect("error.jsp?page=assignmentAttachInsert&message=1");
    return;
   }
  String lineID = (String)request.getParameter("lineid"); 

  if (request.getParameter("typeid") == null) {
    response.sendRedirect("error.jsp?page=assignmentAttachInsert&message=1");
    return;
   }
  int typeID = Integer.parseInt((String)request.getParameter("typeid")); 

  if (request.getParameter("courseid") == null) {
    response.sendRedirect("error.jsp?page=assignmentAttachInsert&message=1");
    return;
   }
  int courseID = Integer.parseInt((String)request.getParameter("courseid")); 
 
  if (request.getParameter("begindate") == null) {
    response.sendRedirect("error.jsp?page=assignmentAttachInsert&message=1");
    return;
   }
   time timeformater = new time(); 
   String beginDate = timeformater.monthToDBFormat((String)request.getParameter("begindate")); 
 
 
%>



<%-- Check that user is allowed   --%>

  <sql:statement id="stmt2" conn="conn2">
    <sql:query>
          select 1 as id
          from   asspersonrelright
          where  asspersonrelright.deleted = false
          and    asspersonrelright.personid = <%=personID%>
          and    asspersonrelright.rightid = <%=allowAssAttach%> 
      <%  if ( ! lineID.equals("null") ) { %>
          and     asspersonrelright.lineid = <%=lineID%>
      <% } %>
          and    asspersonrelright.asstypeid = <%=typeID%>

    </sql:query>
    <sql:resultSet id="rset2">
      <sql:getColumn colName="id" to="did" scope="page" />
    </sql:resultSet>
  </sql:statement>

<%
  try {
    int id = Integer.parseInt((String)pageContext.getAttribute("did"));
  } catch (Exception e) {
    response.sendRedirect("errorNoAccess.jsp"); 
    return;
  }

%>

<%-- Check that we haven't pushed back-button --%>

  <sql:statement id="stmt2" conn="conn2">
    <sql:query>
          select available as av
          from   assignmentoriginal
          where  assignmentoriginal.originalid = <%=origID%>
          and    assignmentoriginal.deleted = false
    </sql:query>
    <sql:resultSet id="rset2">
      <sql:getColumn colName="av" to="av" scope="page" />
    </sql:resultSet>
  </sql:statement>

<%
  try {
    int av = Integer.parseInt((String)pageContext.getAttribute("av"));
    if ( av <= 0 ) {
      response.sendRedirect("error.jsp?page=assignmentAttachInsert&message=3"); 
      return;
    }
  } catch (Exception e) {
    response.sendRedirect("error.jsp?page=assignmentAttachInsert&message=3"); 
    return;
  }
%>


<% boolean success = false; %>

  <sql:statement id="stmt2" conn="conn2">
    <sql:query>
      select max(assignment.assignmentid)+1 as maxid from assignment; 
    </sql:query>
    <sql:resultSet id="rset2">
      <sql:getColumn colName="maxid" to="maxid" scope="page"/>
      <% if (pageContext.getAttribute("maxid") != null) success = true;  %>
    </sql:resultSet>
  </sql:statement>

<%
  int maxID = 1;
    if (success) maxID = Integer.parseInt((String)pageContext.getAttribute("maxid")); 
%>

 <sql:statement id="stmt2" conn="conn2">
  <sql:query>  
	insert into assignment 
	(deleted, assignmentid, warningtime, publicgroup, originalid, 
	assignmenttypeid, courseid, lineid, begindate, finisheddate, phaseid) 
	values 
	('false', <%=maxID%>, NULL, <%=defaultPublicGroup%>, <%=origID%>, 
	<%=typeID%>, <%=courseID%>, <%=lineID%>, '<%=beginDate%>' ,NULL, <%=defaultPhaseID%>);
  </sql:query>
  <sql:execute />
</sql:statement>


<%--  sql to get maxid of table assignmentrelatedperson --%>
<% success = false; %>

  <sql:statement id="stmt2" conn="conn2">
    <sql:query>
      select max(assignmentrelatedperson.relationid)+1 as maxid from assignmentrelatedperson; 
    </sql:query>
    <sql:resultSet id="rset2">
      <sql:getColumn colName="maxid" to="maxid" scope="page"/>
      <% if (pageContext.getAttribute("maxid") != null) success = true;  %>
    </sql:resultSet>
  </sql:statement>

<%  int relID = 1;
    if (success) relID = Integer.parseInt((String)pageContext.getAttribute("maxid")); 
%>

<sql:statement id="stmt2" conn="conn2">
  <sql:query> 
	insert into assignmentrelatedperson (deleted, relationid, assignmentid, personid, roleid) 
	values
	('false', <%=relID%>, <%=maxID%>, <%=personID%>, <%=chiefRoleID%>);
  </sql:query>
  <sql:execute />
</sql:statement>


<%-- copy all raleted details --%>

  <sql:statement id="stmt2" conn="conn2">
    <sql:query>
insert into assignmentreldetail (deleted, assignmentid, detailid, allowupdate)
select 'false', <%=maxID%>, assoriginalreldetail.detailid, 'false'
from assoriginalreldetail 
where assoriginalreldetail.originalid = <%=origID%>
and   assoriginalreldetail.deleted = false;

      </sql:query>
      <sql:execute />
  </sql:statement>



<%-- copy all raleted keywords --%>

  <sql:statement id="stmt2" conn="conn2">
    <sql:query>
insert into assignmentrelkeyword (deleted, assignmentid, keywordid)
select 'false', <%=maxID%>, assoriginalrelkeyword.keywordid
from assoriginalrelkeyword 
where assoriginalrelkeyword.originalid = <%=origID%>
and   assoriginalrelkeyword.deleted = false;
      </sql:query>
      <sql:execute />
  </sql:statement>



<%-- no more available --%>

  <sql:statement id="stmt2" conn="conn2">
    <sql:query>
update assignmentoriginal
set available = (available-1)
where assignmentoriginal.originalid = <%=origID%>;

      </sql:query>
      <sql:execute />
  </sql:statement>


<% response.sendRedirect("assignmentUpdate.jsp?assid="+maxID); %>

