<%
/***************************************************************************************************
*               PAGE DESCRIPTION
****************************************************************************************************
*
*               NAME:           assignmentEvent.jsp
*               LANGUAGE:       JSP
*               DATE:           4.4.2002
*               AUTHOR:         Minna Hillebrand, University of Jyvskyl (JYU)
*               PURPOSE:        Show assignment event's details
*
****************************************************************************************************
*               COPYRIGHT (C) KOPPELO PROJECT GROUP
*               Limited rights granted. Please refer to GNU General Public License
*               http://www.gnu.org/licenses/gpl.html
****************************************************************************************************

****************************************************************************************************
*               UPDATES
****************************************************************************************************
*              
*
*
****************************************************************************************************/
%>




<%@ include file="/shared/beans.inc" %>
<%@ include file="/shared/constants.inc" %>
<%@ include file="/shared/dbconnect.inc" %>

<%
  if (request.getParameter("eventid") == null) { 
    response.sendRedirect("error.jsp?page=assignmentEvent&message=1");
    return;
    }
  String eventID = request.getParameter("eventid");
%>

  <sql:statement id="stmt2" conn="conn2">
    <sql:query>
          select 1 as id
          from   assignmentrelatedperson
          where  assignmentrelatedperson.deleted = false 
          and    assignmentrelatedperson.assignmentid = assignmentevent.assignmentid
          and    assignmentevent.eventid = <%=eventID%>
          and    assignmentrelatedperson.personid = <%=personID%>
          and    assignmentrelatedperson.roleid = assrolerelright.roleid
          and    assrolerelright.deleted = false
          and    assrolerelright.rightid = <%=allowAssDetail%> 
          union 
          select 1 as id from assusergrouprelright
          where assusergrouprelright.deleted = false
          and   assusergrouprelright.groupid = <%=userAccessLevel%>
          and   assusergrouprelright.rightid = <%=allowAssDetail%>  
          union      
          select 1 as id from asspersonrelright  
          where asspersonrelright.deleted = false
          and   asspersonrelright.personid = <%=personID%>
          and   asspersonrelright.rightid = <%=allowAssDetail%>                
    </sql:query>
    <sql:resultSet id="rset2">
      <sql:getColumn colName="id" to="did" scope="page" />
    </sql:resultSet>
  </sql:statement>

<%
  try {
    int id = Integer.parseInt((String)pageContext.getAttribute("did"));
  } catch (Exception e) {
    response.sendRedirect("errorNoAccess.jsp"); 
    return;
  }

%>

<%@ include file="/shared/header.inc" %>
<%@ include file="/shared/menus.inc" %>



<h3>Opinnytteeseen liittyvn tapahtuman tiedot</h3>

<% time timeformater = new time(); %>

<br / >
<sql:statement id="stmt2" conn="conn2">
  <sql:query>
   select assdetailtranslation.name as assname, 
          assignment.assignmentid as assid
   from  assignment, assignmentdetail, assdetailtranslation, assignmentevent 
   where assignmentevent.eventid = <%=eventID%>
   and   assignment.assignmentid = assignmentevent.assignmentid 
   and   assignmentreldetail.assignmentid = assignment.assignmentid
   and   assignmentreldetail.deleted = false  
   and   assignmentreldetail.detailid = assignmentdetail.detailid
   and   assignmentdetail.typeid = <%=titleID%> 
   and   assdetailtranslation.detailid = assignmentdetail.detailid
   and   assdetailtranslation.languageid = <%=languageID%>;
  </sql:query>
  <sql:resultSet id="rset2">
    <h4><a href="assignment.jsp?assid=<sql:getColumn colName="assid" />"><sql:getColumn colName="assname" /></a></h4> 
    <sql:getColumn colName="assid" to="assid" scope="page"/>
  </sql:resultSet>
</sql:statement>

<% String assID;
   try { 
     assID = (String)pageContext.getAttribute("assid");
   } catch (Exception e) { %><p>Sivulla tapahtui virhe.</p><% return; }
%>


<div class="in">
<table>
  <sql:statement id="stmt3" conn="conn2">
    <sql:query>
      select asseventtypetranslation.name as eventtype,
             assignmentevent.title as title,
             assignmentevent.memo as memo,
             assignmentevent.eventdate as edate,
             assignmentevent.begintime as begintime,
             assignmentevent.endtime as endtime, 
             person.firstnames as fnames, 
             person.lastname as lname,
             personparameter.personparametervalue as email
      from   asseventtypetranslation, person
      where  assignmentevent.eventid = <%=eventID%>
      and    assignmentevent.eventtypeid = asseventtypetranslation.typeid 
      and    asseventtypetranslation.languageid = <%=languageID%>
      and    assignmentevent.registratorid = assignmentrelatedperson.relationid
      and    assignmentrelatedperson.personid = person.personid
      and    person.personid = personparameter.personid
      and    personparameter.deleted = false 
      and    personparameter.personparametertypeid = 3 
    </sql:query>

    <sql:resultSet id="rset3">
      <tr>
        <td><strong><t:Tr>Tyyppi</t:Tr></strong></td> 
        <td><sql:getColumn colName="eventtype" /></td> 
      </tr>
      <tr>
        <td><strong><t:Tr>Otsikko</t:Tr></strong></td> 
        <td><sql:getColumn colName="title" /></td> 
      </tr>
      <tr>
        <td><strong><t:Tr>Kirjaaja</t:Tr></strong></td> 
        <td><sql:getColumn colName="fnames" /> <sql:getColumn colName="lname" />, <sql:getColumn colName="email" /></td> 
      </tr>
      <tr>
        <td><strong><t:Tr>Piv</t:Tr></strong></td> 
        <td><sql:getDate colName="edate" to="edate"/>
            <%=timeformater.monthToOutFormat((String)pageContext.getAttribute("edate"))%></td> 
      </tr>
      <tr>
        <td><strong><t:Tr>Aloitusaika</t:Tr></strong></td> 
        <td><sql:getColumn colName="begintime" to="btime"/>
          <% if (pageContext.getAttribute("btime") != null) { %> <%=timeformater.kloToOutFormat((String)pageContext.getAttribute("btime"))%> <% } %>
        </td> 
      </tr>
      <tr>
        <td><strong><t:Tr>Lopetusaika</t:Tr></strong></td> 
        <td><sql:getColumn colName="endtime" to="btime"/>
          <% if (pageContext.getAttribute("btime") != null) { %> <%=timeformater.kloToOutFormat((String)pageContext.getAttribute("btime"))%> <% } %>

      </tr>
      
      <tr>
        <td valign="top"><strong><t:Tr>Kuvaus</t:Tr></strong></td> 
        <td><sql:getColumn colName="memo" /></td> 
      </tr>


    </sql:resultSet>
  </sql:statement>
</table>
</div>

  <sql:statement id="stmt3" conn="conn2">
    <sql:query>
      select assignmentevent.assignmentid as assid  from
      assignmentevent
      where  assignmentevent.eventid = <%=eventID%>
    </sql:query>
    <sql:resultSet id="rset3">
      <sql:getColumn colName="assid" to="assid" scope="page" />
    </sql:resultSet>
  </sql:statement>

<% try { %>
  <sql:statement id="stmt3" conn="conn2">
    <sql:query>
      update unreadmessages set 
        deleted = true 
        where 
        assignmentrelatedperson.assignmentid = <%=(String)pageContext.getAttribute("assid")%>
        and assignmentrelatedperson.personid = <%=personID%>
        and assignmentrelatedperson.relationid = unreadmessages.asspersonid
        and unreadmessages.eventid = <%=eventID%>  
    </sql:query>
    <sql:resultSet id="rset3">
      <sql:getColumn colName="assid" to="assid" scope="page" />
    </sql:resultSet>
  </sql:statement>
<% } catch ( Exception e) {  } %>

<p><a href="addEvent.jsp?assid=<%=assID %>" ><t:Tr>Lis tapahtuma</t:Tr></a></p>
<br />

<h4><a name="events"><t:Tr>Opinnytteen kaikki tapahtumat</t:Tr></a></h4>

<div class="in">
<%--<p><a href="addEvent.jsp?assid=<%=assID %>" ><t:Tr>Lis tapahtuma</t:Tr></a></p>
--%>

<% int counter = 0; %> 
<table>
      <tr>
        <td><strong><t:Tr>Pivmr</t:Tr></strong></td>
        <td><strong><t:Tr>Tyyppi</t:Tr></strong></td>
        <td><strong><t:Tr>Otsikko</t:Tr></strong></td>
        <td><strong><t:Tr>Kirjaaja</t:Tr></strong></td>
      </tr>  <sql:statement id="stmt3" conn="conn2">
    <sql:query>
      select assignmentevent.eventid as eventid,
             asseventtypetranslation.name as eventtype,
             assignmentevent.title as title,
             assignmentevent.eventdate as eventdate,
             person.firstnames || ' ' || person.lastname as name

      from   asseventtypetranslation, person
      where  assignmentevent.deleted = 'false'
      and    assignmentevent.assignmentid = <%=assID%>
      and    assignmentevent.eventtypeid = asseventtype.typeid 
      and    asseventtype.typeid =  asseventtypetranslation.typeid
      and    asseventtypetranslation.languageid = <%=languageID%>
      and    assignmentevent.registratorid = assignmentrelatedperson.relationid
      and    assignmentrelatedperson.assignmentid = <%=assID%> 
      and    assignmentrelatedperson.personid = person.personid
      order by assignmentevent.eventdate desc;
    </sql:query>

    <sql:resultSet id="rset3" loop="true">
      <% counter++; %>
      <tr>
         <td><sql:getDate colName="eventdate" to="edate"/>
             <a href="assignmentEvent.jsp?eventid=<sql:getColumn colName="eventid" />">
             <%=timeformater.monthToOutFormat((String)pageContext.getAttribute("edate"))%></a></td> 
        <td>
            <sql:getColumn colName="eventtype" /></td> 
        <td><sql:getColumn colName="title" /></td> 
        <td><sql:getColumn colName="name" /></td> 
      </tr>
    </sql:resultSet>
  </sql:statement>
</table>
</div>

<% if (counter > 5) { %>
<p><a href="addEvent.jsp?assid=<%=assID%>" ><t:Tr>Lis tapahtuma</t:Tr></a></p>
<% } %>


<%@ include file="/shared/pageEnd.inc" %>
