<%
/***************************************************************************************************
*               PAGE DESCRIPTION
****************************************************************************************************
*
*               NAME:           assignmentGrade.jsp
*               LANGUAGE:       JSP
*               DATE:           3.5.2002
*               AUTHOR:         Minna Hillebrand, University of Jyvskyl (JYU)
*               PURPOSE:        Grade assignment related person
*
****************************************************************************************************
*               COPYRIGHT (C) KOPPELO PROJECT GROUP
*               Limited rights granted. Please refer to GNU General Public License
*               http://www.gnu.org/licenses/gpl.html
****************************************************************************************************

****************************************************************************************************
*               UPDATES
****************************************************************************************************
*              
*
*
****************************************************************************************************/
%>


<%@ include file="/shared/beans.inc" %>
<%@ include file="/shared/constants.inc" %>
<%@ include file="/shared/dbconnect.inc" %>

<%

 if (request.getParameter("assid") == null)
   response.sendRedirect("error.jsp?page=assignmentGrade&message=1") ;
 int assID = Integer.parseInt((String)request.getParameter("assid"));

%>

<%-- check right to access page --%>


<% police.setDB(db);

   boolean canUpdate = false;
   boolean canGrade  = false;
   boolean canFinish = false; 

   if ( ! police.hasPersonRight(allowGradeID, personID, assID) ) {
      response.sendRedirect("errorNoAccess.jsp"); 
      return;   
   }
   canGrade = true;

   if ( police.hasPersonRight(allowAssUpdate, personID, assID) )   canUpdate  = true;
   if ( police.hasPersonRight(allowAssFinish, personID, assID) )   canFinish = true;

%>

<%@ include file="/shared/header.inc" %>
<%@ include file="/shared/menus.inc" %>

<p>
<t:Tr><a href="assignment.jsp?assid=<%=assID%>">Opinnytteen tiedot ja tapahtumat</a></t:Tr>
<% if ( canUpdate ) { %>
| <t:Tr><a href="assignmentUpdate.jsp?assid=<%=assID %>">Muuta tietoja</a></t:Tr>
| <t:Tr><a href="addEvent.jsp?assid=<%=assID%>">Lis tapahtuma</a></t:Tr>
| <t:Tr><a href="assignmentUpdatePerson.jsp?assid=<%=assID %>">Lis/poista henkilit</a></t:Tr>
| <t:Tr><a href="assignmentUpdateTask.jsp?assid=<%=assID %>">Pivit tytehtvi</a></t:Tr>
<% } %>
<% if ( canFinish ) { %>
| <t:Tr><a href="assignmentGradeFinish.jsp?assid=<%=assID %>">Opinnytteen hyvksyminen</a></t:Tr>
<% } %>
</p>


<% time timeformater = new time(); %>


<h3><t:Tr>Opiskelijan arviointi</t:Tr></h3>

<br />
<sql:statement id="stmt2" conn="conn2">
  <sql:query>
   select assdetailtranslation.name as assname

   from  assignment
   where assignment.deleted = false
   and   assignment.assignmentid = <%=assID%>
   and   assignmentreldetail.assignmentid = assignment.assignmentid
   and   assignmentreldetail.deleted = false  
   and   assignmentreldetail.detailid = assignmentdetail.detailid
   and   assignmentdetail.typeid = <%=titleID%> 
   and   assdetailtranslation.detailid = assignmentdetail.detailid
   and   assdetailtranslation.languageid = <%=languageID%>;
  </sql:query>
  <sql:resultSet id="rset2">
    <h4><a href="assignment.jsp?assid=<%=assID%>"><sql:getColumn colName="assname" /></a></h4> 
  </sql:resultSet>
</sql:statement>


<br />


<h4><t:Tr>Opiskelijoiden nykyiset arvioinnit</t:Tr></h4>

<div class="in">
<table>
  <tr>
    <td><strong><t:Tr>Arvostelupiv</t:Tr></strong></td>
    <td><strong><t:Tr>Opiskelija</t:Tr></strong></td>
    <td><strong><t:Tr>Arvioitsija</t:Tr></strong></td>
    <td><strong><t:Tr>Arvolause</t:Tr></strong></td>
    <td><strong><t:Tr>OV</t:Tr></strong></td>

  </tr>
  <sql:statement id="stmt2" conn="conn2">
    <sql:query>
       select assignmentfinished.persontobegradedid as studentgrade,
              Stu.firstnames || ' ' || Stu.lastname as stuname,
              assignmentfinished.gradedate,  
              GradedBy.personid as gradeperson,
              GradedBy.relationid as gradedbyid,
              Tea.firstnames || ' ' || Tea.lastname as teaname,
              gradetranslation.name as grade,
              trunc(assignmentfinished.credits) as credits
       from   assignmentfinished, assignmentrelatedperson as Student, assignmentrelatedperson as GradedBy,
              person as Stu, person as Tea
       where  assignmentfinished.deleted = false
       and    assignmentfinished.gradedbyid = GradedBy.relationid
       and    GradedBy.assignmentid = <%=assID%>
       and    GradedBy.deleted = false
       and    GradedBy.personid = Tea.personid 
       and    assignmentfinished.persontobegradedid = Student.relationid
       and    Student.deleted = false
       and    Student.personid = Stu.personid
       and    Student.assignmentid = <%=assID%>
       and    assignmentfinished.gradeid = grade.gradeid
       and    grade.gradeid = gradetranslation.gradeid
       and    gradetranslation.languageid = <%=languageID%>  
       order by gradedate desc;
    </sql:query>
    <sql:resultSet id="rset2"> 
    <tr><sql:getColumn colName="gradeperson" to="gradeperson" />
      <% if ( Integer.parseInt((String)pageContext.getAttribute("gradeperson")) == personID ) { %> 
      <td><a href="assignmentGrade.jsp?assid=<%=assID%>&studentgrade=<sql:getColumn colName="studentgrade" />">
          <sql:getColumn colName="gradedate" to="gdate" />
          <%=timeformater.monthToOutFormat((String)pageContext.getAttribute("gdate"))%></td> 
       <% } else { %>
      <td><%--<a href="assignmentGradeStudent?assid=<%=assID%>&teacher=<sql:getColumn colName="gradedbyid">--%><sql:getColumn colName="gradedate" /><%--</a>--%></td> 
       <% } %>      <td><sql:getColumn colName="stuname" /></td>
      <td><sql:getColumn colName="teaname" /></td>
      <td>&nbsp;&nbsp;<sql:getColumn colName="grade" /></td>
      <td>&nbsp;&nbsp;<sql:getColumn colName="credits" /></td>
    </tr>   
    </sql:resultSet>
  </sql:statement>
</table>
</div>


<br />
<%  if (request.getParameter("studentgrade") == null) { %>
<h4><t:Tr>Uusi arvostelu</t:Tr></h4>
<% } else { %>
<h4><t:Tr>Oppilaan arvostelu</t:Tr></h4>
<% } %>

<%   
   java.util.Date today = new java.util.Date();
   java.text.SimpleDateFormat parser = new java.text.SimpleDateFormat("dd.MM.yyyy");

%>


<%-- Get the information of inserted grade --%>

<%

  String srel="0";
  String trel="0";
  String gradedate = parser.format(today); 
  String memo="";
  String credits="";
  String gradeid="0";   
  boolean hasValues = false;

  if (request.getParameter("studentgrade") != null) { 
%>
<sql:statement id="stmt3" conn="conn2">
  <sql:query>
    select 
           Studentrel.relationid as srel,
           Teacherrel.relationid as trel,
           assignmentfinished.memo as memo,
           trunc(assignmentfinished.credits) as credits,
           assignmentfinished.gradedate as gradedate,
           assignmentfinished.gradeid as gradeid
    from   assignmentfinished, assignmentrelatedperson as Studentrel, 
                               assignmentrelatedperson as Teacherrel
    where  assignmentfinished.deleted = false
    and    Studentrel.assignmentid = <%=assID%> 
    and    Studentrel.relationid = <%=request.getParameter("studentgrade")%>
    and    Studentrel.relationid = assignmentfinished.persontobegradedid
    and    assignmentfinished.gradedbyid = Teacherrel.relationid
    and    Teacherrel.assignmentid = <%=assID%>
    and    Teacherrel.personid =  <%=personID%>

  </sql:query>
  <sql:resultSet id="rset3">
    <sql:getColumn colName="srel" to="srel" scope="page" />
    <sql:getColumn colName="trel" to="trel" scope="page" />
    <sql:getColumn colName="memo" to="memo" scope="page" />
    <sql:getColumn colName="credits" to="credits" scope="page" />
    <sql:getColumn colName="gradeid" to="gradeid" scope="page" />
    <sql:getColumn colName="gradedate" to="gradedate" scope="page" />
  </sql:resultSet>
</sql:statement>

<%
  if ( pageContext.getAttribute("trel") != null ) {
    trel = (String)pageContext.getAttribute("trel");
    srel = (String)pageContext.getAttribute("srel");
    memo = (String)pageContext.getAttribute("memo");
    credits = (String)pageContext.getAttribute("credits");
    gradedate = timeformater.monthToOutFormat((String)pageContext.getAttribute("gradedate"));
    gradeid = (String)pageContext.getAttribute("gradeid");
    hasValues = true;
  }
 

 } %>



<% if (request.getParameter("updated") != null) { 
     if ( ((String)request.getParameter("error")).equals("") ) { %> <h4><t:Tr>Tiedot tallennettu</t:Tr></h4> <% }
     else { %> <h4><t:Tr><%=request.getParameter("error")%></t:Tr></h4> <% } 
   }
%>

<form method="post" action="assignmentGradeInsert.jsp">
<input type="hidden" name="assid" value="<%=assID%>" />
<% if (hasValues) { %>
<input type="hidden" name="update" value="<%=srel%>" />
<% } %>


<% String selected=""; %>

<table>
    <tr>
      <td valign="top"><strong><t:Tr>Opiskelija </t:Tr></strong></td>
<td>
<select id="student" name="studentid">
  <sql:statement id="stmt4" conn="conn2">
    <sql:query>
     select person.firstnames || ' ' || person.lastname as name,
            assignmentrelatedperson.relationid as pid
     from   assignmentrelatedperson
     where  assignmentrelatedperson.deleted = false
     and    assignmentrelatedperson.assignmentid = <%=assID%>
     and    assignmentrelatedperson.roleid = <%=studentID%>
     and    assignmentrelatedperson.personid = person.personid       
     and    person.deleted = false 
     order by person.lastname       
    </sql:query>
    <sql:resultSet id="rset2" loop="true">
      <sql:getColumn colName="pid" to="pid" scope="page" />
      <% selected="";
         if ( pageContext.getAttribute("pid") != null && 
              srel.equals((String)pageContext.getAttribute("pid")) ) 
              selected = "selected=\"selected\""; %> 
      <option <%=selected%> value="<sql:getColumn colName="pid" />"><sql:getColumn colName="name" /></option>  
    </sql:resultSet>
  </sql:statement>
</select>
<% if (pageContext.getAttribute("pid") == null) { %>
<p> Opinnytteeseen ei ole liitetty henkilit. 
    Arvostelua ei voida suorittaa.</p> 
</td>
</table>
</form>
</div>

<%@ include file="/shared/pageEnd.inc" %>

<% return; } %>

</td>

    </tr>
    <tr>
      <td><strong><t:Tr>Arvioitsija </t:Tr></strong></td>
      <input type="hidden" name="gradedby" value="<%=trel%>" />
      <td><%=user.getFirstNames()%> <%=user.getLastName()%></td>
    </tr>
    <tr>
      <td><strong><t:Tr>Arviointipiv </t:Tr></strong></td>
      <td><input type="text" name="gradedate" value="<%=gradedate%>" size="12" /></td>
    </tr>
    <tr>
      <td><strong><t:Tr>Arvolause </t:Tr></strong></td>
<td>
<select id="grade" name="gradeid">
  <sql:statement id="stmt4" conn="conn2">
    <sql:query>
      select gradetranslation.name as name,
             grade.gradeid as gradeid
      from   gradetranslation
      where  grade.deleted = false
      and    grade.gradeid = gradetranslation.gradeid
      and    gradetranslation.deleted = false
      and    gradetranslation.languageid = <%=languageID%>
      order by grade.belongsingroup asc, gradeid

    </sql:query>
    <sql:resultSet id="rset2" loop="true">
      <sql:getColumn colName="gradeid" to="gid" scope="page" />
      <% selected ="";
         if ( pageContext.getAttribute("gid") != null && 
              gradeid.equals((String)pageContext.getAttribute("gid")) ) 
              selected = "selected=\"selected\""; %> 
       <option <%=selected%> value="<sql:getColumn colName="gradeid" />"><sql:getColumn colName="name" /></option>  
    </sql:resultSet>
  </sql:statement>
</select>
</td>
     
    </tr>    
    <tr>
      <td valign="top"><strong><t:Tr>Arvio </t:Tr></strong></td>
      <td><textarea name="memo" cols="50" rows="10"><%=memo%></textarea></td>
    </tr>    
    <tr>
      <td><strong><t:Tr>Opintoviikot </t:Tr></strong></td>
      <td><input type="text" name="credits" value="<%=credits%>" size="5" /></td>
    </tr>

  </sql:resultSet>
</sql:statement>

</table>

<p>
<% if (hasValues) { %>
<input type="submit" name="update" value="Tallenna muutokset" /> &nbsp; &nbsp;
<% } %>
<input type="submit" name="new" value="Tallenna uusi arvostelu" />
</p>

<p>
<t:Tr><a href="assignment.jsp?assid=<%=assID%>">Opinnytteen tiedot ja tapahtumat</a></t:Tr>
<% if ( canUpdate ) { %>
| <t:Tr><a href="assignmentUpdate.jsp?assid=<%=assID %>">Muuta tietoja</a></t:Tr>
| <t:Tr><a href="addEvent.jsp?assid=<%=assID%>">Lis tapahtuma</a></t:Tr>
| <t:Tr><a href="assignmentUpdatePerson.jsp?assid=<%=assID %>">Lis/poista henkilit</a></t:Tr>
| <t:Tr><a href="assignmentUpdateTask.jsp?assid=<%=assID %>">Pivit tytehtvi</a></t:Tr>
<% } %>
<% if ( canFinish ) { %>
| <t:Tr><a href="assignmentGradeFinish.jsp?assid=<%=assID %>">Opinnytteen hyvksyminen</a></t:Tr>
<% } %>
</p>

</div>
</form>



<%@ include file="/shared/pageEnd.inc" %>


