<%
/***************************************************************************************************
*               PAGE DESCRIPTION
****************************************************************************************************
*
*               NAME:           assignmentGradeFinish.jsp
*               LANGUAGE:       JSP
*               DATE:           15.5.2002
*               AUTHOR:         Minna Hillebrand, University of Jyvskyl (JYU)
*               PURPOSE:        Add grades to KOTKA database
*
****************************************************************************************************
*               COPYRIGHT (C) KOPPELO PROJECT GROUP
*               Limited rights granted. Please refer to GNU General Public License
*               http://www.gnu.org/licenses/gpl.html
****************************************************************************************************

****************************************************************************************************
*               UPDATES
****************************************************************************************************
*              
*
*
****************************************************************************************************/
%>


<%@ include file="/shared/beans.inc" %>
<%@ include file="/shared/constants.inc" %>
<%@ include file="/shared/dbconnect.inc" %>

<%

 if (request.getParameter("assid") == null)
   response.sendRedirect("error.jsp?page=assignmentGradeFinish&message=1") ;
 int assID = Integer.parseInt((String)request.getParameter("assid"));

%>

<%-- check right to access page --%>

<% police.setDB(db);

   boolean canUpdate = false;
   boolean canGrade  = false;
   boolean canFinish = false; 

   if ( ! police.hasPersonRight(allowAssFinish, personID, assID) ) {
      response.sendRedirect("errorNoAccess.jsp"); 
      return;   
   }
   canFinish = true;

   if ( police.hasPersonRight(allowAssUpdate, personID, assID) )  canUpdate  = true;
   if ( police.hasPersonRight(allowGradeID, personID, assID) )    canGrade   = true;

%>


<%@ include file="/shared/header.inc" %>
<%@ include file="/shared/menus.inc" %>


<% time timeformater = new time(); %>

<p>
<t:Tr><a href="assignment.jsp?assid=<%=assID%>">Opinnytteen tiedot ja tapahtumat</a></t:Tr>
<% if ( canUpdate ) { %>
| <t:Tr><a href="assignmentUpdate.jsp?assid=<%=assID %>">Muuta tietoja</a></t:Tr>
| <t:Tr><a href="addEvent.jsp?assid=<%=assID%>">Lis tapahtuma</a></t:Tr>
| <t:Tr><a href="assignmentUpdatePerson.jsp?assid=<%=assID %>">Lis/poista henkilit</a></t:Tr>
| <t:Tr><a href="assignmentUpdateTask.jsp?assid=<%=assID %>">Pivit tytehtvi</a></t:Tr>
<% } %>
<% if ( canGrade ) { %>
| <t:Tr><a href="assignmentGrade.jsp?assid=<%=assID %>">Arvioi opiskelija</a></t:Tr>
<% } %>
</p>


<h3><t:Tr>Opiskelijoiden arviointien vienti KORPPI-jrjestelmn kantaan</t:Tr></h3>

<br />
<sql:statement id="stmt2" conn="conn2">
  <sql:query>
   select assdetailtranslation.name as assname,
          course.code as code

   from  assignment
   where assignment.deleted = false
   and   assignment.assignmentid = <%=assID%>
   and   assignmentreldetail.assignmentid = assignment.assignmentid
   and   assignmentreldetail.deleted = false  
   and   assignmentreldetail.detailid = assignmentdetail.detailid
   and   assignmentdetail.typeid = <%=titleID%> 
   and   assdetailtranslation.detailid = assignmentdetail.detailid
   and   assdetailtranslation.languageid = <%=languageID%>
   and   assignment.courseid = course.courseid 
  </sql:query>
  <sql:resultSet id="rset2">
    <h4><a href="assignment.jsp?assid=<%=assID%>"><sql:getColumn colName="assname" /></a></h4> 
    <sql:getColumn colName="code" to="code" scope="page" />
  </sql:resultSet>
</sql:statement>

<% String courseCode = (String)pageContext.getAttribute("code"); %>

<br />


<h4><t:Tr>Opiskelijoiden nykyiset arvioinnit</t:Tr></h4>

<div class="in">
<table>
  <tr>
    <td><strong><t:Tr>Arvostelupiv</t:Tr></strong></td>
    <td><strong><t:Tr>Opiskelija</t:Tr></strong></td>
    <td><strong><t:Tr>Arvioitsija</t:Tr></strong></td>
    <td><strong><t:Tr>Arvolause</t:Tr></strong></td>
    <td><strong><t:Tr>Opintoviikot</t:Tr></strong></td>

  </tr>
  <sql:statement id="stmt2" conn="conn2">
    <sql:query>
       select assignmentfinished.persontobegradedid as studentgrade,
              Stu.firstnames || ' ' || Stu.lastname as stuname,
              assignmentfinished.gradedate,  
              GradedBy.personid as gradeperson,
              GradedBy.relationid as gradedbyid,
              Tea.firstnames || ' ' || Tea.lastname as teaname,
              gradetranslation.name as grade,
              trunc(assignmentfinished.credits) as credits
       from   assignmentfinished, assignmentrelatedperson as Student, assignmentrelatedperson as GradedBy,
              person as Stu, person as Tea
       where  assignmentfinished.deleted = false
       and    assignmentfinished.gradedbyid = GradedBy.relationid
       and    GradedBy.assignmentid = <%=assID%>
       and    GradedBy.deleted = false
       and    GradedBy.personid = Tea.personid 
       and    assignmentfinished.persontobegradedid = Student.relationid
       and    Student.deleted = false
       and    Student.personid = Stu.personid
       and    Student.assignmentid = <%=assID%>
       and    assignmentfinished.gradeid = grade.gradeid
       and    grade.gradeid = gradetranslation.gradeid
       and    gradetranslation.languageid = <%=languageID%>  
       order by gradedate desc, Stu.lastname desc;
    </sql:query>
    <sql:resultSet id="rset2"> 
    <tr><sql:getColumn colName="gradeperson" to="gradeperson" />
      <% if ( Integer.parseInt((String)pageContext.getAttribute("gradeperson")) == personID ) { %> 
      <td><a href="assignmentGrade.jsp?assid=<%=assID%>&studentgrade=<sql:getColumn colName="studentgrade" />">
          <sql:getColumn colName="gradedate" to="gdate" />
          <%=timeformater.monthToOutFormat((String)pageContext.getAttribute("gdate"))%></td> 
       <% } else { %>
      <td><%--<a href="assignmentGradeStudent?assid=<%=assID%>&teacher=<sql:getColumn colName="gradedbyid">--%><sql:getColumn colName="gradedate" /><%--</a>--%></td> 
       <% } %>      <td><sql:getColumn colName="stuname" /></td>
      <td><sql:getColumn colName="teaname" /></td>
      <td>&nbsp;&nbsp;<sql:getColumn colName="grade" /></td>
      <td><sql:getColumn colName="credits" /></td>
    </tr>   
    </sql:resultSet>
  </sql:statement>
</table>
</div>


<br />

<h4><t:Tr>Opinnytteen hyvksyminen ja loppuarviointi</t:Tr></h4>


<%   
   java.util.Date today = new java.util.Date();
   java.text.SimpleDateFormat parser = new java.text.SimpleDateFormat("dd.MM.yyyy");

%>


<form action="assignmentGradeFinishInsert.jsp" method="post" >
<input type="hidden" name="assid" value="<%=assID%>" />
<input type="hidden" name="coursecode" value="<%=courseCode%>" />

<div class="in">

<p>Arviointi tehdn kurssikoodille <%=courseCode%>.</p>

<table>
  <tr>
    <td><strong><t:Tr>Opiskelija</t:Tr></strong></td>
    <td><strong><t:Tr>Arviointipiv</t:Tr></strong></td>
    <td><strong><t:Tr>Arvolause</t:Tr></strong></td>
    <td><strong><t:Tr>Opintoviikot</t:Tr></strong></td>

  </tr>
  <sql:statement id="stmt2" conn="conn2">
    <sql:query>
       select Stu.firstnames || ' ' || Stu.lastname as stuname,
              Stu.personid as personid  
       from   assignmentrelatedperson as Student,
              person as Stu
       where  Student.deleted = false
       and    Student.assignmentid = <%=assID%>
       and    Student.roleid = <%=studentID%>
       and    Student.personid = Stu.personid
       order by Stu.lastname, Stu.firstnames 
    </sql:query>
    <sql:resultSet id="rset2"> 
      <sql:getColumn colName="personid" to="personid" scope="page" />
    <tr>    

<%-- HAETAAN VANHAT TIEDOT FINISHED-TAULUSTA  --%>

  <sql:statement id="stmt8" conn="conn2">
    <sql:query>
       select  finished.gradeid as gradeid,
               finished.credits as credits,
               finished.finishedon as fdate

        from   finished
        where  finished.deleted = false
        and    finished.person1id = <%=pageContext.getAttribute("personid")%>
        and    finished.code like '<%=courseCode%>'
        and    finished.person2id = <%=personID%>

    </sql:query>
    <sql:resultSet id="rset8"> 
       <sql:getColumn colName="gradeid" to="currgrade" scope="page" />
       <sql:getColumn colName="credits" to="currcredits" scope="page" /> 
       <sql:getColumn colName="fdate" to="currfdate" scope="page" /> 
    </sql:resultSet>
  </sql:statement>


      <td><sql:getColumn colName="stuname" />
          <input type="hidden" name="studentid" value="<sql:getColumn colName="personid" />" /></td>

<%-- ARVOSTELUPIV --%>
      <% String fdate = parser.format(today);
         if ( pageContext.getAttribute("currfdate") != null ) 
           fdate = timeformater.monthToOutFormat(((String)pageContext.getAttribute("currfdate")).substring(0, 10));  
      %>
      <td><input type="text" name="gradedate" value="<%=fdate%>" size="12"></td>


<%-- ARVOSANA --%>

      <% String currgrade = "0";
         if ( pageContext.getAttribute("currgrade") != null ) 
           currgrade = (String)pageContext.getAttribute("currgrade");  
         String selected = ""; 
      %>
      <td>
<select name="gradeid">
  <sql:statement id="stmt5" conn="conn2">
    <sql:query>
       select  gradetranslation.name as name,
               grade.gradeid as gradeid
        from   gradetranslation
        where  grade.deleted = false
        and    grade.gradeid = gradetranslation.gradeid
        and    gradetranslation.deleted = false
        and    gradetranslation.languageid = <%=languageID%>
        order by grade.belongsingroup desc, gradetranslation.name asc
    </sql:query>
    <sql:resultSet id="rset5" loop="true">
      <sql:getColumn colName="gradeid" to="grid" scope="page" />
      <% selected ="";
         if ( ((String)pageContext.getAttribute("grid")).equals(currgrade) ) 
           selected="selected=\"selected\""; %>  
      <option <%=selected%> value="<sql:getColumn colName="gradeid" />"><sql:getColumn colName="name" /></option>
    </sql:resultSet>
  </sql:statement> 
</select>

      </td>

<%-- OPINTOVIIKOT --%>

      <% double credits = 0;
         if ( pageContext.getAttribute("currcredits") != null ) 
           credits = java.lang.Double.parseDouble((String)pageContext.getAttribute("currcredits"));  
      %>
      <td>&nbsp;&nbsp;&nbsp;<input type="text" name="credits" value="<%=credits%>" size="5"></td>

    </tr>   
    </sql:resultSet>
  </sql:statement>
</table>
</div>

<br />
<input type="submit" name="update" value="<t:Tr>Tallenna arvostelut</t:Tr>">
<input type="submit" name="submitJORE" value="<t:Tr>Tallenna ja lhet tulokset JOREEN</t:Tr>">
</form>

<p>
<t:Tr><a href="assignment.jsp?assid=<%=assID%>">Opinnytteen tiedot ja tapahtumat</a></t:Tr>
<% if ( canUpdate ) { %>
| <t:Tr><a href="assignmentUpdate.jsp?assid=<%=assID %>">Muuta tietoja</a></t:Tr>
| <t:Tr><a href="addEvent.jsp?assid=<%=assID%>">Lis tapahtuma</a></t:Tr>
| <t:Tr><a href="assignmentUpdatePerson.jsp?assid=<%=assID %>">Lis/poista henkilit</a></t:Tr>
| <t:Tr><a href="assignmentUpdateTask.jsp?assid=<%=assID %>">Pivit tytehtvi</a></t:Tr>
<% } %>
<% if ( canGrade ) { %>
| <t:Tr><a href="assignmentGrade.jsp?assid=<%=assID %>">Arvioi opiskelija</a></t:Tr>
<% } %>
</p>

<%@ include file="/shared/pageEnd.inc" %>


