<%
/***************************************************************************************************
*               PAGE DESCRIPTION
****************************************************************************************************
*
*               NAME:           assignmentGradeFinishInsert.jsp
*               LANGUAGE:       JSP
*               DATE:           15.5.2002
*               AUTHOR:         Minna Hillebrand, University of Jyvskyl (JYU)
*               PURPOSE:        Insert or update assignment grade to KOTKA database
*
****************************************************************************************************
*               COPYRIGHT (C) KOPPELO PROJECT GROUP
*               Limited rights granted. Please refer to GNU General Public License
*               http://www.gnu.org/licenses/gpl.html
****************************************************************************************************

****************************************************************************************************
*               UPDATES
****************************************************************************************************
*              
*
*
****************************************************************************************************/
%>


<%@ include file="/shared/beans.inc" %>
<%@ include file="/shared/constants.inc" %>
<%@ include file="/shared/dbconnect.inc" %>


<%
  if (request.getParameter("assid") == null) {
    response.sendRedirect("error.jsp?page=assignmentGradeFinishInsert.jsp&message=1") ;
    return;
  }
  String assID = (String)request.getParameter("assid");


   police.setDB(db);

   boolean canFinish = false; 
   boolean canUpdate = false;
   boolean canGrade  = false;
   try {
   if ( ! police.hasPersonRight(allowAssFinish, personID, Integer.parseInt(assID)) ) {
      response.sendRedirect("errorNoAccess.jsp"); 
      return;   
   }
   canFinish = true;
   } catch (Exception nullvalue) {
      response.sendRedirect("error.jsp?page=assignmentGradeFinishInsert.jsp&message=2") ;
      return;
  }

   if ( police.hasPersonRight(allowAssUpdate, personID, Integer.parseInt(assID)) )   canUpdate  = true;
   if ( police.hasPersonRight(allowGradeID, personID, Integer.parseInt(assID)) )     canGrade = true;


  time timeformater = new time(); 



 if ( request.getParameter("coursecode") == null ||
      request.getParameter("studentid") == null ||
      request.getParameter("gradedate") == null || 
      request.getParameter("gradeid") == null   ||  
      request.getParameter("credits") == null  
 ) {
    response.sendRedirect("error.jsp?message=1&page=assignmentGradeFinishInsert") ;
    return;
 }


  String students[] = new String[20];
  students = request.getParameterValues("studentid");

  String dates[] = new String[20];
  dates = request.getParameterValues("gradedate");

  String grades[] = new String[20];
  grades = request.getParameterValues("gradeid");

  String credits[] = new String[20];
  credits = request.getParameterValues("credits");


  int i = 0;
  String errormsg;

  for (i=0; i < students.length; i++) { 

   errormsg="";

   double Dcredits = 0;
    try {
      Dcredits = java.lang.Double.parseDouble(credits[i]);
      if (Dcredits < 0 ) {
        Dcredits = 0;
        errormsg += "Annoit opintoviikot vrin! ";
      } 
    } catch (Exception e) { Dcredits = 0; errormsg += "Annoit laittomat opintoviikkoarvon"; }
 

    try {
%>
  <sql:statement id="stmt3" conn="conn2">
    <sql:query>
       update finished
       set    deleted = true 
       where  person1id = <%=students[i]%>
       and    person2id = <%=personID%>
       and    code = '<%=request.getParameter("coursecode")%>'
    </sql:query>
    <sql:execute /> 
  </sql:statement>


<sql:statement id="stmt3" conn="conn2">
  <sql:query>
    insert into finished 
     (deleted, person1id, person2id, courseinstanceid, gradeid, credits, code, finishedon)
    values (false, <%=students[i]%>, <%=personID%>, 1, <%=grades[i]%>, 
            <%=Dcredits%>, '<%=request.getParameter("coursecode")%>', '<%=timeformater.monthToDBFormat(dates[i])%>')
  </sql:query>
  <sql:execute /> 
</sql:statement>

<%  } catch (Exception e) {

       try {
%>
  <sql:statement id="stmt3" conn="conn2">
    <sql:query>
       update finished 
       set    finishedon = '<%=timeformater.monthToDBFormat(dates[i])%>',
              gradeid = <%=grades[i]%>,
              credits = <%=Dcredits%>
       where  person1id = <%=students[i]%>
       and    person2id = <%=personID%>
       and    code = '<%=request.getParameter("coursecode")%>'
       and    deleted = false
    </sql:query>
    <sql:execute /> 
  </sql:statement>
<%
       } catch (Exception ef) {
          errormsg += "<p>Tietojen tallennuksessa tapahtui virhe. Unohditko antaa joitain arvoja tai annoitko virheellisen arvon?</p>";
       } 
    }
%>
<%=errormsg%>
<%
  }

%>

  <sql:statement id="stmt3" conn="conn2">
    <sql:query>
       update assignment
       set    phaseid = <%=readyAssignmentID%>,
              finisheddate = current_date
       where  assignmentid = <%=assID%>
    </sql:query>
    <sql:execute />
  </sql:statement>




<%@ include file="/shared/header.inc" %>
<%@ include file="/shared/menus.inc" %>

<h3><t:Tr>Arvosanat tallennettu</t:Tr></h3>
<p><t:Tr>Arvostelut on tallennettu KORPPI-jrjestelmn kantaan. Opinnytteen vaiheeksi on 
         asetettu 'Hyvksytty'.</t:Tr></p>
<p>Arvostelujen vieminen JOREEN on toistaiseksi jtetty jatkokehityksess 
   toteutettavaksi.</p>


<p>
<t:Tr><a href="assignment.jsp?assid=<%=assID%>">Opinnytteen tiedot ja tapahtumat</a></t:Tr>
<% if ( canUpdate ) { %>
| <t:Tr><a href="assignmentUpdate.jsp?assid=<%=assID %>">Muuta tietoja</a></t:Tr>
| <t:Tr><a href="addEvent.jsp?assid=<%=assID%>">Lis tapahtuma</a></t:Tr>
| <t:Tr><a href="assignmentUpdatePerson.jsp?assid=<%=assID %>">Lis/poista henkilit</a></t:Tr>
| <t:Tr><a href="assignmentUpdateTask.jsp?assid=<%=assID %>">Pivit tytehtvi</a></t:Tr>
<% } %>
<% if ( canGrade ) { %>
| <t:Tr><a href="assignmentGradeFinish.jsp?assid=<%=assID %>">Arvioi opiskelija</a></t:Tr>
<% } %>
<% if ( canFinish ) { %>
| <t:Tr><a href="assignmentGradeFinish.jsp?assid=<%=assID %>">Opinnytteen hyvksyminen</a></t:Tr>
<% } %>
</p>


<%@ include file="/shared/pageEnd.inc" %>

