<%
/***************************************************************************************************
*               PAGE DESCRIPTION
****************************************************************************************************
*
*               NAME:           assignmentGradeInsert.jsp
*               LANGUAGE:       JSP
*               DATE:           3.5.2002
*               AUTHOR:         Minna Hillebrand, University of Jyvskyl (JYU)
*               PURPOSE:        Insert or update assignment grade
*
****************************************************************************************************
*               COPYRIGHT (C) KOPPELO PROJECT GROUP
*               Limited rights granted. Please refer to GNU General Public License
*               http://www.gnu.org/licenses/gpl.html
****************************************************************************************************

****************************************************************************************************
*               UPDATES
****************************************************************************************************
*              
*
*
****************************************************************************************************/
%>


<%@ include file="/shared/beans.inc" %>
<%@ include file="/shared/constants.inc" %>
<%@ include file="/shared/dbconnect.inc" %>

<%

 if (request.getParameter("assid") == null) {
   response.sendRedirect("error.jsp?page=assignmentGradeInsert.jsp&message=1") ;
   return;
 }

   int assID = 0;
   try {
     assID = Integer.parseInt((String)request.getParameter("assid"));
   } catch (Exception novalue) { response.sendRedirect("error.jsp?message=2&page=assignmentGradeInsert"); return;  }


   time timeformater = new time(); 

   police.setDB(db);
   boolean canGrade  = false;

   if ( ! police.hasPersonRight(allowGradeID, personID, assID) ) {
      response.sendRedirect("errorNoAccess.jsp"); 
      return;   
   }



 if ( request.getParameter("studentid") == null ||
      request.getParameter("gradedate") == null || 
      request.getParameter("gradedby") == null || 
      request.getParameter("memo") == null || 
      request.getParameter("gradeid") == null    ) { 
    response.sendRedirect("error.jsp?message=1&page=assignmentGradeInsert.jsp") ;
    return;
 }


 String errormsg="";

  double credits = 0;
  if ( request.getParameter("credits") != null ) {
    try {
      credits = java.lang.Double.parseDouble((String)request.getParameter("credits"));
      if (credits < 0 ) {
        credits = 0;
        errormsg += "Annoit opintoviikot vrin! ";
      } 
    } catch (Exception e) { credits = 0; errormsg += "Annoit laittomat opintoviikkoarvon"; }
  }


  if ( request.getParameter("new") != null ) {
  
    try {
%>

<sql:statement id="stmt3" conn="conn2">
  <sql:query>
    insert into assignmentfinished 
     (deleted, persontobegradedid, gradedbyid, gradeid, gradedate, credits, memo)
     select 'false', <%=request.getParameter("studentid")%>, assignmentrelatedperson.relationid,
           <%=request.getParameter("gradeid")%>, '<%=timeformater.monthToDBFormat(request.getParameter("gradedate"))%>', 
           <%=credits%>, '<%=request.getParameter("memo")%>' 
     from   assignmentrelatedperson
     where  assignmentrelatedperson.personid = <%=personID%>
     and    assignmentrelatedperson.assignmentid = <%=request.getParameter("assid")%>
  </sql:query>
  <sql:execute /> 
</sql:statement>
<%  } catch (Exception e) { 
       errormsg += "Tietojen tallennuksessa tapahtui virhe. Unohditko antaa joitain arvoja? Tarkasta, ette ole jo arvioinut ko. opiskelijaa."; 
    }

   response.sendRedirect("assignmentGrade.jsp?updated=true&studentgrade="+
                         (String)request.getParameter("studentid") +
                         "&assid="+(String)request.getParameter("assid") +
                         "&error="+errormsg); 
   return;
 }

// else we update existing grading

 try {

%>

<sql:statement id="stmt3" conn="conn2">
  <sql:query>
    update assignmentfinished
    set    persontobegradedid = <%=request.getParameter("studentid")%>, 
           gradeid = <%=request.getParameter("gradeid")%>, 
           gradedate = '<%=request.getParameter("gradedate")%>', 
           credits = <%=credits%>, 
           memo = '<%=request.getParameter("memo")%>' 
    where assignmentfinished.persontobegradedid = <%=request.getParameter("update")%> 
    and   assignmentfinished.gradedbyid = <%=request.getParameter("gradedby")%>

  </sql:query>
  <sql:execute /> 
</sql:statement>

<%  } catch (Exception e) { errormsg += "Tietojen tallennuksessa tapahtui virhe. Tarkasta, ettet ole jo arvioinut ko. opiskelijaa."; }


   response.sendRedirect("assignmentGrade.jsp?updated=true&studentgrade="+
                         (String)request.getParameter("studentid") +
                         "&assid="+(String)request.getParameter("assid")+
                         "&error="+errormsg);


%>

