<%
/***************************************************************************************************
*               PAGE DESCRIPTION
****************************************************************************************************
*
*               NAME:           assignmentGradeStudent.jsp
*               LANGUAGE:       JSP
*               DATE:           3.5.2002
*               AUTHOR:         Minna Hillebrand, University of Jyvskyl (JYU)
*               PURPOSE:        Grade details for student
*
****************************************************************************************************
*               COPYRIGHT (C) KOPPELO PROJECT GROUP
*               Limited rights granted. Please refer to GNU General Public License
*               http://www.gnu.org/licenses/gpl.html
****************************************************************************************************

****************************************************************************************************
*               UPDATES
****************************************************************************************************
*              
*
*
****************************************************************************************************/
%>


<%@ include file="/shared/beans.inc" %>
<%@ include file="/shared/constants.inc" %>
<%@ include file="/shared/dbconnect.inc" %>

<%

 if (request.getParameter("assid") == null)
   response.sendRedirect("error.jsp&page=assignmentGradeStudent.jsp&message=1") ;
 int assID = Integer.parseInt((String)request.getParameter("assid"));

%>


<%-- check right to access page --%>

  <sql:statement id="stmt2" conn="conn2">
    <sql:query>
          select 1 as id
          from   assignmentrelatedperson
          where  assignmentrelatedperson.deleted = false 
          and    assignmentrelatedperson.assignmentid = <%=assID%>
          and    assignmentrelatedperson.personid = <%=personID%>
          and    assignmentrelatedperson.roleid = <%=studentID%>
    </sql:query>
    <sql:resultSet id="rset2">
      <sql:getColumn colName="id" to="gid" scope="page" />
    </sql:resultSet>
  </sql:statement>
<%
  try {
    if ( Integer.parseInt((String)pageContext.getAttribute("gid")) != 1 ) {
       response.sendRedirect("errorNoAccess.jsp"); 
       return;
    } 
  } catch (Exception e) { response.sendRedirect("errorNoAccess.jsp"); return; }

%>

<%@ include file="/shared/header.inc" %>
<%@ include file="/shared/menus.inc" %>


<h3><t:Tr>Arviointitiedot</t:Tr></h3>

<% time timeformater = new time(); %>

<br / >
<sql:statement id="stmt2" conn="conn2">
  <sql:query>
   select assdetailtranslation.name as assname

   from  assignment
   where assignment.deleted = false
   and   assignment.assignmentid = <%=assID%>
   and   assignmentreldetail.assignmentid = assignment.assignmentid
   and   assignmentreldetail.deleted = false  
   and   assignmentreldetail.detailid = assignmentdetail.detailid
   and   assignmentdetail.typeid = <%=titleID%> 
   and   assdetailtranslation.detailid = assignmentdetail.detailid
   and   assdetailtranslation.languageid = <%=languageID%>;
  </sql:query>
  <sql:resultSet id="rset2">
    <h4><a href="assignment.jsp?assid=<%=assID%>"><sql:getColumn colName="assname" /></a></h4> 
  </sql:resultSet>
</sql:statement>


<table>
<sql:statement id="stmt3" conn="conn2">
  <sql:query>

    select Student.firstnames || ' ' || Student.lastname as stuname, 
           Teacher.firstnames || ' ' || Teacher.lastname as teaname, 
           gradetranslation.name as gradevalue, 
           assignmentfinished.memo as memo,
           trunc(assignmentfinished.credits) as credits,
           assignmentfinished.gradedate as gradedate
    from   assignmentfinished, person as Student, assignmentrelatedperson as Studentrel, 
                               person as Teacher, assignmentrelatedperson as Teacherrel
    where  assignmentfinished.deleted = false
    and    Studentrel.assignmentid = <%=assID%> 
    and    Studentrel.personid = <%=personID%>
    and    Studentrel.personid = Student.personid
    and    Studentrel.relationid = assignmentfinished.persontobegradedid
    and    assignmentfinished.gradedbyid = Teacherrel.relationid
    and    Teacherrel.assignmentid = <%=assID%>
    and    Teacherrel.relationid =  <%=request.getParameter("teacher")%>
    and    Teacherrel.personid = Teacher.personid   
    and    assignmentfinished.gradeid = gradetranslation.gradeid
    and    gradetranslation.languageid = <%=languageID%> 
  </sql:query>
  <sql:resultSet id="rset3">
    <tr>
      <td><strong><t:Tr>Opiskelija </t:Tr></strong></td>
      <td><sql:getColumn colName="stuname" /></td>
    </tr>
    <tr>
      <td><strong><t:Tr>Arvioitsija </t:Tr></strong></td>
      <td><sql:getColumn colName="teaname" /></td>
    </tr>
    <tr>
      <td><strong><t:Tr>Arviointipiv </t:Tr></strong></td>
      <td><sql:getColumn colName="gradedate" to="gdate" />
      <%=timeformater.monthToOutFormat((String)pageContext.getAttribute("gdate"))%></td>
    </tr>
    <tr>
      <td><strong><t:Tr>Arvolause </t:Tr></strong></td>
      <td><sql:getColumn colName="gradevalue" /></td>
    </tr>    
    <tr>
      <td><strong><t:Tr>Arvio </t:Tr></strong></td>
      <td><sql:getColumn colName="memo" /></td>
    </tr>
    <tr>
      <td><strong><t:Tr>Opintoviikot </t:Tr></strong></td>
      <td><sql:getColumn colName="credits" /></td>
    </tr>
  </sql:resultSet>
</sql:statement>


</table>





<%@ include file="/shared/pageEnd.inc" %>


