<%
/***************************************************************************************************
*               PAGE DESCRIPTION
****************************************************************************************************
*
*               NAME:           assignment.jsp
*               LANGUAGE:       JSP
*               DATE:           16.4.2002
*               AUTHOR:         Minna Hillebrand, University of Jyvskyl (JYU)
*               PURPOSE:        Show general information about assignment or subject.  
*
****************************************************************************************************
*               COPYRIGHT (C) KOPPELO PROJECT GROUP
*               Limited rights granted. Please refer to GNU General Public License
*               http://www.gnu.org/licenses/gpl.html
****************************************************************************************************

****************************************************************************************************
*               UPDATES
****************************************************************************************************
*                 27.4.2002 Minna Hillebrand           
*                    Added assignment related details
*
****************************************************************************************************/
%>

<%@ include file="/shared/beans.inc" %>
<%@ include file="/shared/constants.inc" %>

<%
   /* No relation to database is needed because every KOTKA users are allowed to see this page */
   if ( userAccessLevel < studentID )  { response.sendRedirect("errorNoAccess.jsp"); return; }

%>

<%

  if ((request.getParameter("assid") == null) && (request.getParameter("origid") == null)) {  
    response.sendRedirect("error.jsp?page=assignmentInfo&message=1"); 
    return; 
  }

  if (request.getParameter("origid") != null) { 
    response.sendRedirect("assignmentOriginalInfo.jsp?origid="+ request.getParameter("origid") );     
    return; 
  }

  if (request.getParameter("assid") == null) {
    response.sendRedirect("error.jsp?page=assignmentInfo&message=1"); 
    return; 
  }

  int assID = Integer.parseInt(request.getParameter("assid"));   

%>

<%@ include file="/shared/header.inc" %>
<%@ include file="/shared/menus.inc" %>
<%@ include file="/shared/dbconnect.inc" %>


<h3><t:Tr>Opinnytteen yleiset tiedot</t:Tr></h3>

<% time timeformater = new time(); %>

<%--
<p>Tll sivulla nytetn vain opinnytteen julkiset tiedot.
Tapahtumatietoihin pset <a href="assignment.jsp?assid=<%=assID%>">tst</a>.
</p>
--%>

<div class="in">
<table>

  <sql:statement id="stmt2" conn="conn2">
    <sql:query>
       select assdetailtranslation.name as title,
              descriptiontypetranslation.name as name 
       from   assdetailtranslation
       where  assignment.assignmentid = <%=assID%>
       and    assignment.deleted = false
       and    assignmentreldetail.assignmentid = <%=assID%>
       and    assignmentreldetail.detailid = assignmentdetail.detailid
       and    assignmentdetail.typeid = <%=titleID%>
       and    assdetailtranslation.detailid = assignmentdetail.detailid
       and    assdetailtranslation.languageid = <%=languageID%> 
       and    descriptiontypetranslation.descriptiontypeid = <%=titleID%>
       and    descriptiontypetranslation.languageid = <%=languageID%> 
     </sql:query>
    <sql:resultSet id="rset2"> 
    <tr>
      <td valign="top"><strong><sql:getColumn colName="name" /></strong></td>
      <td><sql:getColumn colName="title" /></td>
    </tr>
    </sql:resultSet>
  </sql:statement>

  <sql:statement id="stmt2" conn="conn2">
    <sql:query>
       select assdetailtranslation.name as descr,
              descriptiontypetranslation.name as name 
       from   assdetailtranslation
       where  assignment.assignmentid = <%=assID%>
       and    assignment.deleted = false
       and    assignmentreldetail.assignmentid = <%=assID%>
       and    assignmentreldetail.detailid = assignmentdetail.detailid
       and    assignmentdetail.typeid = <%=descriptionID%>
       and    assdetailtranslation.detailid = assignmentdetail.detailid
       and    assdetailtranslation.languageid = <%=languageID%> 
       and    descriptiontypetranslation.descriptiontypeid = <%=descriptionID%>
       and    descriptiontypetranslation.languageid = <%=languageID%> 
     </sql:query>
    <sql:resultSet id="rset2"> 
    <tr>
      <td valign="top"><strong><sql:getColumn colName="name" /></strong></td>
      <td><sql:getColumn colName="descr" /></td>
    </tr>
    </sql:resultSet>
  </sql:statement>

    <tr>
      <td valign="top"><strong><t:Tr>Avainsanat</t:Tr></strong></td>
      <td>
<% String akeys=""; boolean first=true; %>
  <sql:statement id="stmt2" conn="conn2">
    <sql:query>
       select asskeywordtranslation.name as keyw
       from   asskeywordtranslation
       where  assignmentrelkeyword.deleted = false
       and    assignmentrelkeyword.assignmentid = <%=assID%>
       and    assignmentrelkeyword.keywordid = assignmentkeyword.keywordid
       and    assignmentkeyword.deleted = false
       and    asskeywordtranslation.deleted = false
       and    assignmentkeyword.keywordid = asskeywordtranslation.keywordid
       and    asskeywordtranslation.languageid = <%=languageID%>
     </sql:query>
    <sql:resultSet id="rset2"> 
      <sql:getColumn colName="keyw" to="keys" />
      <% if (first) { akeys = (String)pageContext.getAttribute("keys"); first = false; }
         else  akeys += ", " +(String)pageContext.getAttribute("keys"); %>
    </sql:resultSet>
  </sql:statement>
      <%=akeys%></td>
    </tr>

  <sql:statement id="stmt2" conn="conn2">
    <sql:query>
      select             
             assignment.assignmenttypeid as asstypeid,
             asstypetranslation.name as typename, 
             assignment.lineid as alineid, 
             course.courseid as  asscourseid,
             assignment.phaseid as assphaseid,
             assphasetranslation.name as phasename,
             assignment.begindate,
             assignment.finisheddate  

      from   assignment
      where  assignment.deleted = false  
      and    assignment.assignmentid = <%=assID%>
      and    assignment.originalid = assignmentoriginal.originalid

      and    assignment.assignmenttypeid = assignmenttype.typeid
      and    assignmenttype.typeid = asstypetranslation.typeid
      and    asstypetranslation.languageid = <%=languageID%>

      and    assignment.courseid = course.courseid
      and    course.courseid = coursetranslation.courseid
      and    coursetranslation.languageid = <%=languageID%>

      and    assignment.phaseid = assignmentphase.phaseid
      and    assignmentphase.phaseid = assphasetranslation.phaseid
      and    assphasetranslation.languageid = <%=languageID%> 

    </sql:query>
    <sql:resultSet id="rset2"> 
    <tr>
      <td valign="top"><strong><t:Tr>Tyyppi</t:Tr></strong></td>
      <td><sql:getColumn colName="typename" /></td>  
    </tr>

    <tr>
      <td valign="top"><strong><t:Tr>Linja</t:Tr></strong></td>
      <td>
         <% try { %>

  <sql:statement id="stmt3" conn="conn2">
    <sql:query>
          select studylinetranslation.name as linename,
                 organisationtranslation.name as orgname
          from   studyline
          where  studyline.deleted = false
          and    studyline.lineid = <sql:getColumn colName="alineid" />
          and    studyline.lineid = studylinetranslation.lineid
          and    studylinetranslation.languageid = <%=languageID%>
          and    studyline.organisationid = organisation.organisationid
          and    organisation.deleted = false 
          and    organisation.organisationid = organisationtranslation.organisationid
          and    organisationtranslation.languageid = <%=languageID%>
    </sql:query>
    <sql:resultSet id="rset3">
      <sql:getColumn colName="linename" />, <sql:getColumn colName="orgname" />
    </sql:resultSet>
  </sql:statement>
         <% } catch (Exception e) {} %>  
       </td>
    </tr>

    <tr>
      <td valign="top"><strong><t:Tr>Tyn vaihe</t:Tr></strong></td>
      <td><sql:getColumn colName="phasename" /> </td>  
    </tr>

    <tr>
      <td valign="top"><strong><t:Tr>Aloituspiv</t:Tr></strong></td>
      <td><sql:getDate colName="begindate" to="bdate" />
          <%=timeformater.monthToOutFormat((String)pageContext.getAttribute("bdate"))%> </td>  
    </tr>

    <tr>
      <td valign="top"><strong><t:Tr>Hyvksymispiv</t:Tr></strong></td>
      <td><sql:getDate colName="finisheddate" to="fdate" />
          <% if  ( pageContext.getAttribute("fdate") != null ) { %>
          <%=timeformater.monthToOutFormat((String)pageContext.getAttribute("fdate"))%> <% } %> </td>  
    </tr>




<%--
    <tr>
      <td valign="top"><strong><t:Tr>Aihe vapaa </t:Tr></strong></td>
      <td><sql:getColumn colName="available" /> <t:Tr>ryhmlle</t:Tr></td>
    </tr>
 --%>

    </sql:resultSet>
  </sql:statement>

</table>

</div>


<h4><t:Tr>Opinnytteeseen liittyvt henkilt</t:Tr></h4>

<div class="in">
<p>
  <sql:statement id="stmt2" conn="conn2">
    <sql:query>
       select person.lastname || ' ' || person.firstnames as name,
              assroletranslation.name as rolename,
              personparameter.personparametervalue as email
       from   assignmentrelatedperson
       where  assignmentrelatedperson.deleted = false
       and    assignmentrelatedperson.assignmentid = <%=assID%>  
       and    assignmentrelatedperson.personid = person.personid
       and    person.deleted = false
       and    assignmentrelatedperson.roleid = assignmentrole.roleid
       and    assignmentrole.deleted = false
       and    assignmentrole.roleid = assroletranslation.roleid
       and    assroletranslation.deleted = false
       and    assroletranslation.languageid = <%=languageID%>
       and    person.personid = personparameter.personid
       and    personparameter.deleted = false
       and    personparameter.personparametertypeid = 3                    
       order by roleid, person.lastname;
    </sql:query>
    <sql:resultSet id="rset2"> 
      <sql:getColumn colName="name" />, <sql:getColumn colName="email" /> (<sql:getColumn colName="rolename" />)<br />
    </sql:resultSet>
  </sql:statement>
</p>
</div>

<h4><t:Tr>Aiheeseen liittyvt tiedot</t:Tr></h4>
<div class="in">
<table>
 <sql:statement id="stmt2" conn="conn2">
    <sql:query>
      select assignmentoriginal.available,   
             proposer.firstnames || ' ' || proposer.lastname as pname,
             assignmentoriginal.proposeddate,
             assignmentoriginal.validuntil,
             personparameter.personparametervalue as email

      from   assignmentoriginal, person as proposer
      where  assignmentoriginal.deleted = false  
      and    assignment.assignmentid = <%=assID%>
      and    assignment.originalid = assignmentoriginal.originalid
      and    assignmentoriginal.proposedby = proposer.personid
      and    proposer.personid = personparameter.personid
      and    personparameter.deleted = false
      and    personparameter.personparametertypeid = 3

    </sql:query>
    <sql:resultSet id="rset2"> 
    <tr>
      <td valign="top"><strong><t:Tr>Ehdotettu</t:Tr></strong></td>
      <td><sql:getDate colName="proposeddate" to="pdate" />
          <%=timeformater.monthToOutFormat((String)pageContext.getAttribute("pdate"))%> </td>  

    </tr>

    <tr>
      <td valign="top"><strong><t:Tr>Ehdottaja</t:Tr></strong></td>
      <td><sql:getColumn colName="pname" />, <sql:getColumn colName="email" /> </td>  
    </tr>

    <tr>
      <td valign="top"><strong><t:Tr>Aihe vapaa</t:Tr></strong></td>
      <td><sql:getColumn colName="available" /> <t:Tr>ryhmlle</t:Tr></td>  
    </tr>

    <tr>
      <td valign="top"><strong><t:Tr>Aihe voimassa </t:Tr></strong></td>
      <td><sql:getDate colName="validuntil" to="vdate" />
          <%=timeformater.monthToOutFormat((String)pageContext.getAttribute("vdate"))%> </td>  
    </tr>

    </sql:resultSet>
  </sql:statement>

</table>

</div>



<% /* Box to send email. */ %>
<%--
<p><t:Tr>Alla olevalla laatikolla voit pyyt listietoja aiheesta. 
Viesti lhetetn opinnytett ohjaavalle henkillle.</t:Tr></p>

<form action="sendMail.jsp" method="post">
<input type="hidden" name="sender"   value="mape@cc.jyu.fi" />
<input type="hidden" name="to"       value="mmhilleb@cc.jyu.fi" />
<input type="hidden" name="subject"  value="tama saadaan mys kannasta" />

<textarea name="message" rows="4" cols="50"></textarea>
<input type="submit" name="submit" value="Lhet posti" />

</form>
--%>


<%@ include file="/shared/pageEnd.inc" %>
