<%
/***************************************************************************************************
*               PAGE DESCRIPTION
****************************************************************************************************
*
*               NAME:           assignmentOriginalInfo.jsp
*               LANGUAGE:       JSP
*               DATE:           22.4.2002
*               AUTHOR:         Minna Hillebrand, University of Jyvskyl (JYU)
*               PURPOSE:        Show general information about subject.  
*
****************************************************************************************************
*               COPYRIGHT (C) KOPPELO PROJECT GROUP
*               Limited rights granted. Please refer to GNU General Public License
*               http://www.gnu.org/licenses/gpl.html
****************************************************************************************************

****************************************************************************************************
*               UPDATES
****************************************************************************************************
*                            
*
*
****************************************************************************************************/
%>

<%@ include file="/shared/beans.inc" %>
<%@ include file="/shared/constants.inc" %>

<%
   /* No relation to database is needed because every KOTKA users are allowed to see this page */
   if ( userAccessLevel < studentID )  { response.sendRedirect("errorNoAccess.jsp"); return; }

%>

<%

  if (request.getParameter("origid") == null) { 
    response.sendRedirect("error.jsp?page=assignmentOriginalInfo&message=1"); 
    return; 
  }
  int origID = Integer.parseInt(request.getParameter("origid"));   

%>


<%@ include file="/shared/header.inc" %>
<%@ include file="/shared/menus.inc" %>
<%@ include file="/shared/dbconnect.inc" %>


<% time timeformater = new time(); %>

<h3><t:Tr>Opinnytteen aiheen tiedot</t:Tr></h3>


<div class="in">
<table>

  <sql:statement id="stmt2" conn="conn2">
    <sql:query>
       select assdetailtranslation.name as title,
              descriptiontypetranslation.name as name 
       from   assdetailtranslation
       where  assignmentoriginal.originalid = <%=origID%>
       and    assignmentoriginal.deleted = false
       and    assoriginalreldetail.originalid = <%=origID%>
       and    assoriginalreldetail.detailid = assignmentdetail.detailid
       and    assignmentdetail.typeid = <%=titleID%>
       and    assdetailtranslation.detailid = assignmentdetail.detailid
       and    assdetailtranslation.languageid = <%=languageID%> 
       and    descriptiontypetranslation.descriptiontypeid = <%=titleID%>
       and    descriptiontypetranslation.languageid = <%=languageID%> 
     </sql:query>
    <sql:resultSet id="rset2"> 
    <tr>
      <td valign="top"><strong><sql:getColumn colName="name" /></strong></td>
      <td><sql:getColumn colName="title" /></td>
    </tr>
    </sql:resultSet>
  </sql:statement>

  <sql:statement id="stmt2" conn="conn2">
    <sql:query>
       select assdetailtranslation.name as descr,
              descriptiontypetranslation.name as name 
       from   assdetailtranslation
       where  assignmentoriginal.originalid = <%=origID%>
       and    assignmentoriginal.deleted = false
       and    assoriginalreldetail.originalid = <%=origID%>
       and    assoriginalreldetail.detailid = assignmentdetail.detailid
       and    assignmentdetail.typeid = <%=descriptionID%>
       and    assdetailtranslation.detailid = assignmentdetail.detailid
       and    assdetailtranslation.languageid = <%=languageID%> 
       and    descriptiontypetranslation.descriptiontypeid = <%=descriptionID%>
       and    descriptiontypetranslation.languageid = <%=languageID%> 
     </sql:query>
    <sql:resultSet id="rset2"> 
    <tr>
      <td valign="top"><strong><sql:getColumn colName="name" /></strong></td>
      <td><sql:getColumn colName="descr" /></td>
    </tr>
    </sql:resultSet>
  </sql:statement>

    <tr>
      <td valign="top"><strong><t:Tr>Avainsanat</t:Tr></strong></td>
      <td>
<% String akeys=""; boolean first=true; %>
  <sql:statement id="stmt2" conn="conn2">
    <sql:query>
       select asskeywordtranslation.name as keyw
       from   asskeywordtranslation
       where  assoriginalrelkeyword.deleted = false
       and    assoriginalrelkeyword.originalid = <%=origID%>
       and    assoriginalrelkeyword.keywordid = assignmentkeyword.keywordid
       and    assignmentkeyword.deleted = false
       and    asskeywordtranslation.deleted = false
       and    assignmentkeyword.keywordid = asskeywordtranslation.keywordid
       and    asskeywordtranslation.languageid = <%=languageID%>
     </sql:query>
    <sql:resultSet id="rset2"> 
      <sql:getColumn colName="keyw" to="keys" />
      <% if (first) { akeys = (String)pageContext.getAttribute("keys"); first = false; }
         else  akeys += ", " +(String)pageContext.getAttribute("keys"); %>
    </sql:resultSet>
  </sql:statement>
      <%=akeys%></td>
    </tr>

    <tr>
      <td valign="top"><strong><t:Tr>Mahdolliset tyypit</t:Tr></strong></td>
      <td>
         <% try { %>

  <sql:statement id="stmt3" conn="conn2">
    <sql:query>
          select asstypetranslation.name as typename
          from   assoriginalpostype
          where  assignmenttype.deleted = false
          and    assoriginalpostype.deleted = false
          and    assoriginalpostype.originalid = <%=origID%>
          and    assoriginalpostype.typeid = assignmenttype.typeid
          and    assignmenttype.typeid = asstypetranslation.typeid
          and    asstypetranslation.languageid = <%=languageID%>
    </sql:query>
    <sql:resultSet id="rset3">
      <sql:getColumn colName="typename" /><br/>
    </sql:resultSet>
  </sql:statement>
         <% } catch (Exception e) {} %>  
       </td>
    </tr>


    <tr>
      <td valign="top"><strong><t:Tr>Mahdolliset linjat</t:Tr></strong></td>
      <td>
         <% try { %>

  <sql:statement id="stmt3" conn="conn2">
    <sql:query>
          select studylinetranslation.name as linename,
                 organisationtranslation.name as orgname
          from   assoriginalposline
          where  studyline.deleted = false
          and    assoriginalposline.deleted = false
          and    assoriginalposline.originalid = <%=origID%>
          and    assoriginalposline.lineid = studyline.lineid
          and    studyline.lineid = studylinetranslation.lineid
          and    studylinetranslation.languageid = <%=languageID%>
          and    studyline.organisationid = organisation.organisationid
          and    organisation.deleted = false 
          and    organisation.organisationid = organisationtranslation.organisationid
          and    organisationtranslation.languageid = <%=languageID%>
    </sql:query>
    <sql:resultSet id="rset3">
      <sql:getColumn colName="linename" />, <sql:getColumn colName="orgname" /><br/>
    </sql:resultSet>
  </sql:statement>
         <% } catch (Exception e) {} %>  
       </td>
    </tr>


 <sql:statement id="stmt2" conn="conn2">
    <sql:query>
      select assignmentoriginal.available,   
             proposer.firstnames || ' ' || proposer.lastname as pname,
             assignmentoriginal.proposeddate,
             assignmentoriginal.validuntil,
             personparameter.personparametervalue as email

      from   assignmentoriginal, person as proposer
      where  assignmentoriginal.deleted = false  
      and    assignmentoriginal.originalid = <%=origID%>
      and    assignmentoriginal.proposedby = proposer.personid
      and    proposer.personid = personparameter.personid
      and    personparameter.deleted = false
      and    personparameter.personparametertypeid = 3

    </sql:query>
    <sql:resultSet id="rset2"> 
    <tr>
      <td valign="top"><strong><t:Tr>Ehdotettu</t:Tr></strong></td>
      <td><sql:getDate colName="proposeddate" to="pdate"/><%=timeformater.monthToOutFormat((String)pageContext.getAttribute("pdate"))%></td>  
    </tr>

    <tr>
      <td valign="top"><strong><t:Tr>Ehdottaja</t:Tr></strong></td>
      <td><sql:getColumn colName="pname" />, <sql:getColumn colName="email" /> </td>  
    </tr>

    <tr>
      <td valign="top"><strong><t:Tr>Aihe vapaa</t:Tr></strong></td>
      <td><sql:getColumn colName="available" /> <t:Tr>ryhmlle</t:Tr></td>  
    </tr>

    <tr>
      <td valign="top"><strong><t:Tr>Aihe voimassa </t:Tr></strong></td>
      <td><sql:getDate colName="validuntil" to="vdate"/><%=timeformater.monthToOutFormat((String)pageContext.getAttribute("vdate"))%></td> 
    </tr>

    </sql:resultSet>
  </sql:statement>

</table>

</div>


<%--
<% /* Box to send email. */ %>

<p><t:Tr>Alla olevn laatikon avulla voit pyyt listietoja aiheesta. 
Viesti lhetetn .. niin, kenelle??</t:Tr></p>

<form action="sendMail.jsp" method="post">
<input type="hidden" name="sender"   value="mape@cc.jyu.fi" />
<input type="hidden" name="to"       value="mmhilleb@cc.jyu.fi" />
<input type="hidden" name="subject"  value="tama saadaan mys kannasta" />

<textarea name="message" rows="4" cols="50"></textarea>
<input type="submit" name="submit" value="Lhet posti" />

</form>

</div>
--%>



<%@ include file="/shared/pageEnd.inc" %>
