<%
/***************************************************************************************************
*               PAGE DESCRIPTION
****************************************************************************************************
*
*               NAME:           assignmentUpdate.jsp
*               LANGUAGE:       JSP
*               DATE:           22.4.2002
*               AUTHOR:         Minna Hillebrand, University of Jyvskyl (JYU)
*               PURPOSE:        Maintain assignment related information
*
****************************************************************************************************
*               COPYRIGHT (C) KOPPELO PROJECT GROUP
*               Limited rights granted. Please refer to GNU General Public License
*               http://www.gnu.org/licenses/gpl.html
****************************************************************************************************

****************************************************************************************************
*               UPDATES
****************************************************************************************************
*              
*
*
****************************************************************************************************/
%>


<%@ include file="/shared/beans.inc" %>
<%@ include file="/shared/constants.inc" %>
<%@ include file="/shared/dbconnect.inc" %>

<%-- Check that user is allowed   --%>


<%
  if (request.getParameter("assid") == null) { 
      response.sendRedirect("error.jsp?page=assignmentUpdate&message=1");
      return;
    }

  int assID = Integer.parseInt(request.getParameter("assid"));   
%>
<%
   police.setDB(db);

   boolean canUpdate = false;
   boolean canGrade  = false;
   boolean canFinish = false; 

   if ( ! police.hasPersonRight(allowAssDetail, personID, assID) ) {
      response.sendRedirect("assignmentInfo.jsp?assid="+assID); 
      return;   
   }

   if ( police.hasPersonRight(allowAssUpdate, personID, assID)   ) canUpdate  = true;
   if ( police.hasPersonRight(allowGradeID, personID, assID)   ) canGrade  = true;
   if ( police.hasPersonRight(allowAssFinish, personID, assID) ) canFinish = true;


   if (!canUpdate) {
     response.sendRedirect("errorNoAccess.jsp"); 
     return;
   }

%>


<%@ include file="/shared/header.inc" %>
<%@ include file="/shared/menus.inc" %>



<% time timeformater = new time(); %>

<p>
<t:Tr><a href="assignment.jsp?assid=<%=assID%>">Opinnytteen tiedot ja tapahtumat</a></t:Tr>
| <t:Tr><a href="assignmentUpdatePerson.jsp?assid=<%=assID %>">Lis/poista henkilit</a></t:Tr>
| <t:Tr><a href="assignmentUpdateTask.jsp?assid=<%=assID %>">Pivit tytehtvi</a></t:Tr>
<% if ( canGrade ) { %>
| <t:Tr><a href="assignmentGrade.jsp?assid=<%=assID %>">Arvioi opiskelija</a></t:Tr>
<% } %>
<% if ( canFinish ) { %>
| <t:Tr><a href="assignmentGradeFinish.jsp?assid=<%=assID %>">Opinnytteen hyvksyminen</a></t:Tr>
<% } %>
</p>

<h3><t:Tr>Opinnytteen tietojen hallinta</t:Tr></h3>


<% if (request.getParameter("updated") != null) { %>
<h3><t:Tr>Tiedot tallennettu</t:Tr></h3>
<% } %>


<h4><t:Tr>Opinnytteen yleiset tiedot</t:Tr></h4>

<div class="in">


<form action="assignmentUpdateInsert.jsp" method="post">
<input type ="hidden" name="assid" value="<%=assID%>" />

<table>

  <sql:statement id="stmt2" conn="conn2">
    <sql:query>
       select assdetailtranslation.name as title,
              descriptiontypetranslation.name as name 
       from   assdetailtranslation
       where  assignment.assignmentid = <%=assID%>
       and    assignment.deleted = false
       and    assignmentreldetail.assignmentid = <%=assID%>
       and    assignmentreldetail.detailid = assignmentdetail.detailid
       and    assignmentdetail.typeid = <%=titleID%>
       and    assdetailtranslation.detailid = assignmentdetail.detailid
       and    assdetailtranslation.languageid = <%=languageID%> 
       and    descriptiontypetranslation.descriptiontypeid = <%=titleID%>
       and    descriptiontypetranslation.languageid = <%=languageID%> 
     </sql:query>
    <sql:resultSet id="rset2"> 
    <tr>
      <td valign="top"><strong><sql:getColumn colName="name" /></strong></td>
      <td><input type="text" name="title" value="<sql:getColumn colName="title" />" size="50"></td>
    </tr>
    </sql:resultSet>
  </sql:statement>

  <sql:statement id="stmt2" conn="conn2">
    <sql:query>
       select assdetailtranslation.name as descr,
              descriptiontypetranslation.name as name 
       from   assdetailtranslation
       where  assignment.assignmentid = <%=assID%>
       and    assignment.deleted = false
       and    assignmentreldetail.assignmentid = <%=assID%>
       and    assignmentreldetail.detailid = assignmentdetail.detailid
       and    assignmentdetail.typeid = <%=descriptionID%>
       and    assdetailtranslation.detailid = assignmentdetail.detailid
       and    assdetailtranslation.languageid = <%=languageID%> 
       and    descriptiontypetranslation.descriptiontypeid = <%=descriptionID%>
       and    descriptiontypetranslation.languageid = <%=languageID%> 
     </sql:query>
    <sql:resultSet id="rset2"> 
    <tr>
      <td valign="top"><strong><sql:getColumn colName="name" /></strong></td>
      <td><textarea name="description" rows="5" 
           cols="50"><sql:getColumn colName="descr" /></textarea></td>
    </tr>
    </sql:resultSet>
  </sql:statement>


<% String akeywords=""; 
   boolean first = true; 
%>
  <sql:statement id="stmt2" conn="conn2">
    <sql:query>
       select asskeywordtranslation.name as keyw
       from   asskeywordtranslation
       where  assignmentrelkeyword.deleted = false
       and    assignmentrelkeyword.assignmentid = <%=assID%>
       and    assignmentrelkeyword.keywordid = assignmentkeyword.keywordid
       and    assignmentkeyword.deleted = false
       and    asskeywordtranslation.deleted = false
       and    assignmentkeyword.keywordid = asskeywordtranslation.keywordid
       and    asskeywordtranslation.languageid = <%=languageID%>
     </sql:query>
    <sql:resultSet id="rset2"> 
       <sql:getColumn colName="keyw" to="keyw" scope="page" />
       <% if (first) { akeywords += pageContext.getAttribute("keyw"); first = false; }
          else akeywords += ", " + pageContext.getAttribute("keyw"); %>
    </sql:resultSet>
  </sql:statement>
    <tr>
      <td valign="top"><strong><t:Tr>Avainsanat</t:Tr></strong></td>
      <td><input type="text" name="keywords" value="<%=akeywords%>" size="50" />
      </td>
    </tr>


  <sql:statement id="stmt2" conn="conn2">
    <sql:query>
      select             
             assignment.assignmenttypeid as asstypeid,
<%-- MAY BE NULL             assignment.lineid as alineid, --%>
             course.courseid as  asscourseid,
             assignment.phaseid as assphaseid, 
             assignment.warningtime as wtime,
             assignment.publicgroup as pgroup,
             assignmentoriginal.available as available,
             assignment.finisheddate,
             assignment.begindate 
      from   assignment
      where  assignment.deleted = false  
      and    assignment.assignmentid = <%=assID%>
      and    assignment.originalid = assignmentoriginal.originalid

      and    assignment.assignmenttypeid = assignmenttype.typeid
      and    assignmenttype.typeid = asstypetranslation.typeid
      and    asstypetranslation.languageid = <%=languageID%>
<%-- MAY BE NULL
      and    assignment.lineid = studyline.lineid
      and    studyline.lineid = studylinetranslation.lineid 
      and    studylinetranslation.languageid = <%=languageID%>
--%>
      and    assignment.courseid = course.courseid
      and    course.courseid = coursetranslation.courseid
      and    coursetranslation.languageid = <%=languageID%>

      and    assignment.phaseid = assignmentphase.phaseid
      and    assignmentphase.phaseid = assphasetranslation.phaseid
      and    assphasetranslation.languageid = <%=languageID%> 

    </sql:query>
    <sql:resultSet id="rset2"> 
    <tr>
      <td valign="top"><strong><t:Tr>Tyyppi</t:Tr></strong></td>
       <sql:getColumn colName="asstypeid" to="selectedTypeID" scope="page" />
       <td><select name="typeid">
       <sql:statement id="stmt4" conn="conn2">
         <sql:query>

<%--          select asstypetranslation.name as typename,
                 assignmenttype.typeid as typeid
          from   assignmenttype
          where  assignmenttype.deleted = false
          and    assignmenttype.typeid = asstypetranslation.typeid
          and    asstypetranslation.languageid = <%=languageID%>
          and    assignmenttype.typeid in (
--%>
             select assoriginalpostype.typeid as alltype,
                    asstypetranslation.name as typename 
             from   assoriginalpostype
             where  assoriginalpostype.originalid = 
                 (select assignment.originalid 
                  from assignment 
                  where assignment.assignmentid = <%=assID%>)
             and    assoriginalpostype.deleted = false
             and    assoriginalpostype.typeid = assignmenttype.typeid
             and    assignmenttype.typeid = asstypetranslation.typeid
             and    asstypetranslation.languageid = <%=languageID%>
      <%--    )--%> 
        </sql:query>
        <sql:resultSet id="rset4" loop="true">
          <sql:getColumn colName="alltype" to="curTypeID" scope="page" />  
          <% String selected ="";
             if ( Integer.parseInt((String)pageContext.getAttribute("selectedTypeID")) == 
                  Integer.parseInt((String)pageContext.getAttribute("curTypeID"))         ) selected = "selected=\"selected\""; %>  
          <option <%=selected%> value="<sql:getColumn colName="alltype" />"><sql:getColumn colName="typename" /></option>
        </sql:resultSet>
      </sql:statement>
      </select>
      </td>  
    </tr>

    <tr>
      <td valign="top"><strong><t:Tr>Linja</t:Tr></strong></td>

       <% boolean hasLine=false; %> 
       <td><select name="lineid">
         <option value="null">ei linjaa</option> 
       <sql:statement id="stmt4" conn="conn2">
         <sql:query>
          select 
                 assignment.lineid as lineid
          from   assignment
          where  assignment.assignmentid = <%=assID%>
          
        </sql:query>
        <sql:resultSet id="rset4">
           <sql:getColumn colName="lineid" to="selectedLineID" scope="page" />
           <% if ( pageContext.getAttribute("selectedLineID") != null ) hasLine = true; %>
        </sql:resultSet>
  
       <sql:query>
           select studyline.lineid as lineid,
                  studylinetranslation.name as linename,
                  organisationtranslation.name as orgname
           from   studyline
           where  studyline.lineid = studylinetranslation.lineid
           and    studylinetranslation.languageid = <%=languageID%>
           and    studyline.lineid in (
             select assoriginalposline.lineid 
             from assoriginalposline 
             where assoriginalposline.originalid = 
                   ( select originalid 
                     from assignment 
                     where assignmentid = <%=assID%>) 
             and   assoriginalposline.deleted = false 
          )
           and    studyline.organisationid = organisationtranslation.organisationid
           and    organisationtranslation.languageid = <%=languageID%>  
        </sql:query>
        <sql:resultSet id="rset4" loop="true">
          <sql:getColumn colName="lineid" to="curLineID" scope="page" />  
          <% String selected ="";
             if (hasLine) 
               if ( Integer.parseInt((String)pageContext.getAttribute("selectedLineID")) == 
                    Integer.parseInt((String)pageContext.getAttribute("curLineID"))        ) selected = "selected=\"selected\""; 
          %>  
          <option <%=selected%> value="<sql:getColumn colName="lineid" />"><sql:getColumn colName="linename" /> (<sql:getColumn colName="orgname" />)</option>
        </sql:resultSet>
      </sql:statement>
      </select>
      </td>  
    </tr>

    <tr>
      <sql:getColumn colName="assphaseid" to="selectedPhaseID" scope="page" />
      <td valign="top"><strong><t:Tr>Tyn vaihe</t:Tr></strong></td>
       <td><select name="phaseid">
       <sql:statement id="stmt4" conn="conn2">
         <sql:query>

          select assphasetranslation.name as phasename,
                 assignmentphase.phaseid as phaseid
          from   assignmentphase
          where  assignmentphase.deleted = false
          and    assignmentphase.phasegroup = 1 
          and    assignmentphase.phaseid = assphasetranslation.phaseid
          and    assphasetranslation.languageid = <%=languageID%>
        </sql:query>
        <sql:resultSet id="rset4" loop="true">
          <sql:getColumn colName="phaseid" to="curPhaseID" scope="page" />  
          <% String selected ="";
             if ( Integer.parseInt((String)pageContext.getAttribute("selectedPhaseID")) == 
                  Integer.parseInt((String)pageContext.getAttribute("curPhaseID"))         ) selected = "selected=\"selected\""; %>  
          <option <%=selected%> value="<sql:getColumn colName="phaseid" />"><sql:getColumn colName="phasename" /></option>
        </sql:resultSet>
      </sql:statement>
      </select>
      </td>  
    </tr>


    <tr>
      <sql:getColumn colName="asscourseid" to="selectedCourseID" scope="page" />
      <td valign="top"><strong><t:Tr>Kurssi</t:Tr></strong></td>
       <td><select name="courseid">
       <sql:statement id="stmt4" conn="conn2">
         <sql:query>

          select cast(course.code as varchar) || ' ' ||  coursetranslation.name as coursename, 
                 course.courseid
          from   course
          where  course.deleted = false
          and    course.courseid > 0 
          and    course.courseid = coursetranslation.courseid
          and    coursetranslation.languageid = <%=languageID%>
          and    course.organisationid = <%=user.getOrganisationID()%>
          order by course.code 
        </sql:query>
        <sql:resultSet id="rset4" loop="true">
          <sql:getColumn colName="courseid" to="curCourseID" scope="page" />  
          <% String selected ="";
             if ( Integer.parseInt((String)pageContext.getAttribute("selectedCourseID")) == 
                  Integer.parseInt((String)pageContext.getAttribute("curCourseID"))         ) selected = "selected=\"selected\""; %>  
          <option <%=selected%> value="<sql:getColumn colName="courseid" />"><sql:getColumn colName="coursename" /></option>
        </sql:resultSet>
      </sql:statement> 
      </select>
      </td>  
    </tr>


<%--
    <tr>
      <td valign="top"><strong><t:Tr>Jakso</t:Tr></strong></td>
      <td><sql:getColumn colName="periodname" /></td>
    </tr>
--%>
    <tr>
      <td valign="top"><strong><t:Tr>Muistutusvli</t:Tr></strong></td>
      <td><input type="text" name="warntime" value="<sql:getColumn colName="wtime" />" size="5" /> 
          <t:Tr>piv, eli maksimiaika kahden opinnytteen tapahtuman vlill. Jos muistutusvli ylittyy, 
                lhetetn asiasta shkpostiviesti.</t:Tr></td>
    </tr>
    <tr>
      <td valign="top"><strong><t:Tr>Julkinen</t:Tr></strong></td>
      <sql:getColumn colName="pgroup" to="pgroup" scope="page" />
      <% String selected=""; if ( Integer.parseInt((String)pageContext.getAttribute("pgroup")) > 0 ) selected = "checked=\"checked\""; %>
      <td><input type="checkbox" <%=selected%> name="ispublic" value="0" />
          eli esitetnk opinnyte hakutuloksissa tyn hyvksymisen jlkeen.</td>
    </tr>
    <tr>
      <td valign="top"><strong><t:Tr>Aihe vapaa </t:Tr></strong></td>
      <td><input type="text" name="available" value="<sql:getColumn colName="available" />" size="5" /> <t:Tr>ryhmlle</t:Tr></td>
    </tr>

  <tr>
    <td><strong><t:Tr>Aloituspiv</t:Tr></strong></td>
    <td><sql:getDate colName="begindate" to="bdate" /><%=timeformater.monthToOutFormat((String)pageContext.getAttribute("bdate"))%></td>
  </tr>
  <tr>
    <td><strong><t:Tr>Hyvksymispiv</t:Tr></strong></td>
    <sql:getDate colName="finisheddate" to="fdate" />
    <% String fdate=""; 
       if ( pageContext.getAttribute("fdate") != null ) fdate = timeformater.monthToOutFormat((String)pageContext.getAttribute("fdate"));
    %>   
    <td><input type="text" name="finisheddate" size="12" value="<%=fdate%>" /> <%--pp.kk.vvvv--%>
         voi olla mys arvio tyn hyvksymispivst.</td>
  </tr>

    </sql:resultSet>
  </sql:statement>

</table>

<p>
<input type="submit" name="update" value="<t:Tr>Tallenna tiedot</t:Tr>" />
</p>
</form>

</div>

<%--
<br />
<h4><t:Tr>Opinnytteeseen liittyvt henkilt</t:Tr></h4>

<div class="in">
<table>
  <sql:statement id="stmt2" conn="conn2">
    <sql:query>
       select person.lastname || ' ' || person.firstnames as name,
              assroletranslation.name as rolename,
               personparameter.personparametervalue as email
       from   assignmentrelatedperson
       where  assignmentrelatedperson.deleted = false
       and    assignmentrelatedperson.assignmentid = <%=assID%>  
       and    assignmentrelatedperson.personid = person.personid
       and    person.deleted = false
       and    assignmentrelatedperson.roleid = assignmentrole.roleid
       and    assignmentrole.deleted = false
       and    assignmentrole.roleid = assroletranslation.roleid
       and    assroletranslation.deleted = false
       and    assroletranslation.languageid = <%=languageID%>
       and    personparameter.deleted = false 
       and    personparameter.personid = person.personid
       and    personparameter.personparametertypeid = 3                    
       order by roleid, person.lastname;
    </sql:query>
    <sql:resultSet id="rset2"> 
      <tr> 
        <td><strong><sql:getColumn colName="rolename" /></strong></td>
        <td><sql:getColumn colName="name" /></td>
        <td>&nbsp;&nbsp;<sql:getColumn colName="email" /></td>
      </tr> 
    </sql:resultSet>
  </sql:statement>
</table>

</div>
--%>

<%--
<br />
<h4><t:Tr>Opinnytteeseen liittyvt tytehtvt</t:Tr></h4>

<div class="in">
<table>
  <sql:statement id="stmt2" conn="conn2">
    <sql:query>
       select asstasktranslation.name as taskname,
              asstaskcategorytranslation.name as catname,
              assphasetranslation.name as taskphase
       from   assignmenttaskrelation
       where  assignmenttaskrelation.deleted = false
       and    assignmenttaskrelation.assignmentid = <%=assID%>  
       and    assignmenttaskrelation.taskid = assignmenttask.taskid
       and    assignmenttask.deleted = false
       and    assignmenttask.taskid = asstasktranslation.taskid
       and    asstasktranslation.languageid = <%=languageID%>
       and    assignmenttask.categoryid = asstaskcategory.categoryid
       and    asstaskcategory.categoryid = asstaskcategorytranslation.categoryid
       and    asstaskcategorytranslation.languageid = <%=languageID%>
       and    assignmenttaskrelation.phaseid = assignmentphase.phaseid
       and    assignmentphase.phaseid = assphasetranslation.phaseid
       and    assphasetranslation.languageid = <%=languageID%> 
       order by catname, taskname 
    </sql:query>
    <sql:resultSet id="rset2"> 
    <tr>
      <td><sql:getColumn colName="catname" /></td> 
      <td><sql:getColumn colName="taskname" /></td> 
      <td><sql:getColumn colName="taskphase" /></td> 
    </tr>   
    </sql:resultSet>
  </sql:statement>
</table>

</div>
--%>

<%-- oikeudet... --%>

<br />
<form action="assignmentRemove.jsp" method="post">
<input type="hidden" name="assid" value="<%=assID%>" />
<p>


<h4><t:Tr>Opinnytteen poistaminen</t:Tr></h4>

<p><t:Tr>Opinnyte poistetaan tietokannasta ja sen suoritusta ei en voida jatkaa. Jos haluat 
keskeytt opinnytteen suorituksen, valitse opinnytteen vaiheeksi keskeytetty.</t:Tr></p>
<p><t:Tr>Opinnytteen poistaminen ei poista alkuperist aihetta tietokannasta.</t:Tr></p>
<input type="submit" name="submit" value="<t:Tr>Poista opinnyte</t:Tr>"
</p>
</form>


<p>
<t:Tr><a href="assignment.jsp?assid=<%=assID%>">Opinnytteen tiedot ja tapahtumat</a></t:Tr>
| <t:Tr><a href="assignmentUpdatePerson.jsp?assid=<%=assID %>">Lis/poista henkilit</a></t:Tr>
| <t:Tr><a href="assignmentUpdateTask.jsp?assid=<%=assID %>">Pivit tytehtvi</a></t:Tr>

<% if ( canGrade ) { %>
| <t:Tr><a href="assignmentGrade.jsp?assid=<%=assID %>">Arvioi opiskelija</a></t:Tr>
<% } %>
<% if ( canFinish ) { %>
| <t:Tr><a href="assignmentGradeFinish.jsp?assid=<%=assID %>">Opinnytteen hyvksyminen</a></t:Tr>
<% } %>
</p>

<%@ include file="/shared/pageEnd.inc" %>


