<%
/***************************************************************************************************
*               PAGE DESCRIPTION
****************************************************************************************************
*
*               NAME:           proposeInsert.jsp
*               LANGUAGE:       JSP
*               DATE:           27.4.2002
*               AUTHOR:         Minna Hillebrand, University of Jyvskyl (JYU)
*               PURPOSE:        Update the values related to assignment into multiple tables
*                                            
*
****************************************************************************************************
*               COPYRIGHT (C) KOPPELO PROJECT GROUP
*               Limited rights granted. Please refer to GNU General Public License
*               http://www.gnu.org/licenses/gpl.html
****************************************************************************************************

****************************************************************************************************
*               UPDATES
****************************************************************************************************
*           
*
*
****************************************************************************************************/
%>


<%@ include file="/shared/beans.inc" %>
<%@ include file="/shared/constants.inc" %>
<%@ include file="/shared/dbconnect.inc" %>

<%

 if (request.getParameter("assid") == null) {
    response.sendRedirect("error.jsp?page=assignmentUpdateInsert&message=1");
    return;
 }
 String  assID = request.getParameter("assid");


   police.setDB(db);

   boolean canUpdate = false;
   try {
     if ( ! police.hasPersonRight(allowAssUpdate, personID, Integer.parseInt(assID)) ) {
        response.sendRedirect("errorNoAccess.jsp"); 
        return;   
     }
   } catch (Exception e) { 
       response.sendRedirect("error.jsp?message=2&page=assignmentUpdateInsert"); 
      return;
   } 

%>



<%
 /* check that we've got all parameters */

  
 if (request.getParameter("title") == null) {
    response.sendRedirect("error.jsp?page=assignmentUpdateInsert&message=1");
    return;
 }
 String title = request.getParameter("title");

 if (request.getParameter("description") == null) {
    response.sendRedirect("error.jsp?page=assignmentUpdateInsert&message=1");
    return;
 }
 String  description = request.getParameter("description");

/*
 if (request.getParameter("keywords") == null) {
    response.sendRedirect("error.jsp?page=assignmentUpdateInsert&message=1");
    return;
 }
 String  keywords = request.getParameter("keywords");
*/

 if (request.getParameter("lineid") == null) {
    response.sendRedirect("error.jsp?page=assignmentUpdateInsert&message=1");
    return;
 }
 String  lineID = request.getParameter("lineid");

 if (request.getParameter("typeid") == null) {
    response.sendRedirect("error.jsp?page=assignmentUpdateInsert&message=1");
    return;
 }
 String  typeID = request.getParameter("typeid");

 if (request.getParameter("phaseid") == null) {
    response.sendRedirect("error.jsp?page=assignmentUpdateInsert&message=1");
    return;
 }
 String  phaseID = request.getParameter("phaseid");

 if (request.getParameter("courseid") == null) {
    response.sendRedirect("error.jsp?page=assignmentUpdateInsert&message=1");
    return;
 }
 String  courseID = request.getParameter("courseid");

 String publicID = "1"; 
 if (request.getParameter("ispublic") == null) { publicID = "0"; }


 if (request.getParameter("finisheddate") == null) {
    response.sendRedirect("error.jsp?page=assignmentUpdateInsert&message=1");
    return;
 }
 time timeformater = new time();
 String finishedDate="";
  
 try {
   if (! ((String)request.getParameter("finisheddate")).equals("") ) 
   finishedDate = timeformater.monthToDBFormat((String)request.getParameter("finisheddate"));
 } catch (Exception e) {} 

 if (request.getParameter("available") == null) {
    response.sendRedirect("error.jsp?page=assignmentUpdateInsert&message=1");
    return;
 }
 String  available = request.getParameter("available");

 String warntime = "null";
 if (request.getParameter("warntime") != null) 
   warntime = request.getParameter("warntime");
   if (warntime.equals("")) warntime = "null"; 


%>



<sql:statement id="stmt3" conn="conn2">
  <sql:query>
     update assignment
     set  courseid = <%=courseID%>, 
          lineid = <%=lineID%>,
          assignmenttypeid = <%=typeID%>,
          phaseid = <%=phaseID%>,
          publicgroup = <%=publicID%>,
<%  if (finishedDate == null || finishedDate.equals("") || finishedDate.equals("null") ) { %>
          finisheddate = null,
<% } else { %>
          finisheddate = '<%=finishedDate%>',
<% } %> 
          warningtime = <%=warntime%>
     where assignmentid = <%=assID%>
  </sql:query>
  <sql:execute />
</sql:statement>


<sql:statement id="stmt3" conn="conn2">
  <sql:query>
     update assignmentoriginal
     set available = <%=available%>
     where assignment.assignmentid = <%=assID%>
     and   assignment.originalid = assignmentoriginal.originalid 
  </sql:query>
  <sql:execute />
</sql:statement>




<sql:statement id="stmt7" conn="conn2">
  <sql:query>
   select assdetailtranslation.name as detname,
          assdetailtranslation.detailid as detid, 
          assignmentreldetail.allowupdate as allow
   from  assignmentreldetail
   where assignmentreldetail.assignmentid = <%=assID%>
   and   assignmentreldetail.detailid = assignmentdetail.detailid
   and   assignmentdetail.typeid = <%=titleID%>
   and   assignmentdetail.detailid = assdetailtranslation.detailid
   and   assdetailtranslation.languageid = <%=languageID%>
  </sql:query>
  <sql:resultSet id="rset7">
    <sql:getColumn colName="allow" to="allow" scope="page"/>
    <sql:getColumn colName="detname" to="detname" scope="page"/>
    <% String allow  = (String)pageContext.getAttribute("allow");
       if (allow.equals("false")) { 
         String detname = (String)pageContext.getAttribute("detname");
         if (!detname.equals(title)) {
%>         <sql:statement id="stmt3" conn="conn2">               <%-- get max id of details --%>
           <sql:query>
             select max(assignmentdetail.detailid)+1 as maxdet
             from  assignmentdetail
           </sql:query>
           <sql:resultSet id="rset3">
             <sql:getColumn colName="maxdet" to="maxdet" scope="page"/>
           </sql:resultSet>
           </sql:statement>
<%         String maxid = "1";
           if ( pageContext.getAttribute("maxdet") != null ) maxid = (String)pageContext.getAttribute("maxdet");
%>         <sql:statement id="stmt3" conn="conn2">               <%-- insert new instance --%>
           <sql:query>
             insert into assignmentdetail (deleted, detailid, typeid)
             values (false, <%=maxid%>, <%=titleID%>);
           </sql:query>
           <sql:execute />
           </sql:statement>
           <sql:statement id="stmt3" conn="conn2">               <%-- insert translation   --%>
           <sql:query>
             insert into assdetailtranslation (deleted, detailid, languageid, name)
             values (false, <%=maxid%>, <%=languageID%>, '<%=title%>');
           </sql:query>
           <sql:execute />
           </sql:statement>
           <sql:statement id="stmt3" conn="conn2">               <%-- update relation      --%>
           <sql:query>
             update assignmentreldetail
             set    allowupdate = true,
                    detailid = <%=maxid%>
             where  assignmentid = <%=assID%>
             and    detailid = <sql:getColumn colName="detid" />   
           </sql:query>
           <sql:execute />
           </sql:statement>
<%       }        
       } 
       else { 
%>       <sql:statement id="stmt3" conn="conn2">
         <sql:query>
           update assdetailtranslation
           set name = '<%=title%>'
           where detailid = <sql:getColumn colName="detid" />
         </sql:query>
         <sql:execute />
         </sql:statement>
<%     }
%> 
  </sql:resultSet>
</sql:statement>



<sql:statement id="stmt7" conn="conn2">
  <sql:query>
   select assdetailtranslation.name as detname,
          assdetailtranslation.detailid as detid, 
          assignmentreldetail.allowupdate as allow
   from  assignmentreldetail
   where assignmentreldetail.assignmentid = <%=assID%>
   and   assignmentreldetail.detailid = assignmentdetail.detailid
   and   assignmentdetail.typeid = <%=descriptionID%>
   and   assignmentdetail.detailid = assdetailtranslation.detailid
   and   assdetailtranslation.languageid = <%=languageID%>
  </sql:query>
  <sql:resultSet id="rset7">
    <sql:getColumn colName="allow" to="allow" scope="page"/>
    <sql:getColumn colName="detname" to="detname" scope="page"/>
    <% String allow  = (String)pageContext.getAttribute("allow");
       if (allow.equals("false")) { 
         String detname = (String)pageContext.getAttribute("detname");
         if (!detname.equals(title)) {
%>         <sql:statement id="stmt3" conn="conn2">               <%-- get max id of details --%>
           <sql:query>
             select max(assignmentdetail.detailid)+1 as maxdet
             from  assignmentdetail
           </sql:query>
           <sql:resultSet id="rset3">
             <sql:getColumn colName="maxdet" to="maxdet" scope="page"/>
           </sql:resultSet>
           </sql:statement>
<%         String maxid = "1";
           if ( pageContext.getAttribute("maxdet") != null ) maxid = (String)pageContext.getAttribute("maxdet");
%>         <sql:statement id="stmt3" conn="conn2">               <%-- insert new instance --%>
           <sql:query>
             insert into assignmentdetail (deleted, detailid, typeid)
             values (false, <%=maxid%>, <%=descriptionID%>);
           </sql:query>
           <sql:execute />
           </sql:statement>
           <sql:statement id="stmt3" conn="conn2">               <%-- insert translation   --%>
           <sql:query>
             insert into assdetailtranslation (deleted, detailid, languageid, name)
             values (false, <%=maxid%>, <%=languageID%>, '<%=description%>');
           </sql:query>
           <sql:execute />
           </sql:statement>
           <sql:statement id="stmt3" conn="conn2">               <%-- update relation      --%>
           <sql:query>
             update assignmentreldetail
             set    allowupdate = true,
                    detailid = <%=maxid%>
             where  assignmentid = <%=assID%>
             and    detailid = <sql:getColumn colName="detid" />   
           </sql:query>
           <sql:execute />
           </sql:statement>
<%       }        
       } 
       else { 
%>       <sql:statement id="stmt3" conn="conn2">
         <sql:query>
           update assdetailtranslation
           set name = '<%=description%>'
           where detailid = <sql:getColumn colName="detid" />
         </sql:query>
         <sql:execute />
         </sql:statement>
<%     }
%> 
  </sql:resultSet>
</sql:statement>


<%-- keywords --%>

<sql:statement id="stmt2" conn="conn2">
  <sql:query>  
    update assignmentrelkeyword
    set deleted = true
    where assignmentid = <%=assID%>    
  </sql:query>
  <sql:execute />
</sql:statement>

<%
  boolean success = false;

  if ( request.getParameter("keywords") != null) {
      int i=0; 
      int lkm=0;

      int beg = 0; 
      int end = 0;
      String [] keys = new String [100];
      String key = request.getParameter("keywords");

      while ( end < key.length() ) {

        end = key.indexOf(",", beg);
        if ( end < 0 ) end = key.length();
        if (beg >= end ) break;
        keys[i] = (key.substring(beg, end)).trim();
        beg = end+1;
        i++;
      }
    lkm = i;
    for (i=0; i < lkm; i++) { 
      int keyid = 1;
      success=false; 
%>
      <sql:statement id="stmt2" conn="conn2">
       <sql:query>
           select assignmentkeyword.keywordid as id
           from   asskeywordtranslation
           where asskeywordtranslation.deleted = false
           and   asskeywordtranslation.languageid = <%=languageID%>
           and   lower(asskeywordtranslation.name) like lower('<%=keys[i]%>')
           and   asskeywordtranslation.keywordid = assignmentkeyword.keywordid
           and   assignmentkeyword.deleted = false;
        </sql:query>
        <sql:resultSet id="rset2">
        <sql:getColumn colName="id" to="keyid" scope="page" />
          <% String apu = (String)pageContext.getAttribute("keyid");
             if ( apu != null )  success = true; %>
        </sql:resultSet> 
      </sql:statement> 
<%
      if (success) { keyid = Integer.parseInt((String)pageContext.getAttribute("keyid")); }
      else { 

%>   
      <sql:statement id="stmt2" conn="conn2">
        <sql:query>
           select max(keywordid)+1 as max from assignmentkeyword;
        </sql:query>
        <sql:resultSet id="rset2">
        <sql:getColumn colName="max" to="keyid" scope="page" />
          <% String apu = (String)pageContext.getAttribute("keyid");
             if ( apu != null )  success = true; %>
        </sql:resultSet>
      </sql:statement>
      <% if (success) keyid = Integer.parseInt((String)pageContext.getAttribute("keyid")); %>
      <sql:statement id="stmt2" conn="conn2">
        <sql:query>
           insert into assignmentkeyword 
           (deleted, keywordid) values
           ('false', <%=keyid%>);
        </sql:query>
        <sql:execute />
      </sql:statement>
      <sql:statement id="stmt2" conn="conn2">
        <sql:query>
           insert into asskeywordtranslation 
           (deleted, keywordid, languageid, name) values
           ('false', <%=keyid%>, <%=languageID%>, '<%=keys[i]%>');
        </sql:query>
        <sql:execute />
      </sql:statement>
<%    }
    // Finally update to relation table 
      try {
%>
      <sql:statement id="stmt2" conn="conn2">
        <sql:query>
           insert into assignmentrelkeyword 
           (deleted, assignmentid, keywordid) values
           ('false', <%=assID%>, <%=keyid%>);
        </sql:query>
        <sql:execute />
      </sql:statement>
<%    } catch (Exception kex) {
%>
      <sql:statement id="stmt3" conn="conn2">
        <sql:query>
           update assignmentrelkeyword 
           set deleted = false
           where assignmentid = <%=assID%>
           and   keywordid =  <%=keyid%>;
        </sql:query>
        <sql:execute />
      </sql:statement>
<%    }
    }  
  }

%>



<% response.sendRedirect("assignmentUpdate.jsp?updated=true&assid="+assID); %>


