<%
/***************************************************************************************************
*               PAGE DESCRIPTION
****************************************************************************************************
*
*               NAME:           assignmentUpdatePerson.jsp
*               LANGUAGE:       JSP
*               DATE:           22.4.2002
*               AUTHOR:         Minna Hillebrand, University of Jyvskyl (JYU)
*               PURPOSE:        Maintain assignment related person
*
****************************************************************************************************
*               COPYRIGHT (C) KOPPELO PROJECT GROUP
*               Limited rights granted. Please refer to GNU General Public License
*               http://www.gnu.org/licenses/gpl.html
****************************************************************************************************

****************************************************************************************************
*               UPDATES
****************************************************************************************************
*               26.04.2002 M Ylitalo
*               Added 
*                    textarea displays account names too
*
****************************************************************************************************/
%>

<%@ include file="/shared/header.inc" %>
<%@ include file="/shared/beans.inc" %>
<%@ include file="/shared/constants.inc" %>
<%@ include file="/shared/dbconnect.inc" %>

<%-- Check that user is allowed   --%>


<%
  if (request.getParameter("assid") == null) { 
      response.sendRedirect("error.jsp?page=assignmentUpdatePerson&message=1");
      return;
    }

   int assID = Integer.parseInt(request.getParameter("assid"));   



   police.setDB(db);

   boolean canUpdate = false;
   boolean canGrade  = false;
   boolean canFinish = false; 
   boolean canPerson = false;

   if ( ! police.hasPersonRight(allowAssUpdatePerson, personID, assID) ) {
      response.sendRedirect("errorNoAccess.jsp"); 
      return;   
   }
   canPerson = true;

   if ( police.hasPersonRight(allowAssUpdate, personID, assID) )   canUpdate = true;
   if ( police.hasPersonRight(allowAssFinish, personID, assID) )   canFinish = true;
   if ( police.hasPersonRight(allowGradeID, personID, assID) )     canGrade  = true;

%>


<%-- add and remove person --%>


<% 

  if (request.getParameter("addperson") != null) { 
    int i;
    String[] adds = new String[100];
    adds = request.getParameterValues("addperson");
%>
    <sql:statement id="stmt7" conn="conn2">
    <sql:query>
      select max(assignmentrelatedperson.relationid)+1 as relid
      from  assignmentrelatedperson
    </sql:query>  
    <sql:resultSet id="rset7">
      <sql:getColumn colName="relid" to="relid" scope="page"/>    
      </sql:resultSet>
    </sql:statement>
<%
    int relID = Integer.parseInt((String)pageContext.getAttribute("relid"));
    boolean relationExists = false;
    for(i=0;i < adds.length;i++) {
      relationExists = false;  
%>    <sql:statement id="stmt3" conn="conn2">
      <sql:query>
        select assignmentrelatedperson.relationid
        from   assignmentrelatedperson
        where assignmentid = <%=assID%> 
        and   personid =  <%=adds[i]%> 
      </sql:query>
      <sql:resultSet id="rset3">
        <sql:getColumn colName="relationid" to="oldrel" />
<%       if ( pageContext.getAttribute("oldrel") != null ) { 
           relationExists = true; 
%>
           <sql:statement id="stmt4" conn="conn2">
           <sql:query>
            update assignmentrelatedperson 
            set deleted = false,
                roleid =  <%=request.getParameter("role")%> 
            where relationid = <sql:getColumn colName="relationid" />
            </sql:query>
            <sql:execute />
            </sql:statement>
         <% } %>
      </sql:resultSet> 
      </sql:statement>

<%    if (!relationExists) {  %> 
        <sql:statement id="stmt2" conn="conn2">
        <sql:query>
          insert into assignmentrelatedperson (deleted, relationid, assignmentid, personid, roleid)
          values ('false', <%=relID%>, <%=assID%>, <%=adds[i]%>, 
                  <%=request.getParameter("role")%> );
        </sql:query>
        <sql:execute />
        </sql:statement> 
<%
        relID++;
      } 
    }
  }


  if (request.getParameter("removeperson") != null) { 
    int i;
    String[] remove = new String[100];
    remove = request.getParameterValues("removeperson");
    for(i=0;i < remove.length;i++) { 


  %> 
    <sql:statement id="stmt2" conn="conn2">
      <sql:query>
        select count(General.personid) as lkm
        from   assignmentrelatedperson as General
        where  General.assignmentid = <%=assID%>
        and    General.roleid > <%=studentID%>
        and    General.deleted = false
        and    General.relationid <> <%=remove[i]%>
    <%--     group by General.personid --%>
      </sql:query>
      <sql:resultSet id="rset3">
        <sql:getColumn colName="lkm" to="lkm" scope="page" />
       </sql:resultSet>
    </sql:statement> 

<%     int lkm = 1;
       try {
         lkm = Integer.parseInt((String)pageContext.getAttribute("lkm"));
       } catch (Exception e) {} 
       if (lkm > 0 ) {  %>

    <sql:statement id="stmt2" conn="conn2">
      <sql:query>
        update assignmentrelatedperson
        set    deleted = true
        where  assignmentrelatedperson.relationid = <%=remove[i]%>
      </sql:query>
      <sql:execute />
    </sql:statement> 

  <%
     
        }

    }
  }
%>



<%--@ include file="/shared/header.inc" --%>
<%@ include file="/shared/menus.inc" %>

<p>
<t:Tr><a href="assignment.jsp?assid=<%=assID%>">Opinnytteen tiedot ja tapahtumat</a></t:Tr>
<% if ( canUpdate ) { %>
| <t:Tr><a href="assignmentUpdate.jsp?assid=<%=assID %>">Muuta tietoja</a></t:Tr>
| <t:Tr><a href="addEvent.jsp?assid=<%=assID%>">Lis tapahtuma</a></t:Tr>
<%--| <t:Tr><a href="assignmentUpdatePerson.jsp?assid=<%=assID %>">Lis/poista henkilit</a></t:Tr> --%>
| <t:Tr><a href="assignmentUpdateTask.jsp?assid=<%=assID %>">Pivit tytehtvi</a></t:Tr>
<% } %>
<% if ( canGrade ) { %>
| <t:Tr><a href="assignmentGrade.jsp?assid=<%=assID %>">Arvioi opiskelija</a></t:Tr>
<% } %>
<% if ( canFinish ) { %>
| <t:Tr><a href="assignmentGradeFinish.jsp?assid=<%=assID %>">Opinytteen hyvksyminen</a></t:Tr>
<% } %>
</p>

<h3><t:Tr>Opinnytteen henkiliden hallinta</t:Tr></h3>

<br />
<sql:statement id="stmt2" conn="conn2">
  <sql:query>
   select assdetailtranslation.name as assname, 
          assignment.assignmentid as assid
   from  assignment 
   where assignment.deleted = false 
   and   assignment.assignmentid = <%=assID%>
   and   assignmentreldetail.assignmentid = assignment.assignmentid
   and   assignmentreldetail.deleted = false  
   and   assignmentreldetail.detailid = assignmentdetail.detailid
   and   assignmentdetail.typeid = <%=titleID%> 
   and   assdetailtranslation.detailid = assignmentdetail.detailid
   and   assdetailtranslation.languageid = <%=languageID%>;
  </sql:query>
  <sql:resultSet id="rset2">
    <h4><a href="assignmentUpdate.jsp?assid=<sql:getColumn colName="assid" />"><sql:getColumn colName="assname" /></a></h4> 
    <sql:getColumn colName="assid" to="assid" scope="page"/>
  </sql:resultSet>
</sql:statement>

<%--<p><a href="assignmentUpdate.jsp?assid=<%=assID%>">Opinnytteen tietoihin </a></p>
--%>

<div>
<form action="assignmentUpdatePerson.jsp" method="post">
  <input type="hidden" name="assid" value="<%=assID%>" />


<% String ehto="";
   if ( request.getParameter("condition") != null ) 
     ehto = (String)request.getParameter("condition");
   if (ehto.equals("null")) ehto = "";   
%>
  <p>Lisehto sukunimelle <input type="text" name="condition" value="<%=ehto%>" size="30" />
  <input type="submit" name="search" value="Hae" />
  </p>
</form>
</div>

<hr width="75%" />

<table border ="0">
<tr>
<td><h3><t:Tr>Listtvt henkilt</t:Tr></h3></td>
<td>&nbsp;</td>
<td><h3><t:Tr>Opinnytteen henkilt</t:Tr></h3></td>
</tr>
<tr>


<td>
<form action="assignmentUpdatePerson.jsp" method="post">
  <input type="hidden" name="assid" value="<%=assID%>" />
  <input type="hidden" name="condition" value="<%=request.getParameter("condition")%>" />


<%  String condition = ""; 

    if (request.getParameter("condition") != null) {
      int i=0;
      int lkm=0;

      int beg = 0; 
      int end = 0;
      String [] conds = new String [100];
      String con = request.getParameter("condition");

      while ( end < con.length() ) {

        end = con.indexOf(",", beg);
        if ( end < 0 ) end = con.length();
        if (beg >= end ) break;
        conds[i] = (con.substring(beg, end)).trim();
        beg = end+1;
        i++;
      }
      lkm = i;

      condition = "and ( lower(person.lastname) like lower(\'" +conds[0] +"%\') ";
      for(i=1;i < lkm;i++) {
        condition += "or lower(person.lastname) like lower(\'" +conds[i] +"%\') ";    
       } 
      condition += ")";  
    } 
%>

<div>
  <select multiple name="addperson" size="20"> 
<% if (condition != "") { %> 
  <sql:statement id="stmt2" conn="conn2">
    <sql:query>
       select person.lastname || ' ' || person.firstnames as name,
              person.personid as personid, person.account as account
       from   person
       where  person.deleted = false
       <%=condition %>
       order by person.lastname;
    </sql:query>
    <sql:resultSet id="rset2">
      <option value="<sql:getColumn colName="personid" />">
                     <sql:getColumn colName="name" />  
                     '<sql:getColumn colName="account" />'
      </option>
    </sql:resultSet>
  </sql:statement>
<% } %>
  </select>
</div>
</td>

<td valign="top">
  <div>Rooli 
  <select name="role">
  <sql:statement id="stmt2" conn="conn2">
    <sql:query>
     select assroletranslation.name as name,
            assignmentrole.roleid as roleid
     from   assignmentrole
     where  assignmentrole.deleted = false
     and    assignmentrole.roleid = assroletranslation.roleid
     and    assroletranslation.deleted = false
     and    assroletranslation.languageid = <%=languageID%>
    </sql:query>
    <sql:resultSet id="rset2">
      <option value="<sql:getColumn colName="roleid" />">
      <sql:getColumn colName="name" /> </option>
    </sql:resultSet>
  </sql:statement>
  </select>
  </div>

<p>
  <input type="submit" name="update" value="Liit henkilt" />
  </p>
</form>

</td>

<td valign="top">
<form action="assignmentUpdatePerson.jsp" method="post">
  <input type="hidden" name="assid" value="<%=assID%>" />
  <input type="hidden" name="condition" value="<%=request.getParameter("condition")%>" />

<div>
  <select multiple name="removeperson" size="10">
  <sql:statement id="stmt2" conn="conn2">
    <sql:query>
       select assignmentrelatedperson.relationid as relid,
              person.lastname || ' ' || person.firstnames as name,
              assroletranslation.name as rolename,
              person.account as account
       from   assignmentrelatedperson
       where  assignmentrelatedperson.deleted = false
       and    assignmentrelatedperson.assignmentid = <%=assID%>  
       and    assignmentrelatedperson.personid = person.personid
       and    person.deleted = false
       and    assignmentrelatedperson.roleid = assignmentrole.roleid
       and    assignmentrole.deleted = false
       and    assignmentrole.roleid = assroletranslation.roleid
       and    assroletranslation.deleted = false
       and    assroletranslation.languageid = <%=languageID%>                    
       order by assignmentrelatedperson.roleid, person.lastname;
    </sql:query>
    <sql:resultSet id="rset2">
      <option value="<sql:getColumn colName="relid" />">
      <sql:getColumn colName="name" /> '<sql:getColumn colName="account" />'   
                                        ( <sql:getColumn colName="rolename" /> )
      </option>
    </sql:resultSet>
  </sql:statement>
  </select>
</div>

<p>
  <input type="submit" name="update" value="Poista henkilt" />
  </p>
</form>
</td>
</tr>
</table>

<p>
<t:Tr><a href="assignment.jsp?assid=<%=assID%>">Opinnytteen tiedot ja tapahtumat</a></t:Tr>
<% if ( canUpdate ) { %>
| <t:Tr><a href="assignmentUpdate.jsp?assid=<%=assID %>">Muuta tietoja</a></t:Tr>
| <t:Tr><a href="addEvent.jsp?assid=<%=assID%>">Lis tapahtuma</a></t:Tr>
<%--| <t:Tr><a href="assignmentUpdatePerson.jsp?assid=<%=assID %>">Lis/poista henkilit</a></t:Tr> --%>
| <t:Tr><a href="assignmentUpdateTask.jsp?assid=<%=assID %>">Pivit tytehtvi</a></t:Tr>
<% } %>
<% if ( canGrade ) { %>
| <t:Tr><a href="assignmentGrade.jsp?assid=<%=assID %>">Arvioi opiskelija</a></t:Tr>
<% } %>
<% if ( canFinish ) { %>
| <t:Tr><a href="assignmentGradeFinish.jsp?assid=<%=assID %>">Opinnytteen hyvksyminen</a></t:Tr>
<% } %>
</p>

<%@ include file="/shared/pageEnd.inc" %>



