
<%
/***************************************************************************************************
*               PAGE DESCRIPTION
****************************************************************************************************
*
*               NAME:           assignmentUpdateTask.jsp
*               LANGUAGE:       JSP
*               DATE:           27.4.2002
*               AUTHOR:         Minna Hillebrand, University of Jyvskyl (JYU)
*               PURPOSE:        Maintain assignment related task
*
****************************************************************************************************
*               COPYRIGHT (C) KOPPELO PROJECT GROUP
*               Limited rights granted. Please refer to GNU General Public License
*               http://www.gnu.org/licenses/gpl.html
****************************************************************************************************

****************************************************************************************************
*               UPDATES
****************************************************************************************************
*              
*              
*              
*
****************************************************************************************************/
%>


<%@ include file="/shared/beans.inc" %>
<%@ include file="/shared/constants.inc" %>
<%@ include file="/shared/dbconnect.inc" %>

<%-- Check that user is allowed --%>


<%
int assID = 0;
  if (request.getParameter("assid") == null) {
      response.sendRedirect("error.jsp?page=assignmentUpdate&message=1");
      return;
    }
try {
   assID = Integer.parseInt(request.getParameter("assid"));   
} catch (Exception y) { %>OHO <% return;  }



   police.setDB(db);

   boolean canUpdate = false;
   boolean canGrade  = false;
   boolean canFinish = false; 


   if ( ! police.hasPersonRight(allowAssUpdate, personID, assID) ) {
      response.sendRedirect("errorNoAccess.jsp"); 
      return;   
   }
   canUpdate = true;

   if ( police.hasPersonRight(allowAssFinish, personID, assID) )   canFinish = true;
   if ( police.hasPersonRight(allowGradeID, personID, assID) )     canGrade  = true;

%>


<%-- add and remove task --%>


<% 
  if (request.getParameter("templateid") != null) { 
    try {
%>

   <sql:statement id="stmt6" conn="conn2">
     <sql:query>
        update assignmenttaskrelation
        set    deleted = true
        where  assignmenttaskrelation.assignmentid = <%=assID%>
     </sql:query>
     <sql:execute />
   </sql:statement>

   <sql:statement id="stmt5" conn="conn2">
       <sql:query>
            insert into assignmenttaskrelation (deleted, assignmentid, taskid, phaseid)
            select 'false', <%=assID%>, asstasktemplaterelation.taskid, <%=defaultTaskPhaseID%> 
            from   asstasktemplaterelation  
            where  asstasktemplaterelation.deleted = false
            and    asstasktemplaterelation.templateid = <%=request.getParameter("templateid")%>
          </sql:query>
          <sql:execute />
          </sql:statement>
<%   } catch (Exception e) { 
%>   <sql:statement id="stmt6" conn="conn2">
       <sql:query>
            update assignmenttaskrelation
            set    deleted = false
            where  assignmenttaskrelation.assignmentid = <%=assID%>
            and    assignmenttaskrelation.taskid in (
              select asstasktemplaterelation.taskid
              from   asstasktemplaterelation
              where  asstasktemplaterelation.deleted = false
              and    asstasktemplaterelation.templateid = <%=request.getParameter("templateid")%>
            );
          </sql:query>
          <sql:execute />
          </sql:statement>
<%   } 
  }

  if (request.getParameter("addtask") != null) { 
    int i;
    String[] adds = new String[100];
    adds = request.getParameterValues("addtask");
    for(i=0;i < adds.length;i++) { 
       boolean makeInsert = true; 
%>      <sql:statement id="stmt4" conn="conn2">
        <sql:query>
          select assignmenttaskrelation.deleted as deleted
          from   assignmenttaskrelation
          where  assignmenttaskrelation.assignmentid = <%=assID%>
          and    assignmenttaskrelation.taskid = <%=adds[i]%>
        </sql:query>
        <sql:resultSet id="rset2">
        <sql:getColumn colName="deleted" to="deleted" scope="page" />
<%      if ( pageContext.getAttribute("deleted") != null )  {
           makeInsert = false;
%>        <sql:statement id="stmt5" conn="conn2">
          <sql:query>
            update assignmenttaskrelation
            set deleted = false
            where  assignmenttaskrelation.assignmentid = <%=assID%>
            and    assignmenttaskrelation.taskid = <%=adds[i]%>
          </sql:query>
          <sql:execute />
          </sql:statement>
<%      } 
        else { makeInsert = false;
%>        <sql:statement id="stmt6" conn="conn2">
          <sql:query>
             insert into assignmenttaskrelation (deleted, assignmentid, taskid, phaseid)
             values ('false', <%=assID%>, <%=adds[i]%>, <%=defaultTaskPhaseID%>);
          </sql:query>
          <sql:execute />
          </sql:statement>
<%      }
%>
       </sql:resultSet>
       </sql:statement>
<%     if (makeInsert) {
%>       <sql:statement id="stmt6" conn="conn2">
         <sql:query>
           insert into assignmenttaskrelation (deleted, assignmentid, taskid, phaseid)
           values ('false', <%=assID%>, <%=adds[i]%>, <%=defaultTaskPhaseID%>);
         </sql:query>
         <sql:execute />
         </sql:statement>
<%     }
    } 
  }


  if (request.getParameter("removetask") != null) { 
    int i;
    String[] remove = new String[100];
    remove = request.getParameterValues("removetask");
    for(i=0;i < remove.length;i++) { 
  %> 
    <sql:statement id="stmt7" conn="conn2">
      <sql:query>
        update assignmenttaskrelation
        set    deleted = true
        where  assignmenttaskrelation.assignmentid = <%=assID%>
        and    assignmenttaskrelation.taskid = <%=remove[i]%>
      </sql:query>
      <sql:execute />
    </sql:statement> 
  <%
    }
  }

  if (request.getParameter("phaseid") != null) { 
    int i;
    String[] phases = new String[100];
    phases = request.getParameterValues("phaseid");

    for(i=0;i < phases.length;i++) { 

      String phase = "";
      String task = "";
      int end = phases[i].indexOf(",", 0);
      phase = (phases[i].substring(0, end)).trim();
      task = (phases[i].substring(end+1, ((String)phases[i]).length())).trim();


%>

  <sql:statement id="stmt7" conn="conn2">
      <sql:query>
        update assignmenttaskrelation
        set    phaseid = <%=phase%>
        where  assignmenttaskrelation.assignmentid = <%=assID%>
        and    assignmenttaskrelation.taskid = <%=task%>
      </sql:query>
      <sql:execute />
    </sql:statement> 
<%  }
  }
%>



<%@ include file="/shared/header.inc" %>
<%@ include file="/shared/menus.inc" %>


<p>
<t:Tr><a href="assignment.jsp?assid=<%=assID%>">Opinnytteen tiedot ja tapahtumat</a></t:Tr>
<% if ( canUpdate ) { %>
| <t:Tr><a href="assignmentUpdate.jsp?assid=<%=assID %>">Muuta tietoja</a></t:Tr>
| <t:Tr><a href="addEvent.jsp?assid=<%=assID%>">Lis tapahtuma</a></t:Tr>
| <t:Tr><a href="assignmentUpdatePerson.jsp?assid=<%=assID %>">Lis/poista henkilit</a></t:Tr> 
<%-- | <t:Tr><a href="assignmentUpdateTask.jsp?assid=<%=assID %>">Pivit tytehtvi</a></t:Tr> --%>
<% } %>
<% if ( canGrade ) { %>
| <t:Tr><a href="assignmentGrade.jsp?assid=<%=assID %>">Arvioi opiskelija</a></t:Tr>
<% } %>
<% if ( canFinish ) { %>
| <t:Tr><a href="assignmentGradeFinish.jsp?assid=<%=assID %>">Opinnytteen hyvksyminen</a></t:Tr>
<% } %>
</p>

<h3><t:Tr>Opinnytteen tytehtvien hallinnointi</t:Tr></h3>


<br / >
<sql:statement id="stmt2" conn="conn2">
  <sql:query>
   select assdetailtranslation.name as assname 

   from  assignment 
   where assignment.deleted = false 
   and   assignment.assignmentid = <%=assID%>
   and   assignmentreldetail.assignmentid = assignment.assignmentid
   and   assignmentreldetail.deleted = false  
   and   assignmentreldetail.detailid = assignmentdetail.detailid
   and   assignmentdetail.typeid = <%=titleID%> 
   and   assdetailtranslation.detailid = assignmentdetail.detailid
   and   assdetailtranslation.languageid = <%=languageID%>;
  </sql:query>
  <sql:resultSet id="rset2">
    <h4><a href="assignmentUpdate.jsp?assid=<%=assID%>"><sql:getColumn colName="assname" /></a></h4> 
  </sql:resultSet>
</sql:statement>

<%--<p><a href="assignmentUpdate.jsp?assid=<%=assID%>">Opinnytteen tietoihin </a></p>--%>

<br />

<h4><t:Tr>Tytehtvien liittminen opinnytteeseen</t:Tr></h4>

<div class="tasks">
<form action="assignmentUpdateTask.jsp" method="post">
 <input type="hidden" name="assid" value="<%=assID%>" />

<table>
<tr>
<td valign="top"><strong>JOKO</strong></td>
<td> kyt mallia
  <select name="templateid">
  <option value="0"></option>
  <sql:statement id="stmt6" conn="conn2">
    <sql:query>
       select asstasktemplatetranslation.name as templatename,
              asstasktemplate.templateid 
       from   asstasktemplate
       where  asstasktemplate.deleted = false
       and    asstasktemplate.templateid = asstasktemplatetranslation.templateid
       and    asstasktemplatetranslation.languageid = <%=languageID%>
    </sql:query>
    <sql:resultSet id="rset2">
      <option value="<sql:getColumn colName="templateid" />">
                     <sql:getColumn colName="templatename" /></option>
    </sql:resultSet>
  </sql:statement>
 
 </select> tytehtvien asettamiseen. Mallin  kyttminen <strong>poistaa</strong> opinnytteeseen aiemmin liitetyt tytehtvt.
 <input type="submit" name="template" value="<t:Tr>Kyt</t:Tr>" /><br/>&nbsp;
 </td>
</form>

</tr>
<tr>
<td valign="top"><strong>TAI </strong></td>
<td>

<table>
<tr>
<td valign="top">
<t:Tr> vaihtoehtoisesti voit erikseen mritt opinnytteen tytehtvt. Valitse valuamasi tytehtvt 
  viereisest listasta ja paina 'Lis tytehtvt'. Listalta valittujen tytehtvien lisminen <strong>ei poista</strong> 
  opinnytteeseen aiemmin liitettyj tytehtvi.</t:Tr></p>
</td>

<td>
<form action="assignmentUpdateTask.jsp" method="post">
  <input type="hidden" name="assid" value="<%=assID%>" />
  <select multiple name="addtask" size="7"> 
  <sql:statement id="stmt8" conn="conn2">
    <sql:query>
       select asstasktranslation.name as taskname,
              asstaskcategorytranslation.name as catname, 
              assignmenttask.taskid
       from   assignmenttask
       where  assignmenttask.deleted = false
       and    assignmenttask.taskid = asstasktranslation.taskid
       and    asstasktranslation.languageid = <%=languageID%>
       and    assignmenttask.categoryid = asstaskcategory.categoryid
       and    asstaskcategory.categoryid = asstaskcategorytranslation.categoryid
       and    asstaskcategorytranslation.languageid = <%=languageID%>
       order by catname, taskname
    </sql:query>
    <sql:resultSet id="rset2">
      <option value="<sql:getColumn colName="taskid" />">
                     <sql:getColumn colName="taskname" /> (<sql:getColumn colName="catname" />)</option>
    </sql:resultSet>
  </sql:statement>
  </select>

<input type="submit" name="submit" value="<t:Tr>Lis tytehtvt</t:Tr>" />
</form>
</td>
</tr>
</table>
</td>

</tr>
</table>

</div>

<br />
<h4>Opinnytteeseen liitetyt tytehtvt</h4>

<form action="assignmentUpdateTask.jsp" method="post">
<input type="hidden" name="assid" value="<%=assID%>" />

<table>
  <tr>
    <td><strong><t:Tr>Poista</t:Tr></strong></td>
    <td><strong><t:Tr>Luokka</t:Tr></strong></td>
    <td><strong><t:Tr>Tytehtv</t:Tr></strong></td>
    <td><strong><t:Tr>Vaihe</t:Tr></strong></td>
  </tr>
  <sql:statement id="stmt2" conn="conn2">
    <sql:query>
       select asstasktranslation.name as taskname,
              asstaskcategorytranslation.name as catname,
              assphasetranslation.name as taskphase,
              asstasktranslation.taskid as taskid,
              assphasetranslation.phaseid as phaseid
       from   assignmenttaskrelation
       where  assignmenttaskrelation.deleted = false
       and    assignmenttaskrelation.assignmentid = <%=assID%>  
       and    assignmenttaskrelation.taskid = assignmenttask.taskid
       and    assignmenttask.deleted = false
       and    assignmenttask.taskid = asstasktranslation.taskid
       and    asstasktranslation.languageid = <%=languageID%>
       and    assignmenttask.categoryid = asstaskcategory.categoryid
       and    asstaskcategory.categoryid = asstaskcategorytranslation.categoryid
       and    asstaskcategorytranslation.languageid = <%=languageID%>
       and    assignmenttaskrelation.phaseid = assignmentphase.phaseid
       and    assignmentphase.phaseid = assphasetranslation.phaseid
       and    assphasetranslation.languageid = <%=languageID%> 
       order by catname, taskname 
    </sql:query>
    <sql:resultSet id="rset2"> 
     <tr>
      <td><input type="checkbox" name="removetask" value="<sql:getColumn colName="taskid" />" /></td>  
      <sql:getColumn colName="taskid" to="task" scope="page" />
      <td><sql:getColumn colName="catname" /></td> 
      <td><sql:getColumn colName="taskname" /></td> 
      <td>
        <sql:getColumn colName="phaseid" to="selectedPhaseID" scope="page" />        
        <select name="phaseid">
        <sql:statement id="stmt4" conn="conn2">
         <sql:query>
          select assphasetranslation.name as phasename,
                 assignmentphase.phaseid as phaseid
          from   assignmentphase
          where  assignmentphase.deleted = false
           and   assignmentphase.phasegroup = 2  
           and   assignmentphase.phaseid = assphasetranslation.phaseid
           and   assphasetranslation.languageid = <%=languageID%>
        </sql:query>
        <sql:resultSet id="rset4" loop="true">
          <sql:getColumn colName="phaseid" to="curPhaseID" scope="page" />  
          <% String selected ="";
             if ( Integer.parseInt((String)pageContext.getAttribute("selectedPhaseID")) == 
                  Integer.parseInt((String)pageContext.getAttribute("curPhaseID"))         ) selected = "selected=\"selected\""; %>  
          <option <%=selected%> value="<sql:getColumn colName="phaseid" />,<%=pageContext.getAttribute("task")%>">
          <sql:getColumn colName="phasename" /></option>
        </sql:resultSet>
      </sql:statement>
      </select>
      </td>
  
     </tr>
    </sql:resultSet>
  </sql:statement>
</table>

<br />
<input type="submit" name="submit" value="Tallenna muutokset" />
</form>

<p>
<t:Tr><a href="assignment.jsp?assid=<%=assID%>">Opinnytteen tiedot ja tapahtumat</a></t:Tr>
<% if ( canUpdate ) { %>
| <t:Tr><a href="assignmentUpdate.jsp?assid=<%=assID %>">Muuta tietoja</a></t:Tr>
| <t:Tr><a href="addEvent.jsp?assid=<%=assID%>">Lis tapahtuma</a></t:Tr>
| <t:Tr><a href="assignmentUpdatePerson.jsp?assid=<%=assID %>">Lis/poista henkilit</a></t:Tr> 
<%-- | <t:Tr><a href="assignmentUpdateTask.jsp?assid=<%=assID %>">Pivit tytehtvi</a></t:Tr> --%>
<% } %>
<% if ( canGrade ) { %>
| <t:Tr><a href="assignmentGrade.jsp?assid=<%=assID %>">Arvioi opiskelija</a></t:Tr>
<% } %>
<% if ( canFinish ) { %>
| <t:Tr><a href="assignmentGradeFinish.jsp?assid=<%=assID %>">Opinnytteen hyvksyminen</a></t:Tr>
<% } %>
</p>

<%@ include file="/shared/pageEnd.inc" %>
