<%
/***************************************************************************************************
*               PAGE DESCRIPTION
****************************************************************************************************
*
*               NAME:           availableStudent.jsp
*               LANGUAGE:       JSP
*               DATE:           13.5.2002
*               AUTHOR:         Marko Ylitalo, University of Jyvskyl (JYU)
*               PURPOSE:        Show list of all subjects from witch user can start assignment
*
****************************************************************************************************
*               COPYRIGHT (C) KOPPELO PROJECT GROUP
*               Limited rights granted. Please refer to GNU General Public License
*               http://www.gnu.org/licenses/gpl.html
****************************************************************************************************

****************************************************************************************************
*               UPDATES
****************************************************************************************************
*
****************************************************************************************************/
%>

<%@ include file="/shared/beans.inc" %>
<%@ include file="/shared/constants.inc" %>
<%@ include file="/shared/dbconnect.inc" %>

<% /* No relation to database is needed because every KOTKA users are allowed to see this page */
   if ( userAccessLevel < studentID )  { response.sendRedirect("errorNoAccess.jsp"); return; }
%>

<%@ include file="/shared/header.inc" %>
<%@ include file="/shared/menus.inc" %>

<% time timeformater = new time(); %>

<h3><t:Tr>Vapaat opinnytteiden aiheet </t:Tr></h3>

<p>Sivulla esitetn ne laitoksellesi hyvksytyt opinnytteiden aiheet, joista voi aloittaa 
opinnytteen suorituksen. Aiheen nimest pset tarkastelemaan aiheen tarkempia tietoja.</p>

<div class="in">
<table>
      <tr>
<%--        <td><strong><t:Tr>Ehdotettu</t:Tr></strong></td> --%>
        <td><strong><t:Tr>Hyvksytty aiheeksi/<br>Voimassa</t:Tr></strong></td>
        <td><strong><t:Tr>Otsikko</t:Tr></strong></td>
<%--        <td><strong><t:Tr>Ehdottaja</t:Tr></strong></td>
        <td><strong><t:Tr>Hyvksyj</t:Tr></strong></td> --%>
        <td><strong><t:Tr>Vapaa</t:Tr></strong></td>
	<td><strong><t:Tr>Tyypit</t:Tr></strong></td>
      </tr>

  <sql:statement id="stmt2" conn="conn2">
    <sql:query>

      select distinct assignmentoriginal.originalid as origid,
             assignmentoriginal.proposeddate as pdate,
             assignmentoriginal.accepteddate as adate,
             assignmentoriginal.available as available,
             assignmentoriginal.validuntil as validuntil,
             Acceptor.firstnames || ' ' || Acceptor.lastname as acceptor,
             Proposer.firstnames || ' ' || Proposer.lastname as proposer,
             assdetailtranslation.name as title
      from   assignmentoriginal, person as Acceptor, person as Proposer 
      where  assignmentoriginal.deleted = false
<%--      and    assignmentoriginal.acceptedby <> null --%>
      and    assignmentoriginal.available > 0 
      and    assignmentoriginal.originalid = assoriginalreldetail.originalid
      and    assoriginalreldetail.detailid = assignmentdetail.detailid
      and    assignmentdetail.typeid = <%=titleID%>
      and    assignmentdetail.detailid = assdetailtranslation.detailid
      and    assdetailtranslation.languageid = <%=languageID%>
      and    assignmentoriginal.proposedby = Proposer.personid
      and    assignmentoriginal.acceptedby = Acceptor.personid
      and    assignmentoriginal.originalid = assoriginalposline.originalid 
      and    assoriginalposline.lineid = studyline.lineid
      and    studyline.organisationid = <%=user.getOrganisationID()%>
      and    assignmentoriginal.validuntil >= current_date 
      order by adate asc;
    </sql:query>


    <sql:resultSet id="rset2" loop="true">
      <tr>
<%--        <td valign="top"><hr /><br /><sql:getDate colName="pdate" to="pdate" /><%=timeformater.monthToOutFormat((String)pageContext.getAttribute("pdate"))%></td> --%>
        <td valign="top"><hr /><br /><sql:getDate colName="adate" to="pdate" /><%=timeformater.monthToOutFormat((String)pageContext.getAttribute("pdate"))%><br/>
           <sql:getDate colName="validuntil" to="valid" /><%=timeformater.monthToOutFormat((String)pageContext.getAttribute("valid"))%></td> 

        <td valign="top"><hr /><br /><a href="assignment.jsp?origid=<sql:getColumn colName="origid" />">
            <sql:getColumn colName="title" /></a></td> 
<%--        <td valign="top"><hr /><br /><sql:getColumn colName="proposer" /></td> 
        <td valign="top"><hr /><br /><sql:getColumn colName="acceptor" /></td> --%>
        <td valign="top"><hr /><br /><sql:getColumn colName="available" /></td> 


  <td valign="top"><hr/><br/>

  <sql:statement id="stmt3" conn="conn2">
    <sql:query>
          select asstypetranslation.name as typename
          from   assoriginalpostype
          where  assoriginalpostype.originalid = <sql:getColumn colName="origid" />
          and    assoriginalpostype.deleted = false   
          and    assoriginalpostype.typeid = asstypetranslation.typeid
          and    asstypetranslation.languageid = <%=languageID%>
    </sql:query>
    <sql:resultSet id="rset3">
      <sql:getColumn colName="typename" /><br />
    </sql:resultSet>
  </sql:statement>  
  </td>


 
      </tr>
    </sql:resultSet>
  </sql:statement>
</table>
</div>


<br/>
<p><a href="propose.jsp">Uusi aihe-ehdotus</a></p>


<%@ include file="/shared/pageEnd.inc" %>


