<%
/***************************************************************************************************
*               PAGE DESCRIPTION
****************************************************************************************************
*
*               NAME:           main.jsp
*               LANGUAGE:       JSP
*               DATE:           19.3.2002
*               AUTHOR:         Markus Silvn, University of Jyvskyl (JYU)
*
****************************************************************************************************
*               COPYRIGHT (C) KOPPELO PROJECT GROUP
*               Limited rights granted. Please refer to GNU General Public License
*               http://www.gnu.org/licenses/gpl.html
****************************************************************************************************

****************************************************************************************************
*               UPDATES
****************************************************************************************************
*               4.4.2002  Made look like KOPPELO main page, Minna Hillebrand, JYU
*              18.4.2002  Added relations to AssignmentRight-tables, Minna Hillebrand, JYU  
*              20.4.2002  Corrections to html printouts, Antti Vanhanen, JYU
*              28.4.2002  Corrections to sql-queries
*              30.5.2002  Wrong assignment phaseid corrected
*
****************************************************************************************************/
%>

<%@ include file="/shared/beans.inc" %>
<%@ include file="/shared/constants.inc" %>

<% /* No relation to database is needed because every KOTKA users are allowed to see this page */
   if ( userAccessLevel < studentID )  { response.sendRedirect("errorNoAccess.jsp"); return; }

%>

<%@ include file="/shared/header.inc" %>
<%@ include file="/shared/menus.inc" %>
<%@ include file="/shared/dbconnect.inc" %>

<h3><t:Tr>Opinnytteiden hallinta</t:Tr></h3>

<% time timeformater = new time(); %>


<%--
<p><t:Tr>KOTKA-jrjestelmn opinnytteiden hallintaosassa voidaan yllpit kaikkea 
opinnytteisiin liittyv tietoa. Tll psivulla net opinnytteisiisi 
liittyvt lukemattomat tapahtumat ja linkit ohjaamiisi keskenerisiin opinnytteisiin. 
</t:Tr></p>
--%>


<p>


<p>
<t:Tr><a href="propositions.jsp?own=true">Aihe-ehdotuksesi</a></t:Tr>
<% if ( request.getParameter("student") != null ) { %>
| <t:Tr><a href="searchResult.jsp?phaseid=4&personid=<%=personID%>">Hyvksytyt opinnytteesi</a></t:Tr>
| <t:Tr><a href="searchResult.jsp?phaseid=<%=cancelledAssignmentID%>&personid=<%=personID%>">Keskeytetyt opinnytteesi</a></t:Tr>

<% } %>
<% if ( request.getParameter("teacher") != null ) { %>
| <t:Tr><a href="searchResult.jsp?phaseid=4&personid=<%=personID%>">Hyvksytyt ohjaamasi opinnytteet</a></t:Tr>
| <t:Tr><a href="searchResult.jsp?phaseid=<%=cancelledAssignmentID%>&personid=<%=personID%>">Keskeytetyt ohjaamasi opinnytteet</a></t:Tr>
| <t:Tr><a href="available.jsp">Kiinnitettvt opinnytteet</a></t:Tr>
<% } %>
</p>



<br / >

<%-- All unread events related to user's assignments */ --%>


<%  boolean firsttime=true; %>

<h4><t:Tr>Opinnytteisiin liittyvt uudet tapahtumat</t:Tr></h4>
<div calss="in">
<table>
  <sql:statement id="stmt2" conn="conn2">
    <sql:query>
      select unreadmessages.eventid as eventid,
             assignmentevent.title as title,
             person.firstnames || ' ' || person.lastname as name,
             assignmentevent.eventdate as eventdate,
             assdetailtranslation.name as asstitle,
             assignment.assignmentid as assid            
      from   unreadmessages, assignmentrelatedperson as Reader, assignmentrelatedperson as Writer
      where   unreadmessages.deleted = false
      and    unreadmessages.asspersonid = Reader.relationid
      and    Reader.deleted = false
      and    Reader.personid = <%=personID%>
      and    unreadmessages.eventid = assignmentevent.eventid
      and    assignmentevent.assignmentid = assignment.assignmentid
      and    assignment.deleted = false
      and    assignmentevent.registratorid = Writer.relationid
      and    Writer.personid = person.personid
      and    assignment.assignmentid = assignmentreldetail.assignmentid 
      and    assignmentreldetail.deleted = false 
      and    assignmentreldetail.detailid = assignmentdetail.detailid 
      and    assignmentdetail.typeid = <%=titleID%>
      and    assignmentdetail.deleted = false
      and    assignmentdetail.detailid = assdetailtranslation.detailid
      and    assdetailtranslation.languageid = <%=languageID%> 
      order by assignmentevent.eventdate desc, title desc;
    </sql:query>

    <sql:resultSet id="rset2" loop="true"> 
<%  if (firsttime) { firsttime=false; %>
      <tr>
        <td><strong><t:Tr>Pivmr</t:Tr></strong></td> 
        <td><strong><t:Tr>Otsikko</t:Tr></strong></td> 
        <td><strong><t:Tr>Kirjaaja</t:Tr></strong></td> 
        <td><strong><t:Tr>Opinnyte</t:Tr></strong></td> 
      </tr>
<% } %>
      <tr>
        <td><sql:getDate colName="eventdate" to="eventdate"/>
        <%=timeformater.monthToOutFormat((String)pageContext.getAttribute("eventdate"))%></a>
        </td> 
        <td><a href="assignmentEvent.jsp?eventid=<sql:getColumn colName="eventid" />">
            <sql:getColumn colName="title" /></a></td> 
        <td><sql:getColumn colName="name" /></td> 
        <td><a href="assignment.jsp?assid=<sql:getColumn colName="assid" />"><sql:getColumn colName="asstitle" /></a></td> 
      </tr>
    </sql:resultSet>
  </sql:statement>
</table>

<%  if (firsttime) { %><p>Opinnytteisiisi ei liity uusia tapahtumia.</p><% } %>
</div>


<% if ( request.getParameter("teacher") != null ) { %>

<%--  KOMMENTOITU POIS!!!! 

<br / >
<h4><t:Tr>Hyvksymist kaipaaavat aihe-ehdotukset</t:Tr></h4>

<div class="in">
<table>
      <tr>
        <td><strong>Ehdotettu</strong></td>
        <td><strong>Otsikko</strong></td>
        <td><strong>Ehdottaja</strong></td>
      </tr>

  <sql:statement id="stmt2" conn="conn2">
    <sql:query>
      select assignmentoriginal.originalid as origid,
             assignmentoriginal.proposeddate as pdate,
             assdetailtranslation.name as origname,
             person.firstnames || ' ' || person.lastname as proposedby
      from   assignmentoriginal
      where  assdetailtranslation.languageid = <%=languageID%>
      and    assignmentoriginal.deleted = false 
      and    assignmentoriginal.acceptedby = NULL
      and    assoriginalreldetail.originalid = assignmentoriginal.originalid
      and    assoriginalreldetail.detailid = assignmentdetail.detailid
      and    assignmentdetail.typeid = <%=titleID%>
      and    assignmentdetail.detailid = assdetailtranslation.detailid
      and    assignmentoriginal.proposedby = person.personid;
    </sql:query>


    <sql:resultSet id="rset2" loop="true">
      <tr>
        <td><sql:getDate colName="pdate" /></td> 
        <td><a href="acceptProposition.jsp?origid=<sql:getColumn colName="origid" />">
            <sql:getColumn colName="origname" /></a></td> 
        <td><sql:getColumn colName="proposedby" /></td> 
      </tr>
    </sql:resultSet>
  </sql:statement>

</table>
</div>


--%>

<br / >
<h4><t:Tr>Ohjaamasi opinnytteet</t:Tr></h4>
<div class="in">

<table>
      <tr>
        <td valign="top"><strong><t:Tr>Vaihe</t:Tr></strong></td>
        <td valign="top"><strong><t:Tr>Tyyppi</t:Tr></strong></td>
        <td valign="top"><strong><t:Tr>Viimeisin<br/>tapahtuma</t:Tr></strong></td>
        <td valign="top"><strong><t:Tr>Otsikko</t:Tr></strong></td>
      </tr>
  <sql:statement id="stmt2" conn="conn2">
    <sql:query>
      select assignment.assignmentid as assid,
             assdetailtranslation.name as origname,
             assphasetranslation.name as currentphase,
             asstypetranslation.name as typename,
             assignmentrelatedperson.roleid as roleid,
             assignment.assignmenttypeid as typeid,
             assignment.phaseid as phaseid
<%--            max(assignmentevent.eventdate) as lastdate   We can't use due null values in event table --%>
      from   assignment
      where  assdetailtranslation.languageid = <%=languageID%>
      and    assphasetranslation.languageid = <%=languageID%>
      and    asstypetranslation.languageid = <%=languageID%>
      and    assignmentrelatedperson.personid = <%=personID%>
      and    assignmentrelatedperson.deleted = false
      and    assignmentrelatedperson.roleid > <%=studentID%>
      and    assignmentrelatedperson.assignmentid = assignment.assignmentid
      and    assignment.assignmentid = assignmentreldetail.assignmentid
      and    assignmentdetail.detailid = assignmentreldetail.detailid
      and    assignmentdetail.typeid = <%=titleID%>
      and    assdetailtranslation.detailid = assignmentreldetail.detailid
      and    assignment.phaseid = assphasetranslation.phaseid
      and    assignment.phaseid <> <%=readyAssignmentID %> 
      and    assignment.phaseid <> <%=incompleteAssignmentID%>
      and    assignment.assignmenttypeid = asstypetranslation.typeid
      and    assignment.deleted = false
<%--  and    assignmentevent.assignmentid = assignment.assignmentid
      group by assignment.assignmentid, origname, currentphase, typename, roleid, 
               assignment.assignmenttypeid, assignment.phaseid --%>
      order by roleid desc, phaseid desc, typeid, origname, assignmentid;
    </sql:query>

    <sql:resultSet id="rset2" loop="true">
      <sql:getColumn colName="assid" to="assid" scope="page"/>
      <tr>
        <td><a href="assignmentUpdate.jsp?assid=<sql:getColumn colName="assid" />"><sql:getColumn colName="currentphase" /></a></td> 
        <td><sql:getColumn colName="typename" /></td> 
        <td>

  <sql:statement id="stmt3" conn="conn2">
    <sql:query>
      select max(assignmentevent.eventdate) as lastdate
      from   assignmentevent
      where  assignmentevent.deleted = false
      and    assignmentevent.assignmentid = <sql:getColumn colName="assid" />
      group by assignmentid
    </sql:query>
    <sql:resultSet id="rset3" > 
      <sql:getDate colName="lastdate" to="lastdate" /> 
       <% if ( pageContext.getAttribute("lastdate") != null ) { %>
      <a href="assignment.jsp?assid=<%=pageContext.getAttribute("assid") %>#events">
      <%=timeformater.monthToOutFormat((String)pageContext.getAttribute("lastdate")) %></a>
       <% } %>
    </sql:resultSet>
  </sql:statement> 
         </td>

        <td><a href="assignment.jsp?assid=<sql:getColumn colName="assid" />">
            <sql:getColumn colName="origname" /></a></td> 
      </tr>

    </sql:resultSet>
  </sql:statement>
</table>
</div>
<% } 




   if ( request.getParameter("student") != null ) { 
%>
<br / >
<h4><t:Tr>Omat opinnytteesi</t:Tr></h4>
<div class="in">
<table>
      <tr>
        <td valign="top"><strong><t:Tr>Vaihe</t:Tr></strong></td>
        <td valign="top"><strong><t:Tr>Tyyppi</t:Tr></strong></td>
        <td valign="top"><strong><t:Tr>Viimeisin<br/>tapahtuma</t:Tr></strong></td>
        <td valign="top"><strong><t:Tr>Otsikko</t:Tr></strong></td>
      </tr>
  <sql:statement id="stmt2" conn="conn2">
    <sql:query>
      select assignment.assignmentid as assid,
             assdetailtranslation.name as origname,
             assphasetranslation.name as currentphase,
             asstypetranslation.name as typename,
             assignmentrelatedperson.roleid as roleid,
             assignment.assignmenttypeid as typeid,
             assignment.phaseid as phaseid
      from   assignment
      where  assdetailtranslation.languageid = <%=languageID%>
      and    assphasetranslation.languageid = <%=languageID%>
      and    asstypetranslation.languageid = <%=languageID%>
      and    assignmentrelatedperson.personid = <%=personID%>
      and    assignmentrelatedperson.deleted = false
      and    assignmentrelatedperson.roleid = <%=studentID%>
      and    assignmentrelatedperson.assignmentid = assignment.assignmentid
      and    assignment.assignmentid = assignmentreldetail.assignmentid
      and    assignmentdetail.detailid = assignmentreldetail.detailid
      and    assignmentdetail.typeid = <%=titleID%>
      and    assdetailtranslation.detailid = assignmentreldetail.detailid
      and    assignment.phaseid = assphasetranslation.phaseid
      and    assignment.phaseid <> <%=readyAssignmentID %>  
      and    assignment.assignmenttypeid = asstypetranslation.typeid
      and    assignment.deleted = false
      order by roleid desc, phaseid desc, typeid, origname;
    </sql:query>
    <sql:resultSet id="rset2" loop="true">
      <tr>
        <sql:getColumn colName="assid" to="assid" scope="page"/> 
        <td><sql:getColumn colName="currentphase" /></td> 
        <td><sql:getColumn colName="typename" /></td> 
        <td>

  <sql:statement id="stmt3" conn="conn2">
    <sql:query>
      select max(assignmentevent.eventdate) as lastdate
      from   assignmentevent
      where  assignmentevent.deleted = false
      and    assignmentevent.assignmentid = <sql:getColumn colName="assid" />
      group by assignmentid;
    </sql:query>
    <sql:resultSet id="rset3" >
      <sql:getColumn colName="lastdate" to="lastdate" />
      <a href="assignment.jsp?assid=<%=pageContext.getAttribute("assid")%>#events">
      <%=timeformater.monthToOutFormat((String)pageContext.getAttribute("lastdate"))%></a>
    </sql:resultSet>
  </sql:statement>
         </td>
        <td><a href="assignment.jsp?assid=<sql:getColumn colName="assid" />">
            <sql:getColumn colName="origname" /></a></td> 
      </tr>

    </sql:resultSet>
  </sql:statement>
</table>
<p>&nbsp;</p>
</div>

<% } %>


<p>
<t:Tr><a href="propositions.jsp?own=true">Aihe-ehdotuksesi</a></t:Tr>
<% if ( request.getParameter("student") != null ) { %>
| <t:Tr><a href="searchResult.jsp?phaseid=4&personid=<%=personID%>">Hyvksytyt opinnytteesi</a></t:Tr>
| <t:Tr><a href="searchResult.jsp?phaseid=<%=cancelledAssignmentID%>&personid=<%=personID%>">Keskeytetyt opinnytteesi</a></t:Tr>

<% } %>
<% if ( request.getParameter("teacher") != null ) { %>
| <t:Tr><a href="searchResult.jsp?phaseid=4&personid=<%=personID%>">Hyvksytyt ohjaamasi opinnytteet</a></t:Tr>
| <t:Tr><a href="searchResult.jsp?phaseid=5&personid=<%=personID%>">Keskeytetyt ohjaamasi opinnytteet</a></t:Tr>
| <t:Tr><a href="available.jsp">Kiinnitettvt opinnytteet</a></t:Tr>
<% } %>
</p>


<%--
<p>
<a href="propose.jsp">Ehdota aihetta</a>
</p>

<p><a href="proposedSubjects.jsp">Kaikki aiheeksi ehdotetut opinnyteet</a></p>

<p><a href="acceptedSubjects.jsp">Tarjolla olevien opinnytteiden aiheet</a></p>

<p><a href="search.jsp">Haku</a></p>
--%>

<%@ include file="/shared/pageEnd.inc" %>


