<%
/***************************************************************************************************
*               PAGE DESCRIPTION
****************************************************************************************************
*
*               NAME:           propose.jsp
*               LANGUAGE:       JSP
*               DATE:           10.4.2002
*               AUTHOR:         Markus Silvn, University of Jyvskyl (JYU)
*
****************************************************************************************************
*               COPYRIGHT (C) KOPPELO PROJECT GROUP
*               Limited rights granted. Please refer to GNU General Public License
*               http://www.gnu.org/licenses/gpl.html
****************************************************************************************************

****************************************************************************************************
*               UPDATES
****************************************************************************************************
*               20.4.2002   Corrections to html printouts, Antti Vanhanen, JYU
*               23.4.2002   Added more  fields, Minna Hillebrand, JYU 
*
****************************************************************************************************/
%>

<%@ include file="/shared/beans.inc" %>
<%@ include file="/shared/constants.inc" %>

<%

   /* No relation to database is needed because every KOTKA users are allowed to see this page */
   if ( userAccessLevel < studentID )  { response.sendRedirect("errorNoAccess.jsp"); return; }

%>

<%@ include file="/shared/header.inc" %>
<%@ include file="/shared/menus.inc" %>
<%@ include file="/shared/dbconnect.inc" %>

   <h3><t:Tr>Ehdota aihetta opinnytetyksi</t:Tr></h3>
<div class="in">
  <p>Kaikki kentt (avainsanoja lukuunottamatta) ovat pakollisia. Voit antaa 
     aihe-ehdotuksen vain oman laitoksesi linjoille.</p>

  <form name="propose" method="post" action="proposeInsert.jsp">

<%--    <h4><t:Tr>Ehdota aihetta opinnytetyksi</t:Tr></h4> --%>

<table>
  <tr> 
    <td valign="top"><strong><label for="subject"><t:Tr>Aiheen otsikko: </t:Tr></label></strong></td>
    <td><input id="subject" type="text" name="title" size="49" value="" /></td>
  </tr>
  <tr>
    <td valign="top"><strong><label for="description"><t:Tr>Aiheen kuvaus: </t:Tr></label></strong></td>
    <td><textarea id="description" name="description" cols="50" rows="5"></textarea></td>
  </tr>
  <tr>
    <td valign="top"><strong><label for="keywords"><t:Tr>Avainsanat: </t:Tr></label></strong></td>
    <td><input id="keywords" type="text" name="keywords" size="49" />
        <br/>Voit antaa useita avainsanoja pilkulla erottaen.</td>
  </tr>

<%   
   java.util.Date today = new java.util.Date();
   java.text.SimpleDateFormat parser = new java.text.SimpleDateFormat("dd.MM.yyyy");
     
%>
  <tr>
     <td><label for="proposeddate"><strong><t:Tr>Ehdotettu:</t:Tr></strong></label>
         <input type="hidden" name="proposeddate" id="proposeddate"  value="<%= parser.format(today) %>" />
     </td>
     <td> <%= parser.format(today) %></td>
  </tr>

  <tr>
 
      <sql:statement id="stmt2" conn="conn2">
        <sql:query>
          select trunc(avg(assignmenttype.defaulttimeindb)) as deftime
          from assignmenttype;
        </sql:query>
        <sql:resultSet id="rset2">
          <sql:getColumn colName="deftime" to="deftime" scope="page" /> 
        </sql:resultSet>
      </sql:statement>
    <% String defTime = (String)pageContext.getAttribute("deftime"); %>
    <td><label for="validdays"><strong><t:Tr>Aihe voimassa:</t:Tr></strong></label></td>
    <td><input type="text" name="validdays" id="validdays" size="5" value="<%=defTime%>" /> piv</td>
  </tr>

</table>


<table>

    <tr>
      <td valign ="top"><strong><t:Tr>Opinnytteen tyyppi</t:Tr></strong></td>
      <td valign ="top">&nbsp;&nbsp;&nbsp;</td>
      <td valign ="top"><strong><t:Tr>Opinnytteen linja</t:Tr></strong></td>
    </tr>

    <tr>
<%--
    <p>
      <label for="department"><t:Tr>Valitse laitos</t:Tr></label>
      <t:DCombo name="department" />
    </p>
--%>

   
       <%-- all study types and ids --%>
      <td><select multiple name="type" id="studytype" size="6">
      <sql:statement id="stmt2" conn="conn2">
        <sql:query>
          select assignmenttype.typeid as type,
                 asstypetranslation.name as name
          from   assignmenttype, asstypetranslation
          where  assignmenttype.deleted = false
          and    assignmenttype.typeid = asstypetranslation.typeid
          and    asstypetranslation.deleted = false  
          and    asstypetranslation.languageid = <%=languageID%>; 

        </sql:query>
        <sql:resultSet id="rset2" loop="true">
          <option value="<sql:getColumn colName="type" />"><sql:getColumn colName="name" /></option> 
        </sql:resultSet>
      </sql:statement>
      </select></td>

      <td></td>

      <td><select multiple name="line" id="studyline" size="6">
         <option selected="selected" value="null">ei linjaa</option>

     <%-- all study lines and ids --%>
      <sql:statement id="stmt2" conn="conn2">
        <sql:query>
          select studyline.lineid as line,
                 studylinetranslation.name as name,
                 organisationtranslation.name as orgname
          from   studyline, studylinetranslation
          where  studyline.deleted = false
          and    studyline.lineid = studylinetranslation.lineid
          and    studylinetranslation.deleted = false
          and    studylinetranslation.languageid = <%=languageID%>
          and    studyline.organisationid = person.homeorganisationid
          and    person.personid = <%=personID%> 
          and    studyline.organisationid = organisation.organisationid
          and    organisation.deleted = false
          and    organisation.organisationid = organisationtranslation.organisationid
          and    organisationtranslation.languageid = <%=languageID%> 
          order by studylinetranslation.name;
        </sql:query>
        <sql:resultSet id="rset2" loop="true">
          <option value="<sql:getColumn colName="line" />"><sql:getColumn colName="name" /> (<sql:getColumn colName="orgname" />)</option> 
        </sql:resultSet>
      </sql:statement>
      </select></td>

    </tr>
</table>

<%--   
    <p>
      <label for="additionalinfo"><t:Tr>Listietoja (URL):</t:Tr></label>
      <input type="text" name="additionalinfo" id="additionalinfo" size="50" value="http://" />
    </p>
--%>


    <p>
      <input type="submit" name="Submit" value="Tallenna ehdotus" />
<%--      <input type="reset" name="Reset" value="Tyhjenn&auml; lomake" /> --%>
    </p>
  </form>


<%@ include file="/shared/pageEnd.inc" %>

