<%
/***************************************************************************************************
*               PAGE DESCRIPTION
****************************************************************************************************
*
*               NAME:           proposeConfirmRemove.jsp
*               LANGUAGE:       JSP
*               DATE:           13.5.2002
*               AUTHOR:         Minna Hillebrand, University of Jyvskyl (JYU)
*               PURPOSE:        Make sure that user want's to remove proposition
*
*
****************************************************************************************************
*               COPYRIGHT (C) KOPPELO PROJECT GROUP
*               Limited rights granted. Please refer to GNU General Public License
*               http://www.gnu.org/licenses/gpl.html
****************************************************************************************************

****************************************************************************************************
*               UPDATES
****************************************************************************************************
*
*
****************************************************************************************************/
%>

<%
  if (request.getParameter("origid") == null) {
    response.sendRedirect("error.jsp?page=proposeConfirmRemove&message=1");
    return;
  }   
  int origID = Integer.parseInt(request.getParameter("origid"));   
%>

<%@ include file="/shared/beans.inc" %>
<%@ include file="/shared/constants.inc" %>
<%@ include file="/shared/dbconnect.inc" %>


<%-- Access right --%>


<% police.setDB(db);


   boolean canUpdate = false;

   if ( police.hasPersonRightOriginal(allowPropAccept, personID, origID) ||
        police.hasGroupRight(allowPropAccept, userAccessLevel) ) {

     canUpdate = true;
   }

   if ( !canUpdate ) {            
    response.sendRedirect("errorNoAccess.jsp");
    return;
   }

%>


<%@ include file="/shared/header.inc" %>
<%@ include file="/shared/menus.inc" %>


<% time timeformater = new time(); %>

<%
   String term="aihe-ehdotuksen";
   String capitalterm="Aihe-ehdotuksen";
   String redirect = "propositions";

   if ( request.getParameter("page") != null ) { 
    term = "aiheen";
    capitalterm="Aiheen";
    redirect = "available";
   }  
%>

<h3><t:Tr><%=capitalterm%> hylkminen</t:Tr></h3>

<form action="proposeRemove.jsp" method="post">
<input type="hidden" name="redirect" value="<%=redirect%>" />
<input type="hidden" name="origid" value="<%=origID%>" />

<%-- TITLE --%>
<sql:statement id="stmt6" conn="conn2">
  <sql:query>
   select assdetailtranslation.name as name,
          descriptiontypetranslation.name as type,
          assignmentdetail.detailid as id
   from   assdetailtranslation, descriptiontypetranslation 
   where  assoriginalreldetail.originalid = <%=origID%>
   and    assoriginalreldetail.detailid = assignmentdetail.detailid
   and    assignmentdetail.typeid = <%=titleID%> 
   and    assdetailtranslation.detailid = assignmentdetail.detailid
   and    assdetailtranslation.languageid = <%=languageID%>
   and    descriptiontypetranslation.descriptiontypeid = <%=titleID%>
   and    descriptiontypetranslation.languageid = <%=languageID%>;
  </sql:query>
  <sql:resultSet id="rset6">
        <p> Halutko varmasti poistaa <%=term%>
            "<sql:getColumn colName="name" />"? <input type="submit"name="submit" value="Poista" />
        </p>
  </sql:resultSet>
</sql:statement>

</form>


 <% if ( request.getParameter("page") != null ) { %>
     <p>Takaisin kiinnitettvien aiheiden <a href="available.jsp">ksittelyyn</a>.</p>
 <% } else { %>
     <p>Takaisin aihe-ehdotuksen <a href="acceptProposition.jsp?origid=<%=origID%>">hyvksymiseen</a>.</p>
 <% } %>


<%@ include file="/shared/pageEnd.inc" %>



