<%
/***************************************************************************************************
*               PAGE DESCRIPTION
****************************************************************************************************
*
*               NAME:           proposeInsert.jsp
*               LANGUAGE:       JSP
*               DATE:           10.4.2002
*               AUTHOR:         Minna Hillebrand, University of Jyvskyl (JYU)
*               PURPOSE:        Insert proposed subject into table AssignmentOriginal, 
*                               send email to person responsible for accepeting propositions 
*                               (if necessary) and redirect to thanks.jsp or to acceptProposition.jsp
*                               depending on the user related rights.               
*
****************************************************************************************************
*               COPYRIGHT (C) KOPPELO PROJECT GROUP
*               Limited rights granted. Please refer to GNU General Public License
*               http://www.gnu.org/licenses/gpl.html
****************************************************************************************************

****************************************************************************************************
*               UPDATES
****************************************************************************************************
*           
*  17.5.2002 M.Ylitalo
*   - Added sendmail to person who can accept proposition
*
****************************************************************************************************/
%>


<% String baseAdd="https://hartman.it.jyu.fi/kotka/koppelo/"; %>

<%@ include file="/shared/beans.inc" %>
<%@ include file="/shared/constants.inc" %>
<%@ include file="/shared/dbconnect.inc" %>

<%
   /* No relation to database is needed because every KOTKA users are allowed to see this page */
   if ( userAccessLevel < studentID )  { response.sendRedirect("errorNoAccess.jsp"); return; }

%>

<%
 /* check that we've got all parameters */

  
 if (request.getParameter("title") == null || 
	((String)request.getParameter("title")).equals("") ||
        ((String)request.getParameter("title")).equals("null") ) {
    response.sendRedirect("error.jsp?page=proposeInsert&message=1");
    return;
 }
 String title = request.getParameter("title");

 String description="";
 if (request.getParameter("description") != null) {
   description = request.getParameter("description");
 } 
 
 if (request.getParameter("proposeddate") == null) {
    response.sendRedirect("error.jsp?page=proposeInsert&message=1");
    return;
 }
 time timeformater = new time();
 String proposeddate = timeformater.monthToDBFormat((String)request.getParameter("proposeddate"));

 if (request.getParameter("validdays") == null) {
    response.sendRedirect("error.jsp?page=proposeInsert&message=1");
    return;
 }
 int validdays = Integer.parseInt((String)request.getParameter("validdays"));
 
 if ( (request.getParameter("line") == null )  || 
      (request.getParameter("type") == null )    ) {
    response.sendRedirect("error.jsp?page=proposeInsert&message=1");
    return;
 }

%>




<%-- THESE THING WE CANT DO --%>

<%-- Check that we have acceptable validdays value 

<sql:statement id="stmt3" conn="conn2">
  <sql:query>
     select maxtimeindb as resultdate from assignmenttype where typeid = <%=typeID%>;
  </sql:query>
  <sql:resultSet id="rset3">
    <sql:getColumn colName="resultdate" to="maxvalid" scope="page"/> 
  </sql:resultSet>
</sql:statement>

 int maxdays = Integer.parseInt((String)pageContext.getAttribute("maxvalid")); 
 if (validdays > maxdays ) validdays = maxdays;  
 if (0 < validdays) validdays = maxdays; 


 check the lineid:s range, do not execute query witch will fail 
<sql:statement id="stmt4" conn="conn2">
  <sql:query>
     select max(lineid) as max, min(lineid) as min from studyline;
  </sql:query>
  <sql:resultSet id="rset4">
    <sql:getColumn colName="max" to="maxid" scope="page"/>
    <sql:getColumn colName="min" to="minid" scope="page"/> 
  </sql:resultSet>
</sql:statement>

 int maxLineID = Integer.parseInt((String)pageContext.getAttribute("maxid")); 
 int minLineID = Integer.parseInt((String)pageContext.getAttribute("minid")); 
 if (lineID > maxLineID ) { response.sendRedirect("errorProposeInsert.jsp?line=liianiso"); return; }
 if (lineID < minLineID ) { response.sendRedirect("errorProposeInsert.jsp?line=liianpieni"); return; } 

--%>







<%-- This query gives the last date for proposition --%>


<sql:statement id="stmt5" conn="conn2">
  <sql:query>
    select cast('<%=proposeddate%>' as date) + <%=validdays%> as resdate;
  </sql:query>
  <sql:resultSet id="rset5">
    <sql:getDate colName="resdate" to="validuntil" scope="page"/> 
  </sql:resultSet>
</sql:statement>

<% String validuntil = (String)pageContext.getAttribute("validuntil"); %>



<%-- This query gives the maximum id of table AssignmentOriginal 
      The result is saved into variable maxID                      --%>


<% boolean success = false; %>
<sql:statement id="stmt6" conn="conn2">
  <sql:query>
   select max(assignmentoriginal.originalid)+1 as newid
   from  assignmentoriginal;
  </sql:query>
  <sql:resultSet id="rset6">
    <sql:getColumn colName="newid" to="maxid" scope="page"/> 
   <% String apu = (String)pageContext.getAttribute("maxid");
       if ( apu != null )  success = true; %>
  </sql:resultSet>
</sql:statement>

<% int maxID = 1; 
   if (success) maxID = Integer.parseInt((String)pageContext.getAttribute("maxid")); 
%>




<%-- This query gives the maximum id of table AssignmentDetail 
      The result is saved into variable detailID               --%>

<% success = false; %>
<sql:statement id="stmt7" conn="conn2">
  <sql:query>
   select MAX(assignmentdetail.detailid)+1 as newid
   from  assignmentdetail;
  </sql:query>
  <sql:resultSet id="rset7">
    <sql:getColumn colName="newid" to="maxid" scope="page"/> 
   <% String apu = (String)pageContext.getAttribute("maxid");
       if ( apu != null )  success = true; %>
  </sql:resultSet>
</sql:statement>

<% int detailID =1; 
   if (success) detailID = Integer.parseInt((String)pageContext.getAttribute("maxid")); 
%>


<%-- ---- THE ACTION BEGINS ------------------------------------------------- --%>

<%-- The following section executes the insert-commands --%>

<% try { %>
<sql:statement id="stmt8" conn="conn2">
  <sql:query>
     insert into assignmentoriginal 
     (deleted, originalid, proposeddate, proposedby, acceptedby, 
      accepteddate, validuntil, available) values 
     ('false', <%=maxID%>, '<%=proposeddate%>', <%=personID%>, NULL, 
      NULL, '<%=validuntil%>', 0);
  </sql:query>
  <sql:execute />
</sql:statement>
<% } catch (Exception wrongdate) {     
      response.sendRedirect("error.jsp?page=proposeInsert&message=2");
      return;
   }
%>

<%-- set the possible lines and types --%>


<%
 if (request.getParameter("line") != null) {  
    String[] lines = new String[100];
    lines = request.getParameterValues("line");
    int i;
    for (i=0; i < lines.length; i++) { 
      try {
%>
      <sql:statement id="stmt2" conn="conn2">
        <sql:query>
           insert into assoriginalposline 
           (deleted, originalid, lineid) values
           ('false', <%=maxID%>, <%=lines[i]%>);
        </sql:query>
        <sql:execute />
      </sql:statement>
<%
      } catch (Exception nullline) {}  // no big deal if the user has selected null value
    }  
  }

 if (request.getParameter("type") != null) {  
    String[] types = new String[100];
    types = request.getParameterValues("type");
    int i;
    for (i=0; i < types.length; i++) { 
%>
      <sql:statement id="stmt2" conn="conn2">
        <sql:query>
           insert into assoriginalpostype 
           (deleted, originalid, typeid) values
           ('false', <%=maxID%>, <%=types[i]%>);
        </sql:query>
        <sql:execute />
      </sql:statement>
<%  }  
  }
%>

<%-- Insert title --%>



<sql:statement id="stmt11" conn="conn2">
  <sql:query>
    insert into assignmentdetail (deleted, detailid, typeid)
    values ('false', <%=detailID%>, <%=titleID%>);
  </sql:query>
  <sql:execute />
</sql:statement>
<sql:statement id="stmt12" conn="conn2">
  <sql:query>
    insert into assdetailtranslation (deleted, detailid, languageid, name)
    values ('false', <%=detailID%>, <%=languageID%>, '<%=title%>');
  </sql:query>
  <sql:execute />
</sql:statement>
<sql:statement id="stmt13" conn="conn2">
  <sql:query>
    insert into assoriginalreldetail (deleted, originalid, detailid)
    values ('false', <%=maxID%>, <%=detailID%>);
  </sql:query>
  <sql:execute />
</sql:statement>


<% detailID = detailID+1; %>

<%-- Insert description --%>

<sql:statement id="stmt14" conn="conn2">
  <sql:query>
    insert into assignmentdetail (deleted, detailid, typeid)
    values ('false', <%=detailID%>, <%=descriptionID%>);
  </sql:query>
  <sql:execute />
</sql:statement>
<sql:statement id="stmt15" conn="conn2">
  <sql:query>
    insert into assdetailtranslation (deleted, detailid, languageid, name)
    values ('false', <%=detailID%>, <%=languageID%>, '<%=description%>');
  </sql:query>
  <sql:execute />
</sql:statement>
<sql:statement id="stmt16" conn="conn2">
  <sql:query>
    insert into assoriginalreldetail (deleted, originalid, detailid)
    values ('false', <%=maxID%>, <%=detailID%>);
  </sql:query>
  <sql:execute />
</sql:statement>

<% detailID = detailID+1; %>


<%-- <p>m<%=request.getParameter("keywords")%>m</p> --%>

<%-- Section for keywords --%>

<%
  if ( request.getParameter("keywords") != null) {
       int i=0;
       int lkm=0;

      int beg = 0; 
      int end = 0;
      String [] keys = new String [100];
      String key = request.getParameter("keywords");

      while ( end < key.length() ) {

        end = key.indexOf(",", beg);
        if ( end < 0 ) end = key.length();
        if (beg >= end ) break;
        keys[i] = (key.substring(beg, end)).trim();
        beg = end+1;
        i++;
      }
    lkm = i;
    for (i=0; i < lkm; i++) { 
      int keyid = 1;
      success=false; 
%>

      <sql:statement id="stmt2" conn="conn2">
       <sql:query>
           select assignmentkeyword.keywordid as id
           from   asskeywordtranslation
           where asskeywordtranslation.deleted = false
           and   asskeywordtranslation.languageid = <%=languageID%>
           and   lower(asskeywordtranslation.name) like lower('<%=keys[i]%>')
           and   asskeywordtranslation.keywordid = assignmentkeyword.keywordid
           and   assignmentkeyword.deleted = false;
        </sql:query>
        <sql:resultSet id="rset2">
        <sql:getColumn colName="id" to="keyid" scope="page" />
          <% String apu = (String)pageContext.getAttribute("keyid");
             if ( apu != null )  success = true; %>
        </sql:resultSet> 
      </sql:statement> 
<%
    if (success) { keyid = Integer.parseInt((String)pageContext.getAttribute("keyid")); }
      else { 

%>   
      <sql:statement id="stmt2" conn="conn2">
        <sql:query>
           select max(keywordid)+1 as max from assignmentkeyword;
        </sql:query>
        <sql:resultSet id="rset2">
        <sql:getColumn colName="max" to="keyid" scope="page" />
          <% String apu = (String)pageContext.getAttribute("keyid");
             if ( apu != null )  success = true; %>
        </sql:resultSet>
      </sql:statement>
      <% if (success) keyid = Integer.parseInt((String)pageContext.getAttribute("keyid")); %>
      <sql:statement id="stmt2" conn="conn2">
        <sql:query>
           insert into assignmentkeyword 
           (deleted, keywordid) values
           ('false', <%=keyid%>);
        </sql:query>
        <sql:execute />
      </sql:statement>
      <sql:statement id="stmt2" conn="conn2">
        <sql:query>
           insert into asskeywordtranslation 
           (deleted, keywordid, languageid, name) values
           ('false', <%=keyid%>, <%=languageID%>, '<%=keys[i]%>');
        </sql:query>
        <sql:execute />
      </sql:statement>
<%    }
    /* Finally update to relation table */ 
%>
      <sql:statement id="stmt2" conn="conn2">
        <sql:query>
           insert into assoriginalrelkeyword 
           (deleted, originalid, keywordid) values
           ('false', <%=maxID%>, <%=keyid%>);
        </sql:query>
        <sql:execute />
      </sql:statement>
<% 
    }  
  }

%>

<%-- SEND EMAIL TO PERSON WHO CAN ACCEPT THE PROPOSITION (if necessary) --%>


<%
//         MUISTA VAIHTAA OIKEA SENDMAIL-RIVI!!!


String to="ylimark@st.jyu.fi";
String message = "Opinnytteen aiheeksi on ehdotettu seuraavaa aihetta: "+title+"\n\nPset hyvksymn sen seuraavasta linkist:\n\n"+baseAdd+"acceptProposition.jsp?origid="+maxID+"\n\n\n";

%>


<sql:statement id="stmt12" conn="conn2">
  <sql:query>

    select distinct personparametervalue as address
    from   personparameter
    where  personparameter.personparametertypeid = 3

    and    asspersonrelright.deleted = false
    and    asspersonrelright.personid = personparameter.personid
    and    asspersonrelright.lineid IN (
            select lineid 
            from   assoriginalposline 
            where  assoriginalposline.originalid = <%=maxID%>
            and    assoriginalposline.deleted = false ) 
    and    asspersonrelright.asstypeid IN (
            select typeid 
            from   assoriginalpostype 
            where  assoriginalpostype.originalid = <%=maxID%>
            and    assoriginalpostype.deleted = false ) 
    and    asspersonrelright.rightid = <%=allowPropAccept%>;
  </sql:query>

  <sql:resultSet id="rset12">
    <sql:getColumn  colName="address" to="address" scope="page"/>

      <&-- Ota kommentit pois oikeaan versioon, ett viestit lhtee hyvksyjille, eik minulle!--%>

      <%-- mail.sendMail( "koppelo@it.jyu.fi", (String)pageContext.getAttribute("address"), "Aihe-ehdotus: "+title, message ); --%>
      <% mail.sendMail( "koppelo@it.jyu.fi", to, "Aihe-ehdotus: "+title, message+(String)pageContext.getAttribute("address") ); %>
  </sql:resultSet>
</sql:statement>











<%-- redirect to page thanks.jsp or proposeAccept.jsp according to user's rights --%>


<% police.setDB(db);


   if ( police.hasPersonRightOriginal(allowPropAccept, personID, maxID) || 
        police.hasGroupRight(allowPropAccept, userAccessLevel)) {

     response.sendRedirect("acceptProposition.jsp?origid="+maxID); return;
   }


  response.sendRedirect("proposeThanks.jsp?origid="+maxID); 
%>



