<%
/***************************************************************************************************
*               PAGE DESCRIPTION
****************************************************************************************************
*
*               NAME:           proposeRemove.jsp
*               LANGUAGE:       JSP
*               DATE:           13.5.2002
*               AUTHOR:         Minna Hillebrand, University of Jyvskyl (JYU)
*               PURPOSE:        Remove proposition from assigntmentoriginal
*
*
****************************************************************************************************
*               COPYRIGHT (C) KOPPELO PROJECT GROUP
*               Limited rights granted. Please refer to GNU General Public License
*               http://www.gnu.org/licenses/gpl.html
****************************************************************************************************

****************************************************************************************************
*               UPDATES
****************************************************************************************************
*
*       20.5.2002 M.Ylitalo
*           - Added sendmail to proposer
****************************************************************************************************/
%>

<%
  if (request.getParameter("origid") == null) {
    response.sendRedirect("error.jsp?page=proposeConfirmRemove&message=1");
    return;
  }   
  int origID = Integer.parseInt(request.getParameter("origid"));   
%>

<%@ include file="/shared/beans.inc" %>
<%@ include file="/shared/constants.inc" %>
<%@ include file="/shared/dbconnect.inc" %>

<% time timeformater = new time(); %>
<%-- Access right --%>

<% police.setDB(db);

   boolean canAccept = false; 
   boolean canUpdate = false;

   if ( police.hasPersonRightOriginal(allowPropAccept, personID, origID) ||
        police.hasGroupRight(allowPropAccept, userAccessLevel) ) {
     canAccept = true;
     canUpdate = true;
   }

   if ( !canAccept && !canUpdate ) {              // if both are false then redirect
    response.sendRedirect("errorNoAccess.jsp");
    return;
   }

 

  try {
%>


<sql:statement id="stmt6" conn="conn2">
  <sql:query>
    update assignmentoriginal
    set    deleted = true
    where  assignmentoriginal.originalid = <%=origID%>  
  </sql:query>
  <sql:execute />
</sql:statement>

<% } catch (Exception e) {} %>





<%-- TSS LHTEE HYLKYSVIESTI AIHEEN EHDOTTAJALLE  --%>



<% String from  ="nobody&it.jyu.fi"; 
   String to    ="nobody&it.jyu.fi";
   String title ="AIHE";
   String description="KUVAUS";
%>
 



<sql:statement id="stmt4" conn="conn2">
  <sql:query>  
    select   name as title
    from     assdetailtranslation
    where    languageid = <%=languageID%> 
    and      detailid = ( 
               select assignmentdetail.detailid 
               from   assignmentdetail 
               where  assoriginalreldetail.originalid = <%=origID%>
               and    assoriginalreldetail.detailid = assignmentdetail.detailid
               and    assignmentdetail.typeid = <%=titleID%>
    );
  </sql:query>
  <sql:resultSet id="rset4">

    <sql:getColumn colName="title" to="title" scope="page" />
    <%
      if ( pageContext.getAttribute("title") != null )
         title=(String)pageContext.getAttribute("title"); 
    %>

  </sql:resultSet>
</sql:statement>


<sql:statement id="stmt5" conn="conn2">  
  <sql:query>
    select   name as description
    from     assdetailtranslation
    where    languageid = <%=languageID%>
    and      detailid = (
               select assignmentdetail.detailid
               from   assignmentdetail
               where  assoriginalreldetail.originalid = <%=origID%>
               and    assoriginalreldetail.detailid = assignmentdetail.detailid
               and    assignmentdetail.typeid = <%=descriptionID%>
    );
  </sql:query>
  <sql:resultSet id="rset5">

    <sql:getColumn colName="description" to="description" scope="page" />
    <%
      if ( pageContext.getAttribute("description") != null )
         description=(String)pageContext.getAttribute("description");
    %>
      
  </sql:resultSet>
</sql:statement>  



<sql:statement id="stmt6" conn="conn2">
  <sql:query>
    select personparametervalue as add
    from   personparameter 
    
    where  personparametertypeid = 3
    and    personparameter.personid = assignmentoriginal.proposedby
    and    assignmentoriginal.originalid = <%=origID%>
  
  </sql:query>
  <sql:resultSet id="rset6">
    <sql:getColumn colName="add" to="add" scope="page"/>  
      <% if ( pageContext.getAttribute("add") != null)
           to=(String)pageContext.getAttribute("add");
      %>
  </sql:resultSet>
</sql:statement>


<%
String message = "";
if ( session.getAttribute("message") != null) 
     message = (String)session.getAttribute("message");
     

%>



<sql:statement id="stmt7" conn="conn2">
  <sql:query>
    select personparameter.personparametervalue as address,
           person.callname as firstname,
           person.lastname as lastname,
           current_date as day
    from   personparameter, person
    where  personparameter.personparametertypeid = 3
    and    personparameter.personid = person.personid
    and    person.personid = <%=personID%>
  </sql:query>
  <sql:resultSet id="rset7">
    <sql:getColumn colName="address" to="address" scope="page"/>
    <sql:getColumn colName="firstname" to="firstname" scope="page"/>
    <sql:getColumn colName="lastname" to="lastname" scope="page"/>
    <sql:getColumn colName="day" to="day" scope="page"/>

      <% if ( pageContext.getAttribute("address") != null)
           from=(String)pageContext.getAttribute("address");
         mail.sendMail( "koppelo@mit.jyu.fi", to, title, 
           "TM ON AUTOMAATTINEN VIESTI KOPPELO-JRJESTELMST.\n\n\nAihe-ehdotuksesi on hyltty.\n\nOtsikko: "+title+"\nKuvaus:\n"+description+ 
           "\n\n\n\nKsittelijn "+ (String)pageContext.getAttribute("firstname") + " "+ (String)pageContext.getAttribute("lastname")+
           ", "+ timeformater.monthToOutFormat((String)pageContext.getAttribute("day")) + "\n" + from + "\n\n"+ message );      
      %>
  </sql:resultSet>
</sql:statement>


<%	
   response.sendRedirect((String)request.getParameter("redirect")+".jsp"); 
%>




