<%
/***************************************************************************************************
*               PAGE DESCRIPTION
****************************************************************************************************
*
*               NAME:           assignmentUpdate.jsp
*               LANGUAGE:       JSP
*               DATE:           22.4.2002
*               AUTHOR:         Minna Hillebrand, University of Jyvskyl (JYU)
*               PURPOSE:        Maintain assignment related information
*
****************************************************************************************************
*               COPYRIGHT (C) KOPPELO PROJECT GROUP
*               Limited rights granted. Please refer to GNU General Public License
*               http://www.gnu.org/licenses/gpl.html
****************************************************************************************************

****************************************************************************************************
*               UPDATES
****************************************************************************************************
*              
*
*
****************************************************************************************************/
%>


<%@ include file="/shared/beans.inc" %>
<%@ include file="/shared/constants.inc" %>
<%@ include file="/shared/dbconnect.inc" %>

<%-- Check that user is allowed !!! tauluista roledepright, persondepright   --%>

<%
   /* No relation to database is needed because every KOTKA users are allowed to see this page */
   if ( userAccessLevel < studentID )  { response.sendRedirect("errorNoAccess.jsp"); return; }

%>

<%
  if (request.getParameter("origid") == null) { 
      response.sendRedirect("errorProposeDetail.jsp?origid=bad");
      return;
    }
  int origID = Integer.parseInt(request.getParameter("origid"));   
%>


<%@ include file="/shared/header.inc" %>
<%@ include file="/shared/menus.inc" %>

<h3><t:Tr>Aihe-ehdotuksen tiedot</t:Tr></h3>

<p>Tm sivu pitisi nky vain henkilkunnalle, oikeuksia ei viel tehty</p>

<h3>Opinnytteen aihe-ehdotuksen yleiset tiedot</h3>

<table>
<sql:statement id="stmt2" conn="conn2">
  <sql:query>
select assdetailtranslation.name as name, 
       descriptiontypetranslation.name as typename 
from   assoriginalreldetail
where  assoriginalreldetail.deleted = false
and    assoriginalreldetail.originalid = <%=origID%>
and    assoriginalreldetail.detailid = assignmentdetail.detailid
and    assignmentdetail.deleted = false
and    assignmentdetail.typeid = descriptiontypetranslation.descriptiontypeid
and    descriptiontype.descriptiontypeid = descriptiontypetranslation.descriptiontypeid
and    descriptiontypetranslation.languageid = <%=languageID%>
and    assoriginalreldetail.detailid = assdetailtranslation.detailid
and    assdetailtranslation.languageid = <%=languageID%>
order by descriptiontype.ordernum; 
  </sql:query>
  <sql:resultSet id="rset3" loop="true">
  <tr>
    <td><strong><sql:getColumn colName="typename" /></strong></td> 
    <td><sql:getColumn colName="name" /></td> 
  </tr>
  </sql:resultSet>
</sql:statement>
</table>



<table>
<tr><td valign="top"><strong><t:Tr>Avainsanat</t:Tr><strong></td><td>
<sql:statement id="stmt2" conn="conn2">
  <sql:query>
select asskeywordtranslation.name as name 
from   assoriginalrelkeyword
where  assoriginalrelkeyword.deleted = false
and    assoriginalrelkeyword.originalid = <%=origID%>
and    assoriginalrelkeyword.keywordid = assignmentkeyword.keywordid
and    assignmentkeyword.deleted = false
and    assignmentkeyword.keywordid = asskeywordtranslation.keywordid
and    asskeywordtranslation.languageid = <%=languageID%>
<%-- order by descriptiontype.ordernum; --%>
  </sql:query>
  <sql:resultSet id="rset3" loop="true">
    <sql:getColumn colName="name" />
  </sql:resultSet>
</sql:statement>
</td>
</tr>
</table>

<table>
<sql:statement id="stmt2" conn="conn2">
  <sql:query>
select assignmentoriginal.proposeddate as pdate,
       person.firstnames || ' ' || person.lastname as pby
from   assignmentoriginal, person
where  assignmentoriginal.originalid = <%=origID%>
and    assignmentoriginal.deleted = false
and    person.personid = assignmentoriginal.proposedby
  </sql:query>
  <sql:resultSet id="rset3">
  <tr>
    <td><strong><t:Tr>Ehdotettu</t:Tr></strong></td>
    <td><sql:getDate colName="pdate" /></td> 
  </tr>
  <tr>
    <td><strong><t:Tr>Ehdottaja</t:Tr></strong></td>
    <td><sql:getColumn colName="pby" /></td> 
  </tr>  
  </sql:resultSet>
</sql:statement>
</table>

</div>
</body>
</html>
