<%
/***************************************************************************************************
*               PAGE DESCRIPTION
****************************************************************************************************
*
*               NAME:           search.jsp
*               LANGUAGE:       JSP
*               DATE:           16.4.2002
*               AUTHOR:         Minna Hillebrand, University of Jyvskyl (JYU)
*               PURPOSE:        Show search options  
*
****************************************************************************************************
*               COPYRIGHT (C) KOPPELO PROJECT GROUP
*               Limited rights granted. Please refer to GNU General Public License
*               http://www.gnu.org/licenses/gpl.html
****************************************************************************************************

****************************************************************************************************
*               UPDATES
****************************************************************************************************
*               20.4.2002   Corrections and additions to html printouts, Antti Vanhanen, JYU
*               26.4.2002   Page completely rewritten, Markus Silvn, JYU
*               7.5.2002    Added variables isPersonnel and isKOTKAUser, Minna Hillebrand, JYU
*               21.5.2002   Added some search terms, Markus Silvn, JYU
*
****************************************************************************************************/

/***************************************************************************************************
*               ToDo
****************************************************************************************************
*
*               - puuttuvat "oletusarvot"
*                     * personid (?) (=null bugi => null pointer exception)
*                     * timebegin
*                     * timeend
*                     * condition (?)
*                     * typeid (moniarvoinen)
*                     * lineid (moniarvoinen)
*
****************************************************************************************************/
%>

<%@ include file="/shared/beans.inc" %>
<%@ include file="/shared/constants.inc" %>
<%@ include file="/shared/dbconnect.inc" %>

<% boolean isKOTKAUser = false;
   if ( userAccessLevel >= studentID ) isKOTKAUser = true;
  

   boolean isPersonnel = false; 
%>

  <sql:statement id="stmt2" conn="conn2">
    <sql:query>
          select 3 as id from assusergrouprelright
          where assusergrouprelright.deleted = false
          and   assusergrouprelright.groupid = <%=userAccessLevel%>
          and   assusergrouprelright.rightid = <%=allowUnfinishedAss%>  
          union      
          select 3 as id from asspersonrelright
          where asspersonrelright.deleted = false
          and   asspersonrelright.personid = <%=personID%>
          and   asspersonrelright.rightid = <%=allowUnfinishedAss%>                
    </sql:query>
    <sql:resultSet id="rset2">
      <sql:getColumn colName="id" to="fid" scope="page" />
    </sql:resultSet>
  </sql:statement>
<%
  try {
    if ( Integer.parseInt((String)pageContext.getAttribute("fid")) == 3 )  isPersonnel = true;
  } catch (Exception e) {}

%>


<%@ include file="/shared/header.inc" %>
<%@ include file="/shared/menus.inc" %>

<%
  int method = SEARCH_TITLE;
  int phase = allAssignments;
  int line = 0;
  int type = 0;
  int personi = 0;
  String strline = "";
  String strtype = "";
  String strperson = "";
  String searchtext = "";
  String con = "";
  String timebegin = "";
  String timeend = "";
  if(request.getParameter("searchText") != null) searchtext = request.getParameter("searchText");
  if(request.getParameter("condition") != null) con = request.getParameter("condition");
  if(request.getParameter("timebegin") != null) timebegin = request.getParameter("timebegin");
  if(request.getParameter("timeend") != null) timeend = request.getParameter("timeend");

  try {
    method = Integer.parseInt(request.getParameter("searchTextMethod"));
  }
  catch(Exception e) {}

  try {
    phase = Integer.parseInt(request.getParameter("phaseid"));
  }
  catch(Exception e) {}

  String[] lines = request.getParameterValues("lineid");
  String[] types = request.getParameterValues("typeid");
%>


<h3><t:Tr>Opinnytteiden haku</t:Tr></h3>

<form action="searchPerson.jsp">
  <p>
    <label for="searchTextMethod"><h4><t:Tr>Hae</t:Tr></h4></label>
    <select name="searchTextMethod">
<% if(method == SEARCH_TITLE) { %>
      <option selected="selected" name="searchTextMethod" value="<%=SEARCH_TITLE%>"><t:Tr>otsikoista</t:Tr></option>
<% } else { %>
      <option name="searchTextMethod" value="<%=SEARCH_TITLE%>"><t:Tr>otsikoista</t:Tr></option>

<% } if(method == SEARCH_DESCRIPTION) { %>
      <option selected="selected" name="searchTextMethod" value="<%=SEARCH_DESCRIPTION%>"><t:Tr>kuvauksesta</t:Tr></option>
<% } else { %>
      <option name="searchTextMethod" value="<%=SEARCH_DESCRIPTION%>"><t:Tr>kuvauksesta</t:Tr></option>
<% } if(method == SEARCH_KEYWORD) { %>
      <option selected="selected" name="searchTextMethod" value="<%=SEARCH_KEYWORD%>"><t:Tr>avainsanoista</t:Tr></option>
<% } else { %>
      <option name="searchTextMethod" value="<%=SEARCH_KEYWORD%>"><t:Tr>avainsanoista</t:Tr></option>
<% } %>
    </select>
    <label for="searchText"><h4><t:Tr>sanalla</t:Tr></h4></label>
    <input id="searchText" type="text" name="searchText" size="30" value="<%=searchtext%>" />
  </p>
  <table>
    <tr>
      <td>
        <h4><t:Tr>Opinnytteen tyyppi</t:Tr></h4>
        <p><%-- all study types and ids --%>
          <select name="typeid" multiple size="8">
            <sql:statement id="stmt2" conn="conn2">
              <sql:query>
                select assignmenttype.typeid as type,
                       asstypetranslation.name as name
                from   assignmenttype, asstypetranslation
                where  assignmenttype.typeid = asstypetranslation.typeid
                and    asstypetranslation.languageid = <%=languageID%>
              </sql:query>
              <sql:resultSet id="rset2" loop="true">
                <sql:getColumn colName="type" to="strtype" scope="page" />
<%
   boolean selectedtype = false;
   int itype = 0;
              
   try{
     type = Integer.parseInt((String)pageContext.getAttribute("strtype"));
   }
   catch(Exception e) {}
            
   if(types != null) {
     for(int i=0;i<types.length;i++) {
       try{
         itype = Integer.parseInt(types[i]);
       }
       catch(Exception e) {}
       if(itype == type) selectedtype = true;   
     }
   }
   if(selectedtype == true) { %>
                <option selected="selected" name="type" value="<sql:getColumn colName="type" />" id="type<sql:getColumn colName="type" />"> 
                  <sql:getColumn colName="name" />
                </option>
<% } else {%>
                <option name="type" value="<sql:getColumn colName="type" />" id="type<sql:getColumn colName="type" />"> 
                  <sql:getColumn colName="name" />
                </option>
<% } %>
              </sql:resultSet>
            </sql:statement>
          </select>
        </p>
      </td>
<%--
      <td width="20">&nbsp;</td>
      <td>
        <h4><t:Tr>Opinnytteen laitos</t:Tr></h4>
        <p>
          <select multiple name="orgid" size="8">
            <sql:statement id="stmt2" conn="conn2">
              <sql:query>
                select organisation.organisationid as orgid,
                       organisationtranslation.name as name
                from   organisation, organisationtranslation
                where  organisation.organisationid = organisationtranslation.organisationid   
                and    organisationtranslation.languageid = <%=languageID%>
                and    organisation.organisationid >= 0
                and    organisation.organisationtypeid = 3
                order by organisationtranslation.name
              </sql:query>
              <sql:resultSet id="rset2" loop="true">
                <option name="org" value="<sql:getColumn colName="orgid" />" id="org<sql:getColumn colName="orgid" />">
                  <sql:getColumn colName="name" />
                </option>
              </sql:resultSet>
            </sql:statement>
          </select>
        </p>
      </td>
--%>
      <td width="20">&nbsp;</td>
      <td>
        <h4><t:Tr>Opinnytteen linja</t:Tr></h4>
        <p><%-- all study lines and ids --%>
          <select multiple name="lineid" size="8">
            <sql:statement id="stmt2" conn="conn2">
              <sql:query>
                select studyline.lineid as line,
                       studylinetranslation.name as name 
                from   studyline, studylinetranslation
                where  studyline.lineid = studylinetranslation.lineid
                and    studylinetranslation.languageid = <%=languageID%>
                and    studyline.lineid > 0
                order by studylinetranslation.name
              </sql:query>
              <sql:resultSet id="rset2" loop="true">
                <sql:getColumn colName="line" to="strline" scope="page" />
<%
   boolean selectedline = false;
   int iline = 0;

   try{
     line = Integer.parseInt((String)pageContext.getAttribute("strline"));
   }
   catch(Exception e) {}

   if(lines != null) {
     for(int i=0;i<lines.length;i++) {
       try{
         iline = Integer.parseInt(lines[i]);
       }
       catch(Exception e) {}
       if(iline == line) selectedline = true;
     }
   }
   if(selectedline == true) { %>
                <option selected="selected" name="line" value="<sql:getColumn colName="line" />" id="type<sql:getColumn colName="line" />"> 
<% }
   else {
%>
                <option name="line" value="<sql:getColumn colName="line" />" id="type<sql:getColumn colName="line" />"> 
<% } %>
                  <sql:getColumn colName="name" />
                </option>
              </sql:resultSet>
            </sql:statement>
          </select>
        </p>
      </td>
    </tr>
  </table>
  <table>
    <tr>
      <td><p>
        <label for="phase"><h4><t:Tr>Opinnytteen vaihe</t:Tr></h4></label>
      </p></td>
      <td><p>  
        <select name="phaseid">

<% if(phase == allAssignments) { %>
          <option selected="selected" name="phase" value="<%=allAssignments%>"><t:Tr>Kaikki vaiheet</t:Tr></option>
<% } else { %>
          <option name="phase" value="<%=allAssignments%>"><t:Tr>Kaikki vaiheet</t:Tr></option>
<% } if(phase == readyAssignmentID) { %>
          <option selected="selected" name="phase" value="<%=readyAssignmentID%>"><t:Tr>Hyvksytty</t:Tr></option>
<% } else { %>
          <option name="phase" value="<%=readyAssignmentID%>"><t:Tr>Hyvksytty</t:Tr></option>
<% } if(phase == incompleteAssignmentID) { %>
          <option selected="selected" name="phase" value="<%=incompleteAssignmentID%>"><t:Tr>Keskenerinen</t:Tr></option>
<% } else { %>
          <option name="phase" value="<%=incompleteAssignmentID%>"><t:Tr>Keskenerinen</t:Tr></option>
<% } if(phase == freeAssignment) { %>
          <option selected="selected" name="phase" value="<%=freeAssignment%>"><t:Tr>Vapaa aihe</t:Tr></option>
<% } else { %>
          <option name="phase" value="<%=freeAssignment%>"><t:Tr>Vapaa aihe</t:Tr></option>
<% } if(phase == cancelledAssignmentID) { %>
          <option selected="selected" name="phase" value="<%=cancelledAssignmentID%>"><t:Tr>Keskeytetty</t:Tr></option>
<% } else { %>
          <option name="phase" value="<%=cancelledAssignmentID%>"><t:Tr>Keskeytetty</t:Tr></option>
<% } %>

<%--          <option name="phase" value="<%=proposedAssignmentID%>"><t:Tr>Ehdotettu aihe</t:Tr></option> --%>
        </select>
      </p></td>
    </tr>
    <tr>
      <td><p>
        <label for="timebegin"><h4><t:Tr>Ajanjakso</t:Tr></h4></label>
      </p></td>
      <td><p> 
        <input type="text" name="timebegin" id="timebegin" size="12" value="<%=timebegin%>" />-
        <input type="text" name="timeend" id="timeend" size="12" value="<%=timeend%>" />
      </p></td>
    </tr>
    <tr>
      <td>
        <h4>Lisehto sukunimelle </h4>
      </td>
      <td>
        <input type="text" name="condition" size="30" />
      </td>
      <td><input type="submit" name="Submit" value="<t:Tr>Hae henkilt</t:Tr>" /></td>
    </tr>
    <tr><td></td><td>
<%
  String condition = "";
  if (con != null) {
    int i=0;
    int lkm=0;
  
    int beg = 0;
    int end = 0;  
    String [] conds = new String [100];

    while ( end < con.length() ) {
      end = con.indexOf(",", beg);
      if ( end < 0 ) end = con.length();
      if (beg >= end ) break;
      conds[i] = (con.substring(beg, end)).trim();
      beg = end+1;
      i++;
    }
    lkm = i;

    condition = "and ( lower(person.lastname) like lower(\'" +conds[0] +"%\') ";
    for(i=1;i < lkm;i++)
      condition += "or lower(person.lastname) like lower(\'" +conds[i] +"%\') ";
    condition += ")";
  }
%>

        <select name="personid" size="10">

<% if (condition != "") { %>
  <sql:statement id="stmt2" conn="conn2">
    <sql:query> 
       select person.lastname || ' ' || person.firstnames as name,
              person.personid as personid, person.account as account
       from   person
       where  person.deleted = false
       <%=condition %>
       order by person.lastname;
    </sql:query>
    <sql:resultSet id="rset2">
      <sql:getColumn colName="personid" to="strperson" scope="page" />
<%
   int iperson = -1;
   try{
     personi = Integer.parseInt((String)pageContext.getAttribute("strperson"));
     iperson = Integer.parseInt(request.getParameter("personid"));
   }
   catch(Exception e) {}

   if(personi == iperson) { %>
      <option selected="selected" value="<sql:getColumn colName="personid" />">
                     <sql:getColumn colName="name" />
                     '<sql:getColumn colName="account" />'
<% } else { %>
      <option value="<sql:getColumn colName="personid" />">
                     <sql:getColumn colName="name" />
                     '<sql:getColumn colName="account" />'
<% } %>
      </option>
    </sql:resultSet>
  </sql:statement>
<% } %>
        </select>   


    </td></tr>
    <tr>
      <td></td><td>
        <input type="submit" name="Submit" value="<t:Tr>Hae</t:Tr>" />
        <input type="reset" name="Reset" value="<t:Tr>Tyhjenn&auml;</t:Tr>" />
      </td>
    </tr>
  </table>
</form>

<%@ include file="/shared/pageEnd.inc" %>
